﻿' Module: Crypt.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson.

Option Explicit On
Option Strict Off ' Allows translation of numeric variables into strings. 
Imports System

Module Crypt
  Public Const cCrypt_version As Date = #4/4/2021# ' M/d/y.

  Sub Pw()
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    tLocals.Msg = "1"
    Call Encrypt_decrypt(tLocals.Msg)
    Call Encrypt_decrypt(tLocals.Msg)
  End Sub

  Sub Password_generator()
    ' Revised 2021.04.04.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.

    tLocals.Subr = "Password generator"
    uOp.Subr = tLocals.Subr
    tLocals.Status = udtuStandard_texts.Initiation
    Call Log_write(tLocals, 1)
    uOp.Subr = tLocals.Subr
    tLocals.Action = udtuStandard_texts.Main_start
    On Error GoTo Error_captured

Main:
    frmMain.tabControl_main.TabPages("tabPassword").Show()
    frmMain.tabControl_main.TabPages("tabPassword").Hide()

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Then
      Stop ' Indefinite.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed ' Reduce all error responses down to tLocals.Status = udtuStandard_texts.Failed.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case Else
            Call Error_display(tLocals)
        End Select
      End If
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 1)
    uOp.Subr = tLocals.Subr

    uOp.Subr = ""
  End Sub

  Sub Encrypt_decrypt(ByRef szData As String)
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Comments:   Performs XOr encryption, decryption on string data. Passing a
    '             string through the procedure once encrypts it, passing it
    '             through a second time decrypts it.
    '
    ' Arguments:  szData          [in|out] A string containing the data to
    '                             encrypt or decrypt.
    '
    ' Date        Developer       Action
    ' --------------------------------------------------------------------------
    ' 05/18/05    Rob Bovey       Created

    Const lKEY_VALUE As Long = 215

    Dim bytData() As Byte
    Dim lCount As Long

    ' bytData = szData
    ' bytData = CByte(szData)
    bytData = System.Text.Encoding.ASCII.GetBytes(szData)

    For lCount = LBound(bytData) To UBound(bytData)
      bytData(lCount) = bytData(lCount) Xor lKEY_VALUE
    Next lCount

    szData = bytData.ToString

  End Sub

  Sub Character_offset()
    ' Revised 2021.03.04.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Stop
    Dim i As Short
    Dim Estr As String = ""
    Dim Dstr As String = ""

    Dstr = "password"
    ' Encrypt string:
    For i = 1 To Len(Dstr)
      Estr = Estr & Chr(Asc(Mid(Dstr, i, 1)) + 30)
    Next i
    tLocals.Msg = Estr

    Dstr = ""
    ' Decrypt string:
    For i = 1 To Len(Estr)
      Dstr = Dstr & Chr(Asc(Mid(Estr, i, 1)) - 30)
    Next i
    tLocals.Msg = Dstr
  End Sub

  Sub Accredo_encrypt()
    ' Revised 2021.03.04.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim i As Short
    Dim Estr As String = ""
    Dim Dstr As String

    Dstr = "password"
    ' Encrypt string:
    For i = 1 To Len(Dstr)
      Estr = Estr & Chr(Asc(Mid(Dstr, i, 1)) + 30)
    Next i
    tLocals.Msg = Estr

    Dstr = ""
    ' Decrypt string:
    For i = 1 To Len(Estr)
      Dstr = Dstr & Chr(Asc(Mid(Estr, i, 1)) - 30)
    Next i
    tLocals.Msg = Dstr

    Dim oCust As Object
    oCust = CreateObject("Accredo.ARCustomerData")
    oCust.First()
    oCust.Edit()
  End Sub

  Sub Accredo_encrypt_2()
    ' Revised 2021.03.04.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim i As Short
    Dim Estr As String = ""
    Dim Dstr As String
    Dim oCust As Object

    Dstr = "Asheng Engineering Ltd"
    ' Encrypt string: 
    For i = 1 To Len(Dstr)
      Estr = Estr & Chr(Asc(Mid(Dstr, i, 1)) + 30)
    Next i

    tLocals.Msg = oCust.CustomerCode
    oCust.CustomerName = Estr
    oCust.Save()
    tLocals.Msg = oCust.CustomerName

    Dstr = ""
    Estr = oCust.CustomerName
    'Decrypt String
    For i = 1 To Len(Estr)
      Dstr = Dstr & Chr(Asc(Mid(Estr, i, 1)) - 30)
    Next i
    tLocals.Msg = Dstr

  End Sub

  Sub Test_2014_04_05()
    ' System.Web

  End Sub

End Module
