﻿' Module: Database_4D.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson. Separated 2017.08.27. Revised 2020.04.15.

Structure udtDatabase_4D
   ' Separated 2017.08.27. Revised 2020.04.15.
   Public Server As String
   Public Port As String
   Public Database As String ' Database name, such as on a server; or if in a file system, including a path.
   Public Table_name As String

   Public Conn_str As String
   Public Cmd_str As String
   ' Public Conn As 
   ' Public Cmd As 
   ' Public Data_adapter As 
   Public Dataset As DataSet

   Public Changed As Boolean
   Public Indent As String
   Public Rows_affected As Short
   Public Success As Boolean
   Public Upgrade_table As String
   Public Upgrade_counter As Integer
   Public Upgrade_in_progress As Boolean
   Public Use_password As Boolean
End Structure

Module Database_4D

   Private Sub Sql_conditioning_4D(ByRef tDb As udtDatabase_4D)
      ' Separated 2017.08.27. Revised 2018.04.25.
      ' Sql conditioning:  
      ' Modify the sql command string depending on the sqlserver being used. 
      ' References: 
      ' Having www.w3schools.com/sql/sql_having.asp. 
      ' Top    www.w3schools.com/sql/sql_top.asp. 
      Dim i As Integer
      If tDb.Cmd_str = "" Then
         Call Sound_alert()
         Stop
      Else
         Dim tStatement As String = UCase(Left(tDb.Cmd_str, InStr(tDb.Cmd_str, " ") - 1))
         ' Note: 4D SQL Server uses MySQL syntax.
         ' Queries are case sensitive.
         ' Likes ' doesn't like "
         ' Okay with either "Invices.type" or just "Type".
         ' Names with under-scores tend to have to be enclosed with [], and require other names to also be.
         Stop
         If InStr(1, tDb.Cmd_str, " TOP ") <> 0 Then
            Dim tStr As String
            tStr = Mid(tDb.Cmd_str, InStr(1, tDb.Cmd_str, " TOP "))
            tDb.Cmd_str = Replace(tDb.Cmd_str, tStr, "") ' Change to mid$. 
            i = Val(Trim(Replace(tDb.Cmd_str, " TOP ", "")))
            ' And the number afterwards.
            tDb.Cmd_str = tDb.Cmd_str & " LIMIT " ' And add the number.
            tDb.Cmd_str = tDb.Cmd_str & " " & Str(i)
         End If
      End If
   End Sub

End Module
