﻿' Module: Database_Adodb.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner.
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson.
' Adodb version.

' Internal references:
' Microsoft ActiveX Data Objects 6.0 Library.

' External reference:
' www.connectionstrings.com.

Structure udtDatabase_Adodb
  ' Separated 2021.03.14.
  Public Server As String
  Public Port As String
  Public Database As String ' Database name, such as on a server; or if in a file system, including a path.
  Public User_name As String
  Public Password As String
  Public Table_name As String

  Public Conn_str As String
  Public Cmd_str As String
  Public Command As ADODB.Command
  Public Connection As ADODB.Connection
  ' Public Data_adapter As 
  Public Dataset As DataSet
  Public Recordset As ADODB.Recordset

  Public Changed As Boolean
  Public Indent As String
  Public Rows_affected As Short
  Public Success As Boolean
  Public Upgrade_table As String
  Public Upgrade_counter As Integer
  Public Upgrade_in_progress As Boolean
  ' Public Use_password As Boolean
End Structure

Module Database_Adodb
  Public Const cDatabase_common_Adodb_version As Date = #3/24/2021# ' M/d/y.

  Sub Database_Adodb_test()
    ' Revised 2020.03.14.
    Dim tDb As udtDatabase_Adodb

    'With Acon
    '   .Provider = "Microsoft.ACE.OLEDB.12.0"
    '   .ConnectionString = "Data Source=" + myFileNameDir
    '   .Properties("Jet OLEDB:Database Password") = "synpass"
    '   .Open()
    'End With
    With tDb
      .Conn_str = "Microsoft.ACE.OLEDB.12.0;Data Source=" & .Database
      If .Password <> "" Then .Conn_str = .Conn_str & "Jet OLEDB:Database Password" = .Password
      .Connection.ConnectionString = .Conn_str
      ' .Connection.Properties("Jet OLEDB:Database Password") = "synpass"
    End With

    With tDb.Recordset
      .CursorLocation = ADODB.CursorLocationEnum.adUseClient
      .CursorType = ADODB.CursorTypeEnum.adOpenDynamic
      .LockType = ADODB.LockTypeEnum.adLockOptimistic
      '.ActiveConnection = Acon
      .ActiveConnection = tDb.Connection
      .Source = "Select Distinct [Term - Phases] from Sheet1"
      .Open()
    End With

    On Error Resume Next

    If IsDBNull(tDb.Recordset.Fields("Start_Date")) Then
      MsgBox("Not found.")
    Else
      MsgBox("Found.")
    End If
    On Error GoTo 0

    tDb.Recordset.Close()
    tDb.Connection.Close()

    uOp.Subr = ""
  End Sub

  Public Sub Test_02(Optional sPath As String = "")
    ' Revised 2021.03.24.
    ' http://checktechno.blogspot.com/2013/04/using-ado-and-recordset-in-vbnet.html.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tIndex_1 As Integer
    ' Dim aString As String
    ' Dim oConnection As ADODB.Connection
    ' Dim oCommand As ADODB.Command
    ' Dim oRecordset As ADODB.Recordset
    Dim tDb As udtDatabase_Adodb
    On Error GoTo Error_captured

    tDb.Connection = New ADODB.Connection
    With tDb.Connection
      .Provider = "Microsoft.Jet.OLEDB.4.0;"
      .ConnectionTimeout = 30
      .IsolationLevel = ADODB.IsolationLevelEnum.adXactIsolated
      .Mode = ADODB.ConnectModeEnum.adModeReadWrite
      .Open("Data Source=" & sPath & " ;User Id=Admin; Password=")
    End With

    tDb.Recordset = New ADODB.Recordset
    With tDb.Recordset
      .CursorLocation = ADODB.CursorLocationEnum.adUseClient
      .LockType = ADODB.LockTypeEnum.adLockBatchOptimistic
      .CursorType = ADODB.CursorTypeEnum.adOpenStatic
      .CacheSize = 30
      .Source = "SELECT * From dictionary"
      .ActiveConnection = tDb.Connection
      '    Set .ActiveCommand = oCommand
      ' .Open, , , , adCmdText
      .Open(, , , , 1)
    End With

    tDb.Recordset.MoveFirst()
    tIndex_1 = 0
    Do
      tLocals.Msg = ""
      For tIndex_1 = 0 To tDb.Recordset.Fields.Count - 1 Step 1
        tLocals.Msg = tLocals.Msg & tDb.Recordset.Fields(tIndex_1).Value & vbCrLf
      Next tIndex_1
      MsgBox(tLocals.Msg)
      tDb.Recordset.MoveNext()
    Loop Until tDb.Recordset.EOF = True

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Or uApp.Terminating <> 0 Then
      Stop ' Indefinite.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      uError.Count = uError.Count + 1
      uError.Last_error_sub = uOp.Subr
      If uError.Count > udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case 0
            tLocals.Error_count = tLocals.Error_count - 1
            Call Error_clear(tLocals)
            Resume
            Resume Next
          Case Else
            Stop ' Permanent.
            Call Error_display(tLocals)
        End Select
      End If
    End If

    uOp.Subr = ""
  End Sub

  Private Sub Load_sql_Mdb(ByVal sPath As String, sTable As String)
    ' Revised 2021.03.24.
    ' http://checktechno.blogspot.com/2013/04/using-ado-and-recordset-in-vbnet.html.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim oOleDbConnection As System.Data.OleDb.OleDbConnection
    Dim oOleDbCommand As OleDb.OleDbCommand
    Dim oOleDbDataReader As OleDb.OleDbDataReader
    Dim sqlText As String
    Dim index1 As Integer

    Try
      index1 = 0
      'ConnectionString
      oOleDbConnection = New System.Data.OleDb.OleDbConnection()
      oOleDbConnection.ConnectionString = "Provider =Microsoft.ACE.OLEDB.12.0; Data Source =" & sPath & "; Persist Security Info =False;"
      oOleDbConnection.Open() 'ATTENTION, FONTIONNE QUE POUR X86 ; ATTENTION ONLY FOR x86

      If oOleDbConnection.State = ConnectionState.Open Then
        sqlText = "select * from " & sTable
        oOleDbCommand = New System.Data.OleDb.OleDbCommand(sqlText, oOleDbConnection)
        oOleDbDataReader = oOleDbCommand.ExecuteReader()
        'oOleDbDataReader.FieldCount
        Do While oOleDbDataReader.Read()
          'oOleDbDataReader.FieldCount
          Dim str(oOleDbDataReader.FieldCount - 1) As String
          For index1 = 0 To oOleDbDataReader.FieldCount - 1 Step 1
            str(index1) = oOleDbDataReader.GetValue(index1)
          Next index1

          ' Me.DataGridView1.Rows.Add(str)
          'ComboBox1.Items.Insert(index1, oOleDbDataReader.GetValue(0))
          index1 = index1 + 1
        Loop

      End If

      oOleDbDataReader = Nothing
      oOleDbCommand = Nothing
    Catch ex As Exception
      Stop ' Permanent.
      tLocals.Error_description = ex.Message
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_process
    End Try
  End Sub

  Sub List_Access_tables_Adodb_does_not_work(strDBPath)
    ' Imported from https://docs.microsoft.com/en-us/previous-versions/office/developer/office2000/aa165325(v=office.10)?redirectedfrom=MSDN, 2019.12.28.
    ' Revised 2021.03.04.
    ' Doesn't seem to work.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim cnnDB As ADODB.Connection
    Dim rstList As ADODB.Recordset
    cnnDB = New ADODB.Connection

    ' Open the connection:
    With cnnDB
      .Provider = "Microsoft.Jet.OLEDB.4.0"
      .Open(strDBPath)
    End With

    ' Open the tables schema rowset:
    rstList = cnnDB.OpenSchema(ADODB.SchemaEnum.adSchemaTables)

    ' Loop through the results and print the names and types in the Immediate pane:
    With rstList
      Do While Not .EOF
        If .Fields("TABLE_TYPE").ToString <> "VIEW" Then
          Debug.Print(.Fields("TABLE_NAME").ToString)
          Debug.Print(.Fields("TABLE_TYPE").ToString)

          tLocals.Msg = .Fields("TABLE_NAME").ToString
          tLocals.Msg = .Fields("TABLE_TYPE").ToString

        End If
        .MoveNext()
      Loop
    End With
    cnnDB.Close()
    cnnDB = Nothing
  End Sub

End Module
