﻿' Module: Database_MySql.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson. Separated 2021.01.24.

' www.mysql.com/products/connector.

Structure udtDatabase_MySql
  ' Separated 2017.08.27. Revised 2020.04.15.
  Public Server As String
  Public Port As String
  Public Database As String ' Database name, such as on a server; or if in a file system, including a path.
  Public Table_name As String

  Public Conn_str As String
  Public Cmd_str As String
  ' Public Conn As 
  ' Public Cmd As 
  ' Public Data_adapter As 
  Public Dataset As DataSet

  Public Changed As Boolean
  Public Indent As String
  Public Rows_affected As Short
  Public Success As Boolean
  Public Upgrade_table As String
  Public Upgrade_counter As Integer
  Public Upgrade_in_progress As Boolean
  Public Use_password As Boolean
End Structure

Module Database_MySql
  Public Const cDatabase_common_MySql_version As Date = #3/3/2021# ' M/d/y.

  Sub Database_instantiate_MySql(ByRef tDb As udtDatabase_MySql)
    ' Separated 2021.03.03.
    ' MySql requires http://dev.mysql.com/downloads/connector/odbc/5.1.html.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    tLocals.Subr = "Database instantiate MySql"

    With tDb
      .Conn_str = "Driver={MySQL ODBC 5.1 Driver}; "
      .Conn_str = .Conn_str & "Host=" & .Server & "; "
      If .Port <> "" Then .Conn_str = .Conn_str & "Port=" & .Port & "; "
      .Conn_str = .Conn_str & "Database=" & .Database
      ' If .Username <> "" Then .Conn_str = .Conn_str & "; User Id=" & .Username
      ' If .Password <> "" Then .Conn_str = .Conn_str & "; Password=" & .Password
      If .Table_name <> "" Then .Conn_str = .Conn_str & "; Initial catalog=" & .Table_name
      '            .Conn_str = .Conn_str & "; Connection timeout=x"
      '            .Conn_str = .Conn_str & "; Connection reset=true"
      '            .Conn_str = .Conn_str & "; Connection lifetime=600"
      '            .Conn_str = .Conn_str & "; Pooling=true"
      '            .Conn_str = .Conn_str & "; Max pool size=50"
      '            .Conn_str = .Conn_str & "; Min pool size=2"
      '            .Conn_str = .Conn_str & "; Enlist=true"
      '            .Conn_str = .Conn_str & "; Network library=dbmssocn"

      ' Integrated Security or Trusted_Connection. Default: false. 
      ' When false, User Id and Password are specified in the connection. When true, the current Windows account credentials are used for authentication.
      ' Recognised values are true, false, yes, no, and sspi (strongly recommended), which is equivalent to true.
      ' If User Id and Password are specified and Integrated Security is set to true, the User Id and Password will be ignored and Integrated Security will be used.
      ' SqlCredential is a more secure way to specify credentials for a connection that uses SQL server authentication (Integrated Security=false).

      ' If ulis.Dev Then .Conn_str = .Conn_str & ";Option=4"
      .Conn_str = .Conn_str & "; Character Set=utf8"
      Call Error_write_micron(.Conn_str)
      tLocals.Action = "Instantiate connection"
      ' .Conn = New SqlClient.SqlConnection
      tLocals.Action = "Instantiate command"
      ' .Cmd = New SqlClient.SqlCommand
      tLocals.Action = "Set command connection"
      ' .Conn.ConnectionString = .Conn_str
      ' .Cmd.Connection = .Conn_sql
      ' .Cmd.CommandType = CommandType.Text

    End With
  End Sub

  Private Sub Sql_conditioning_MySql(ByRef tDb As udtDatabase_MySql)
    ' Separated 2017.08.27. Revised 2018.04.09.
    ' Sql conditioning:  
    ' Modify the sql command string depending on the sqlserver being used. 
    ' References: 
    ' Having www.w3schools.com/sql/sql_having.asp. 
    ' Top    www.w3schools.com/sql/sql_top.asp. 
    If tDb.Cmd_str = "" Then
      Call Sound_alert()
      Stop
    Else
      Dim tStatement As String = UCase(Left(tDb.Cmd_str, InStr(tDb.Cmd_str, " ") - 1))
      ' To restrict the number of rows returned, use: 
      ' Select column_name(s)
      ' FROM table_name
      ' LIMIT number
      tDb.Cmd_str = Replace(tDb.Cmd_str, "ALTER TABLE", "MODIFY COLUMN")
      tDb.Cmd_str = Replace(tDb.Cmd_str, "Autoincrement", "Auto_increment")
    End If
  End Sub

End Module
