﻿' Module: Database_Odbc.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson. Separated 2020.04.15.
' Odbc version.

' Internal reference:

' External reference:
' www.connectionstrings.com.

Structure udtDatabase_odbc
   ' Revised 2020.04.15.
   Public Database As String ' Database name, such as on a server; or if in a file system, including a path.
   Public Table_name As String

   Public Conn_str As String
   Public Cmd_str As String
   Public Dsn As Boolean ' To do: ?
   Public Conn As Odbc.OdbcConnection
   Public Cmd As Odbc.OdbcCommand
   Public Data_adapter As Odbc.OdbcDataAdapter
   Public Dataset As DataSet

   Public Changed As Boolean
   Public Indent As String
   Public Rows_affected As Short
   Public Success As Boolean
   Public Upgrade_table As String
   Public Upgrade_counter As Integer
   Public Upgrade_in_progress As Boolean
   Public Use_password As Boolean
End Structure

Module Database_Odbc

   Private Sub Sql_conditioning(ByRef tDb As udtDatabase_odbc)
      ' Separated 2017.08.27. Revised 2018.04.09.
      ' Sql conditioning:  
      ' Modify the sql command string depending on the sqlserver being used. 
      ' References: 
      ' Having www.w3schools.com/sql/sql_having.asp. 
      ' Top    www.w3schools.com/sql/sql_top.asp. 
      If tDb.Cmd_str = "" Then
         Call Sound_alert()
         Stop
      Else
         Dim tStatement As String = UCase(Left(tDb.Cmd_str, InStr(tDb.Cmd_str, " ") - 1))
         Stop
      End If
   End Sub

End Module
