' Module: Declarations.
' Copyright  LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson.

' Application specific global variables.

Option Explicit On

Public Module Declarations
  Public Const cDeclarations_version As Date = #3/14/2021# ' M/d/y.

  ' General global variables:
  Structure udtOp_uncommon
    Public Kernel_distributed As Boolean ' 2020.06.27.
  End Structure
  Public gOp As udtOp_uncommon ' Was gOp_uncommon.

  ' Internal environment:

  Structure udtgApplication_subroutine_names
    ' Started 2019.11.08. Revised 2021.02.15.

    ' Module: Kernel:
    ' Region Shared optional:
    Const Sentence_case_fn As String = "Sentence case fn"
    Const Kernel_distribute As String = "Kernel distribute"

    ' Module: Database:
    ' Region "Database diagnostic local":
    Const Test_sql_date_format As String = "Test sql date format"
    Const Preferences_common_write As String = "Preferences common write"
    ' Region "Unshared, this application only":

    ' Module: General:
    Const Credit_card_number_check As String = "Credit card number check"
    Const Luhn_check As String = "Luhn check"
    Const Nested_if_01 As String = "Nested if 01"
    Const Nested_if_02 As String = "Nested if 02"

    ' Form: frmMain:
    ' Region, "Form common sub-routines":
    ' Region "Form element events":

    ' Region, "Tabs application specific":

    ' Region "Tab Music":
    Const Music_renamer As String = "Music renamer"
    Const dgvMusic_naming_clear As String = "dgvMusic_naming clear"
  End Structure

  Structure udtgStandard_texts
    ' Added 2018.10.28. Revised 2020.11.06.
    Public Initialised As Boolean

    Sub Initialise()
      ' Internalised 2020.11.06.
      If Not Initialised Then
        ' Automatically_added = "Automatically added by " & uApp.Short_name & "."

        Initialised = True
      End If
    End Sub

  End Structure
  ' Public gStandard_texts As udtgStandard_texts

  ' Database uncommon (application specific):
  Public gMemory As udtDatabase_oledb ' Was uMemory_uncommon.
  ' For the same structure, in a different location, such as c:\Programme Files\LivingInfo Systems\(uApp.Name)\(uApp.Name).mdb.

  Public Enum udtDialogue_combobox_items
    ' Created 2016.06.11. Revised 2016.06.12.
    Null
    a
    b
  End Enum

  ' Memory:
  ' Define all other table definition variables:

  Structure udtTables_local
    ' Separated 2019.01.09. Revised 2020.12.30.
    Const International As String = "International" ' 2020.12.30.
    Const Preference_common As String = "Preference_common"

    Public Initialised As Boolean

    Sub Initialise()
      ' Internalised 2020.11.01. Revised 2020.11.05.
      If Not Initialised Then
        ' Bank_account = uApp.Short_name & "_" & "Bank_account"

        Initialised = True
      End If
    End Sub

  End Structure
  Public gTables As udtTables_local

  ' Plus other application specific datasets:

  Structure udtCon_help_uncommon
  End Structure
  Public gCon_help As udtCon_help_uncommon

  ' End internal environment.

  ' External environment:

  Structure udtUser_uncommon
    ' Revised 2017.09.11.
  End Structure
  Public gUser As udtUser_uncommon

  Structure udtMusic
    ' Written 2018.04.28. Revised 2019.10.14.
    Dim Path_start As String
    Dim File_count As Short ' 2018.08.11.

    Dim File_original_full_name As String ' 2019.01.01.
    Dim File_new_full_name As String ' 2019.01.01.

    Dim File_original_name As String ' 2019.04.16.
    Dim File_new_name As String ' 2019.04.16.
    Dim File_extension As String ' 2019.04.16.

    Dim Track_artist As String ' 2018.12.01:
    Dim Track_album As String ' 2018.12.01:
    Dim Track_comment As String ' 2019.01.05.
    Dim Track_genre As String ' 2019.01.05.
    Dim Track_number As String  ' 2018.12.01, revised 2019.10.14.
    Dim Track_title As String ' 2018.12.01:
    Dim Track_year As String ' 2019.01.05.
    Dim Message As String ' 2018.12.01:
  End Structure
  Public gMusic As udtMusic

  ' End external environment.

End Module
