﻿' Module: Email_smtp.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner.
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson.

Option Explicit On
Option Strict Off ' Allows translation of numeric variables into strings. 
' Imports System.Net.Mail

Module Email_Smtp
  Public Const cEmail_smtp_version As Date = #4/22/2021# ' M/d/y.

  Sub Email_smtp_test()
    ' Revised 2021.04.04.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    uOp.Subr = udtApplication_subroutine_names.Email_smtp_test
    uOp.Called_from = uOp.Subr
    uApp.Email_udt.Smtp_working = True

    With uApp.Email_udt
      .Recipient_address = "myk_hodgson@hotmail.com"
      .Subject = "Test subject."
      .Body = "Test body."
      .Attachment_loc = Nothing
    End With
    ' If Not Email_smtp_send_fn(uApp.Email_udt, True) Then
    If Not Email_smtp_send_fn() Then
      Stop ' Permanent.
      '        tLocals.Error_count    =        tLocals.Error_count    + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = udtApplication_subroutine_names.Email_smtp_test

    uOp.Called_from = ""
    uOp.Subr = ""
  End Sub

  Function Email_smtp_send_fn() As Boolean
    ' Revised 2021.04.22.
    Dim tLocals As udtLocals = Nothing
    Dim tError As udtError

    If uMachine.Development_machine And uApp.App_name <> udtApplication.App_LivingInfo_Systems_Server And uOp.Called_from <> "Email test" Then
      uOp.Success = True
      Email_smtp_send_fn = True
      GoTo Ender_full
    End If
    If Not uApp.Email_udt.Smtp_working Then
      tLocals.Success = udtBoolean_extended.True_
      GoTo Ender_full
    End If
    tLocals.Subr = udtApplication_subroutine_names.Email_smtp_send_fn
    tLocals.Status = udtuStandard_texts.Initiation
    tError.Description = Nothing
    tError.Message = Nothing
    Email_smtp_send_fn = False

    Call Log_write(tLocals, 0)
    uOp.Subr = tLocals.Subr
    tLocals.Status = ""

Main:
    tLocals.Action = "Test email structure"
    With uApp.Email_udt
      If .From_address <> "" Then tLocals.Continue_ = True
      If .From_password = "" Then tLocals.Continue_ = False
      If .Smtp_server = "" Then tLocals.Continue_ = False
      If .Recipient_address = "" Then tLocals.Continue_ = False
      If .Subject = "" Then tLocals.Continue_ = False
    End With
    If Not tLocals.Continue_ Then GoTo Error_process

    tLocals.Action = "Call Prepare Email_message"
    Call uApp.Email_udt.Prepare_Email_message()
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    With uApp.Email_udt.Email_message
      tLocals.Action = "Form smtp structure"
      With uApp.Email_udt.Smtp_client
        Dim tCounter As Integer = 0
        Do
          tLocals.Action = "Send the message"
          Try
            .Send(uApp.Email_udt.Email_message)
            Email_smtp_send_fn = True
          Catch ex As Exception
            tLocals.Error_description = ex.Message
            If Not IsNothing(ex.InnerException) Then tError.Description = ex.InnerException.ToString

            If uOp.Called_from <> "Preferences load" Then
              Call Internet_connection_check(uApp.Email_udt.Smtp_server)
              uOp.Subr = tLocals.Subr
            End If
          End Try
        Loop Until Email_smtp_send_fn Or tCounter = 3

      End With
    End With
    If Email_smtp_send_fn Then
      tLocals.Success = udtBoolean_extended.True_
    Else
      tError.Message = "Failure sending email. Please check that this computer is connected to the internet."
      Call frmMain.Statuslabel1_set(tError.Message, True)
    End If
    uApp.Email_udt.Smtp_working = Email_smtp_send_fn

Error_process:
    If tLocals.Error_count <> 0 Or uError.Number <> 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    If Not Email_smtp_send_fn Then
      Stop ' Indefinite.
      uApp.Email_udt.Smtp_working = False
    End If

    If tLocals.Action <> udtuStandard_texts.Cancelled Then tLocals.Action = udtuStandard_texts.Completion
    If uOp.Subr = tLocals.Subr Then
      If Email_smtp_send_fn Then tLocals.Success = udtBoolean_extended.True_
      Call Log_write(tLocals, 0)
    End If

    Call frmMain.Statuslabel1_set("", True)
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False : Call frmMain.Statuslabel1_failed(tLocals.Subr)
  End Function

End Module
