﻿' Module: Ftp.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson, 2017.10.05.

Option Explicit On
Imports Microsoft.VisualBasic.Devices

Module Ftp_
   Public Const cFtp_version As Date = #11/11/2018# ' M/d/y.

   Sub Ftp_download(ByVal tFile As String, ByVal tDestination As String)
      ' Revised 2018.11.11.
      Dim tUser_name As String
      Dim tPw As String

      uCrypt.Test = False
      If tUser_name = "" Then tUser_name = Encrypt_it_fn("13BF220B50EF329A", False)
      If tPw = "" Then tPw = Encrypt_it_fn("4984031B4EC66A91", False)
      Call Ftp_download_2(tFile, tDestination, tUser_name, tPw)

   End Sub

   Sub Ftp_download_2(ByVal tFile As String, ByVal tDestination As String, tUser_name As String, tPw As String)
      ' Revised 2018.11.11.
      Dim tNum_err As Integer
      On Error GoTo Error_handler

      If FileSystem.Dir(tDestination, FileAttribute.Normal) = "" Then
         My.Computer.Network.DownloadFile(tFile, tDestination, tUser_name, tPw, True, 100, False, FileIO.UICancelOption.DoNothing)
         uOp.Success = True
      Else
         Stop ' Indefinite.
      End If

Error_handler:
      uError.Number = Err.Number
      uError.Description = Err.Description
      uError.Source = Err.Source
      If Err.Number <> 0 Then
         Stop ' Indefinite.
         tNum_err = tNum_err + 1
         uOp.Success = False
         uError.Error_count = uError.Error_count + 1
         If uError.Error_count > uError.Infinite_loop_limit Or tNum_err > uError.Infinite_loop_limit Then Call Infinite_loop(tNum_err)
         If uApp.Terminating = 0 Then
            Select Case Err.Number
               Case 5 ' Access to the path 'C:\Program Files (x86)\LivingInfo Systems' is denied.
                  Stop
               Case 57 ' Could not complete operation since a file already exists in this path.
                  Stop ' Indefinite.
               Case Else
                  Stop ' Permanent.
                  Call Error_display()
            End Select
         End If
      End If
      uOp.Subr = ""
   End Sub

End Module
