﻿' Module: Ftp common.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson, 2017.10.05.

Option Explicit On
Imports Microsoft.VisualBasic.Devices

Module Ftp_common
  Public Const cFtp_common_version As Date = #4/8/2021# ' M/d/y.

  Sub Ftp_download_prep(ByRef tFile As udtFile)
    ' Revised 2020.04.08.
    uOp.Subr = udtApplication_subroutine_names.Ftp_download_prep

    uCrypt.Test = False
    If uCrypt.User_name = "" Then uCrypt.User_name = Encrypt_it_fn("13BF220B50EF329A", False)
    If uCrypt.Password = "" Then uCrypt.Password = Encrypt_it_fn("4984031B4EC66A91", False)
    uOp.Subr = udtApplication_subroutine_names.Ftp_download_prep

    If InStr(tFile.Copy_source, "ftp") = 0 Then
      tFile.Copy_source = "ftp://ftp.livinginfosystems.com/public_html/download/resources/" & tFile.Copy_source
    End If
    Call Ftp_download(tFile, uCrypt.User_name, uCrypt.Password)
    uOp.Subr = udtApplication_subroutine_names.Ftp_download_prep

    uOp.Subr = ""
  End Sub

  Sub Ftp_download(ByRef tFile As udtFile, tUser_name As String, tPw As String)
    ' Revised 2021.04.08.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tOver_write As Boolean = False
    On Error GoTo Error_captured
    tLocals.Subr = udtApplication_subroutine_names.Ftp_download

    If FileSystem.Dir(tFile.Copy_destination, FileAttribute.Normal) = "" Then
      My.Computer.Network.DownloadFile(tFile.Copy_source, tFile.Copy_destination, tUser_name, tPw, True, 100, tOver_write, FileIO.UICancelOption.DoNothing)
      tLocals.Success = udtBoolean_extended.True_
    Else
      Stop ' Indefinite.
      tLocals.Success = udtBoolean_extended.False_
    End If

Check:
    tLocals.Action = "Check it"
    If FileSystem.Dir(tFile.Copy_destination, FileAttribute.Normal) = "" Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
      uError.Count = uError.Count - 1
    End If
    tLocals.Action = udtuStandard_texts.Main_start

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Then
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      uError.Count = uError.Count + 1
      uError.Last_error_sub = tLocals.Subr
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case 5
            If InStr(Err.Description, "Access to the path") > 0 And InStr(Err.Description, "denied") > 0 Then
              ' Access to the path 'C:\Program Files (x86)\LivingInfo Systems' is denied.
              ' An exception occurred during a WebClient request.
              Stop ' Indefinite.
            ElseIf InStr(Err.Description, "The remote server returned an error") > 0 Then
              ' The remote server returned an error: (425) Can't open data connection.
              ' The remote server returned an error: (550) File unavailable (e.g., file not found, no access).
              ' The remote server returned an error: (500) Syntax error, command unrecognised."
              Call Error_clear(tLocals)
              tOver_write = True
              ' Resume Check
              Resume
            ElseIf Err.Description = "An exception occurred during a WebClient request." Then
              Stop ' Indefinite.
            Else
              Stop ' Permanent.
              Call Error_display(tLocals)
            End If
          Case 57 ' Could not complete operation since a file already exists in this path.
            Stop ' Indefinite.
          Case Else
            Stop ' Permanent.
            Call Error_display(tLocals)
        End Select
      End If
    End If

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

End Module
