﻿' Module: Web_common.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson.

Option Explicit On
Imports System.Net
Imports System.Net.Sockets
' Imports SHDocVw ' Reference: Microsoft Internet Controls.

Module Web_common
  Public Const cWeb_common_version As Date = #5/2/2021# ' M/d/y.
  Public mInternet As udtInternet

  Public Sub Internet_connection_check(Optional ByVal tUrl As String = Nothing)
    ' Revised 2021.03.24.
    Dim tLocals As udtLocals = Nothing
    Dim tLocal_url As String = ""
    Dim tInternet_connection As Boolean = False

    If uMachine.Development_machine Or uMachine.Testing_machine Then
      tLocals.Subr = udtApplication_subroutine_names.Internet_connection_check
      uOp.Subr = tLocals.Subr
      ' On Error GoTo Error_handler

      tLocals.Action = udtuStandard_texts.Main_start
      uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 1
      Call frmMain.Statuslabel1_set("Checking internet connection...")

      '      tLocals.Action  = "Method 1, using WebClient
      '' Takes a long time.
      'Try
      '   Using tClient = New WebClient()
      '      Using tStream = tClient.OpenRead("http://www.google.com")
      '         tInternet_connection = True
      '      End Using
      '   End Using
      'Catch
      ' Stop ' Permanent.
      ' tLocals.Error_description = ex.Message
      ' tLocals.Error_count = tLocals.Error_count + 1
      ' tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_process

      '   tInternet_connection = False
      'End Try

      '       tLocals.Action  = "Method 2, using MSXML2.XMLHTTP60
      'tInternet_connection = False ' For testing.
      '' Requires Microsoft XML, v6.0:"
      'Dim tRequest As MSXML2.XMLHTTP60
      'tRequest = New MSXML2.XMLHTTP60
      'tRequest.Open("GET", "http://www.google.com", False)
      'tRequest.Open("Post", "http://www.google.com", False)
      'tRequest.Send() ' The system cannot locate the resource specified.
      'If uError.Message = "" Then
      '    tLocals.Msg  = tRequest.Status
      '    tLocals.Msg  = tRequest.ResponseText
      '   ' tRequest.body.innerHTML = tRequest.ResponseText
      'Else
      '        tLocals.Error_count    =        tLocals.Error_count    + 1
      '   If uOp.Called_from = uOp.Subr Then
      '      Stop
      '   Else
      '      Stop
      '   End If
      '   Call Speak_it(uOp.Subr, uError.Message, 2)
      'End If

      tLocals.Action = "Method 3, using My.Computer.Network.Ping"
      If My.Computer.Network.IsAvailable Then
        tLocal_url = "www.google.com"
        If tUrl <> "" Then tLocal_url = tUrl
        Try
          tInternet_connection = My.Computer.Network.Ping(tLocal_url, 500)
        Catch ex1 As Exception
          uError.Description = ex1.Message
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Status = udtuStandard_texts.Failed
          tLocals.Success = udtBoolean_extended.False_
        End Try
        If Not tInternet_connection Then
          tLocal_url = "www.google.co.nz"
          If tUrl <> "" Then tLocal_url = tUrl
          Try
            tInternet_connection = My.Computer.Network.Ping(tLocal_url, 500)
          Catch ex2 As Exception
            uError.Description = ex2.Message
            Stop ' Permanent.
            tLocals.Error_count = tLocals.Error_count + 1
            tLocals.Status = udtuStandard_texts.Failed
            tLocals.Success = udtBoolean_extended.False_
          End Try
          If Not tInternet_connection Then
            tLocal_url = "www.livinginfosystems.com"
            If tUrl <> "" Then tLocal_url = tUrl
            Try
              tInternet_connection = My.Computer.Network.Ping(tLocal_url, 500)
            Catch ex3 As Exception
              uError.Description = ex3.Message
              Stop ' Permanent.
              tLocals.Error_count = tLocals.Error_count + 1
              tLocals.Status = udtuStandard_texts.Failed
              tLocals.Success = udtBoolean_extended.False_
            End Try
          End If
        End If
      Else ' If My.Computer.Network.IsAvailable Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
      End If ' If My.Computer.Network.IsAvailable Then
      'If Not Internet_connection Then Call Speak_it(uOp.Subr, "I cannot detect the internet.", 2)
      'uOp.Subr = "Internet connection check fn"
    Else
      tInternet_connection = True
    End If

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case 0
            ' Resume
          Case 5
            Stop ' Permanent.
            Select Case uError.Description
              Case "An exception occurred during a Ping request."
                ' Resume Next

              Case "The operation has timed out."
                ' Resume Next

              Case Else
                Stop ' Permanent.
                Call Error_display(tLocals)
            End Select
          Case Else
            Stop ' Permanent.
            Call Error_display(tLocals)
        End Select
      End If
    End If

Ender_full:
    If Not tInternet_connection Then Call Speak_it(tLocals.Subr, "I cannot detect the internet.", 2)
    uOp.Subr = tLocals.Subr

    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Action = "" And tLocals.Status <> udtuStandard_texts.Cancelled And tLocals.Status <> udtuStandard_texts.Failed Then
      tLocals.Action = tLocals.Status
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If
    Call Log_write(tLocals, 0)

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Function Get_default_browser_fn() As String
    ' A basic walk through of the function for those interested:
    ' Firstly, the function opens the registry key @ HKEY_CURRENT_USER\Sofware\Clients\StartmenuInternet
    ' The default value at this registry key is the executable name of your default browser (IEXPLORE9.EXE, FIREFOX.EXE, Chrome.exe... etc), these names aren't overly helpful as it's not the actual browser's "name". However, they do help out, so we will store this in the "baseName" variable for later use.
    ' The next step is to build our next registry location. 
    ' Due to the difference in registry keys on a 32 bit versus 36 bit system the ternary "IIf" operator was used here to apply the "Wow6432Node" if necessary (64 bit systems). 
    ' The StartMenuInternet key contains multiple sub-keys, one for each browser you have installed, coincidentally the sub-key names correspond to the value stored in baseName, so we use that variable to open the default browser's folder.
    ' This is the moneymaker, the default value at this key is the actual name of the browser, so we just assign retVal the default key value and call it quits.
    ' Return retVal <- self explanatory, return the value we found.
    ' (Not yet tested on a 32 bit system so if someone finds an error please point it out).
    ' Revised MJBH 2018.11.11.
    Dim tRet_val As String = String.Empty
    Using tBase_key As Microsoft.Win32.RegistryKey = My.Computer.Registry.CurrentUser.OpenSubKey("Software\Clients\StartmenuInternet")
      Dim tBase_name As String = tBase_key.GetValue("").ToString
      ' Dim tSub_key As String = "SOFTWARE\" & IIf(Environment.GetEnvironmentVariable("PROCESSOR_ARCHITECTURE") = "AMD64", "Wow6432Node\", "") & "Clients\StartMenuInternet\" & tBase_name
      Dim tSub_key As String = ""
      If Environment.GetEnvironmentVariable("PROCESSOR_ARCHITECTURE") = "AMD64" Then
        tSub_key = "Wow6432Node\"
      End If
      tSub_key = "SOFTWARE\" & tSub_key & "Clients\StartMenuInternet\" & tBase_name
      Using browserKey As Microsoft.Win32.RegistryKey = My.Computer.Registry.LocalMachine.OpenSubKey(tSub_key)
        tRet_val = browserKey.GetValue("").ToString
      End Using
    End Using
    Return tRet_val
  End Function

  ' Sub Instantiate_IE(ByVal tUrl As String, ByRef tIE As InternetExplorer) ' Moved to module Web.

  Function Url_validate_fn(ByVal tUrl As String, ByVal tText As Boolean) As Boolean
    ' Revised 2021.03.03.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    tLocals.Subr = udtApplication_subroutine_names.Url_validate_fn
    tLocals.Action = udtuStandard_texts.Main_start

    Url_validate_fn = True

    If Left$(tUrl, 7) = "http://" Or Left$(tUrl, 8) = "https://" Or Left$(tUrl, 4) = "www." Or Left$(tUrl, 5) = "www2." Then
    Else
      Url_validate_fn = False
    End If
    If InStr(1, tUrl, "\") <> 0 Then Url_validate_fn = False
    If InStr(1, tUrl, "@") <> 0 Then Url_validate_fn = False
    If InStr(1, tUrl, ".") = 0 Then Url_validate_fn = False

    If tText And Not Url_validate_fn Then
      uError.Message = "Invalid web address (url)." & vbCr & vbCr & "It must begin with either 'http' or 'www'."
      uDialogue.Dialogue_result = Msgbox_LIS(uError.Message, udtAlert_types.Critical, udtDialogue_types.Okay_only, frmMain.tabControl_main, udtDialogue_position.Top_right)
      Stop ' To do, to develop; then what?
    End If

    uDialogue.Dialogue_result = Nothing
    uOp.Subr = ""
  End Function

  Function Email_validate_fn(ByVal tEmail As String) As Boolean
    ' Revised 2018.11.11. Copied from Kernel_common.fnRegistration_validate_email 2019.11.30. Revised 2021.05.02.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    uOp.Subr = udtApplication_subroutine_names.Email_validate_fn

    If tEmail = "" Then
      tLocals.Msg = "Please enter your email address."
      Stop ' To do, to re-develop:
      ' tEmail = Trim(Inputbox_LIS_top (        tLocals.Msg , "", uOp.Subr))
      Call Inputbox_LIS_top(tLocals.Msg, "", uOp.Subr)
      If tEmail = "" Or uDialogue.Dialogue_result = DialogResult.Cancel Then
        Stop
      End If
    End If
    If tEmail <> "" And InStr(1, tEmail, "@") > 0 And InStr(1, tEmail, ".") > 0 Then
      Email_validate_fn = True
    Else
      tLocals.Msg = "The submitted email was determined to be invalid."
      Stop ' To do, to re-develop:
      '     uOp.Result  = Msgbox_LIS_top (        tLocals.Msg , udtAlert_types.Exclamation, udtDialogue_types.Okay_only, uOp.Subr)
      ' uDialogue.Dialogue_result = Msgbox_LIS_top (        tLocals.Msg , udtAlert_types.Exclamation, udtDialogue_types.Okay_only, uOp.Subr)
      Call Msgbox_LIS_top(tLocals.Msg, udtAlert_types.Exclamation, udtDialogue_types.Okay_only, uOp.Subr)
    End If

    uOp.Result = Nothing
    uOp.Subr = ""
  End Function

  ' Public Class Connection_info ' Moved to module Web.

  ' Private Sub Invoke_append_output(ByVal tMessage As String) ' Moved to module Web.

  ' Private Sub Append_output(ByVal tMessage As String) ' Moved to module Web.

  Sub Me_web_update()
    ' Written MJBH, 2015.12.25. Revised 2020.04.04.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    ' Dim tConnection_client As Connection_info
    tLocals.Subr = udtApplication_subroutine_names.Me_web_update
    tLocals.Status = udtuStandard_texts.Initiation
    Call Log_write(tLocals, 0)

    Stop ' To do, to develop.

    With mInternet
      If mInternet.Server_address Is Nothing Then
        Try
          ' Dim tRemote_host As IPHostEntry = Dns.GetHostEntry("127.0.0.1")
          .Remote_host = Dns.GetHostEntry("127.0.0.1")
          If .Remote_host IsNot Nothing AndAlso .Remote_host.AddressList.Length > 0 Then
            For Each tDelta_address As IPAddress In .Remote_host.AddressList
              If tDelta_address.AddressFamily = AddressFamily.InterNetwork Then
                .Server_address = tDelta_address
                Exit For
              End If
            Next
          End If
        Catch ex As Exception
          Stop ' Permanent.
          tLocals.Error_description = ex.Message
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process

          tLocals.Error_description = "Internet protocol address error."
        End Try
      End If

      If .Server_address Is Nothing Then
        tLocals.Error_description = "Invalid server name or address."
        MessageBox.Show(tLocals.Error_description, "Cannot connect to server.", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ' ConnectButton.Checked = False
      Else
        ' ConnectButton.Text = "Disconnect"
        ' ConnectButton.Image = My.Resources.Disconnect
        Try
          ' tConnection_client = New Connection_info(.Server_address, CInt("1314"), AddressOf Invoke_append_output)
          ' Call tConnection_client.Await_data()

          tLocals.Action = "Send message"
          tLocals.Msg = "Request " & uApp.App_name & ".version."
          'If tConnection_client IsNot Nothing AndAlso tConnection_client.Client.Connected AndAlso tConnection_client.Stream IsNot Nothing Then
          '  Dim tBuffer() As Byte = System.Text.Encoding.ASCII.GetBytes(tLocals.Msg)
          '  tConnection_client.Stream.Write(tBuffer, 0, tBuffer.Length)
          'End If

        Catch ex As Exception
          Stop ' Permanent.
          tLocals.Error_description = ex.Message
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process

          tLocals.Error_description = "Error connecting to server. " & ex.Message & "."
          MessageBox.Show(tLocals.Error_description, uError.Message, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
          ' ConnectButton.Checked = False
        End Try
      End If

      Stop
      tLocals.Action = "Close connection"
      ' If tConnection_client IsNot Nothing Then tConnection_client.Close()
      ' tConnection_client = Nothing
    End With

Error_process:
    If tLocals.Error_count <> 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       tLocals.Success = udtBoolean_extended.False_ Or tLocals.Steps_completed < tLocals.Steps_to_complete Or _
       uOp.Event_ = "" Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    uOp.Success = True
    Call Log_write(tLocals, 1)
  End Sub

  Sub Country_settings_scrape()
    ' Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tSearch As udtSearch = Nothing

    '      Dim tRow_count As Integer
    '      Dim tColumn_count As Integer
    '      Dim tIE As InternetExplorer
    '      Dim varTables As Object = Nothing
    '      Dim varTable As Object = Nothing
    '      Dim varRows As Object = Nothing
    '      Dim varRow As Object = Nothing
    '      Dim varCells As Object = Nothing
    '      Dim varCell As Object = Nothing
    '      Dim strBuffer As String
    '      Dim tUrl As String
    '      Dim tPackage As String

    '      Dim tName_two_letter As String = ""
    '      Dim tCountry As String = ""
    '      Dim tCountry_last As String = ""
    '      Dim tNotes As String = ""
    '      Dim tCurrency As String = ""
    '      Dim tCurrency_sign As String = ""
    '      Dim tCurrency_format As String = ""
    '      Dim tCurrency_ISO_code As String = ""
    '      Dim tTelephone_code As String
    tLocals.Subr = udtApplication_subroutine_names.Country_settings_scrape

    '      uOp.Subr =  tLocals.Subr 
    '      On Error GoTo Error_handler
    tLocals.Status = udtuStandard_texts.Initiation
    '          Call Log_write( tLocals ,  0) 
    '      uOp.Subr =  tLocals.Subr 
    tLocals.Action = udtuStandard_texts.Main_start

    'Main:
    '      If uMemory_ProgFiles.Database = "" Then
    '         Call Database_instantiate(uMemory_ProgFiles)
    '         uOp.Subr =  tLocals.Subr 
    '         If uMemory.Success Then
    '            Call Memory_define_International()
    '            Call Database_create(uMemory_ProgFiles)
    '         End If
    '      End If

    '      Stop
    '      ' Stage 1, establish two-letter country codes: 
    '      Call frmMain.Statuslabel1_set("Contacting web page...")
    '      ' tUrl = "www.en.wikipedia.org/wiki/ISO_two-letter_country_codes"
    '      tUrl = "https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2"
    '      Call Instantiate_IE(tUrl, tIE)
    '      uOp.Subr =  tLocals.Subr 

    '      Call frmMain.Statuslabel1_set("Updating country data...")

    '      tSearch.Keyword = "*Code*Country name*Year*ccTLD*ISO 3166-2*Notes*"
    '      varTables = tIE.Document.All.tags("TABLE")
    '      For Each varTable In varTables
    '         ' Use the innerText to see if this is the table we want:
    '         If uApp.Debug Then  tLocals.Msg  = varTable.innerText
    '         If varTable.innerText Like tSearch.Keyword Then
    '            varRows = varTable.Rows
    '            tRow_count = 1
    '            For Each varRow In varRows
    '               tName_two_letter = ""
    '               tCountry = ""
    '               tNotes = ""
    '               tColumn_count = 1

    '               varCells = varRow.Cells

    '               For Each varCell In varCells
    '                  If uApp.Debug Then  tLocals.Msg  = varCell.innerText
    '                  If uApp.Debug Then  tLocals.Msg  = Trim(varCell.innerText)

    '                  If tRow_count > 1 And tColumn_count = 1 Then
    '                     tName_two_letter = Trim(varCell.innerText)
    '                     frmMain.ToolStripStatusLabel1.Text = "Updating country data, " & tName_two_letter & "..."
    '                  End If

    '                  If tRow_count > 1 And tColumn_count = 2 Then
    '                     tCountry = varCell.innertext
    '                     If InStr(tCountry, "!") > 0 Then
    '                        tCountry = Trim(Left(tCountry, InStr(tCountry, "!") - 1))
    '                     End If
    '                  End If

    '                  If tRow_count > 1 And tColumn_count = 6 Then
    '                     tNotes = varCell.innertext
    '                     If tNotes <> "" Then
    '                        tNotes = Replace(tNotes, Chr(9), " ")
    '                        tNotes = Replace(tNotes, Chr(13), ". ")
    '                        tNotes = Replace(tNotes, Chr(34), "'") ' "
    '                        tNotes = Replace(tNotes, "  ", " ")
    '                        If Right(tNotes, 1) <> "." Then
    '                           tNotes = tNotes & "."
    '                        End If
    '                     End If
    '                  End If
    '                  If tName_two_letter <> "" And tCountry <> "" And tColumn_count = 6 Then
    '                     ' Query:
    '                     uMemory_ProgFiles.Table = "International"
    '                     uMemory_ProgFiles.Cmd_str = "SELECT Two_letter, Country_name FROM International WHERE Two_letter='" & tName_two_letter & "'"
    '                     Call Database_general(uMemory_ProgFiles)
    '                     uOp.Subr =  tLocals.Subr 

    '                     If uMemory_ProgFiles.Rows_affected = -1 Or uMemory_ProgFiles.Rows_affected = 0 Then
    tLocals.Action = udtuStandard_texts.Sql_build_insert
    '                        Stop
    '                        uMemory_ProgFiles.Cmd_str = "INSERT INTO " & uMemory_ProgFiles.Table & " (" & vbCr
    '                        uMemory_ProgFiles.Indent = Space(Len(uMemory_ProgFiles.Cmd_str))
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & uMemory_ProgFiles.Indent & "Two_letter, " & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & uMemory_ProgFiles.Indent & "Country_name, " & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & uMemory_ProgFiles.Indent & "[Note]" & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & ") VALUES (" & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & uMemory_ProgFiles.Indent & "'"  & tName_two_letter & "'"  & ", " & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & uMemory_ProgFiles.Indent & "'"  & tCountry & "'"  & ", " & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & uMemory_ProgFiles.Indent & "'"  & tNotes & "'"  & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & ")"
    '                     ElseIf uMemory_ProgFiles.Rows_affected = 1 Then
    '                        ' Update:
    '                        uMemory_ProgFiles.Cmd_str = "UPDATE " & uMemory_ProgFiles.Table & " SET " & vbCr
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & "Country_name=" & "'"  & tCountry & "'" 
    '                        If tNotes <> "" Then uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & ", [Note]=" & "'"  & tNotes & "'" 
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & " WHERE Two_letter=" & "'"  & tName_two_letter & "'" 
    '                     Else
    '                        Stop
    '                     End If
    '                     Call Database_general(uMemory_ProgFiles)
    '                     uOp.Subr =  tLocals.Subr 

    '                  End If

    '                  tColumn_count = tColumn_count + 1
    '               Next varCell
    '               tRow_count = tRow_count + 1
    '            Next varRow
    '         End If
    '      Next varTable
    '      tName_two_letter = ""
    '      tCountry = ""
    '      tNotes = ""

    '      ' Establish currencies: 
    '      Stop
    '      Call frmMain.Statuslabel1_set("Contacting web page...")
    '      tUrl = "www.en.wikipedia.org/wiki/List_of_circulating_currencies"
    '      Call Instantiate_IE(tUrl, tIE)
    '      uOp.Subr =  tLocals.Subr 
    '      varTables = tIE.Document.All.tags("TABLE")
    '      For Each varTable In varTables
    '         ' Use the innerText to see if this is the table we want:
    '         If uApp.Debug Then  tLocals.Msg  = varTable.innerText
    '         ' If varTable.innerText Like "*Country or territory[1]*Currency[2]*Sign[3]*ISO code[2]*Fractional unit*Number to basic*" Then
    '         ' If InStr(varTable.innerText, "*Country or territory[1]*Currency[2]*Sign[3]*ISO code[2]*Fractional unit*Number to basic*") > 0 Then
    '         If InStr(varTable.innerText, "Country or territory[1]") > 0 Then
    '            varRows = varTable.Rows
    '            tRow_count = 1
    '            For Each varRow In varRows
    '               tCountry = ""
    '               tCurrency = ""
    '               tCurrency_sign = ""
    '               tCurrency_format = ""
    '               tCurrency_ISO_code = ""
    '               tColumn_count = 1

    '               varCells = varRow.Cells

    '               For Each varCell In varCells
    '                  If tRow_count = 1 Then Exit For

    '                  If uApp.Debug Then  tLocals.Msg  = varCell.innerText
    '                  If uApp.Debug Then  tLocals.Msg  = Trim(varCell.innerText)
    '                  If tRow_count > 1 And tColumn_count = 1 Then
    '                     tCountry = Trim(varCell.innertext)
    '                     If InStr(tCountry, "!") > 0 Then
    '                        tCountry = Trim(Left(tCountry, InStr(tCountry, "!") - 1))
    '                     End If
    '                  End If

    '                  If tRow_count > 1 And tColumn_count = 2 Then
    '                     tCurrency = Trim(varCell.innertext)
    '                     If InStr(tCurrency, "[") > 0 Then
    '                        tCurrency = Left(tCurrency, InStr(tCurrency, "[") - 1)
    '                     End If
    '                     If tCurrency = "None" Then
    '                        tCurrency = ""
    '                        Exit For
    '                     End If
    '                  End If

    '                  If tRow_count > 1 And tColumn_count = 3 Then
    '                     tCurrency_sign = Trim(varCell.innertext)
    '                     If tCurrency_sign = "None" Then tCurrency_sign = ""
    '                  End If

    '                  If tRow_count > 1 And tColumn_count = 4 Then
    '                     tCurrency_ISO_code = Trim(varCell.innertext)
    '                     If tCurrency_ISO_code = "None" Then tCurrency_ISO_code = ""
    '                  End If

    '                  If tCountry <> "" And tCurrency <> "" And tCurrency_sign <> "" And tColumn_count = 6 Then
    '                     ' Query:
    '                     uMemory_ProgFiles.Table = uTables.International
    '                     uMemory_ProgFiles.Cmd_str = "SELECT * FROM " & uMemory_ProgFiles.Table & " WHERE Country_name ='" & tCountry & "'"
    '                     Stop
    '                     Call Database_general(uMemory_ProgFiles)
    '                     uOp.Subr =  tLocals.Subr 

    '                     If uMemory_ProgFiles.Rows_affected = -1 Or uMemory_ProgFiles.Rows_affected = 0 Then
    '                        Stop
    tLocals.Action = udtuStandard_texts.Sql_build_insert
    '                        ' uMemory_ProgFiles.Cmd_str = "INSERT INTO " &  uMemory_ProgFiles.Table & " (Two_letter, Country_name, [Currency], Currency_format, Currency_sign, Telephone_code) VALUES ("
    '                        ' uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & "'" & tTwo & "', "
    '                        ' uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & "'" & tCountry & "', "
    '                        ' uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & "'" & tCurrency & "', "
    '                        ' uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & "'" & tCurrency_format & "', "
    '                        ' uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & "'" & tCurrency_sign & "', "
    '                        ' uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & "'" & tCurrency_format & "'"
    '                        ' uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & ")"

    '                     ElseIf uMemory_ProgFiles.Rows_affected = 1 Then
    '                        ' Update: 
    '                        uMemory_ProgFiles.Table = uTables.International
    '                        uMemory_ProgFiles.Cmd_str = "UPDATE " & uMemory_ProgFiles.Table & " SET "
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & "[Currency]=" & "'"  & tCurrency & "'" 
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & ", Currency_sign=" & "'"  & tCurrency_sign & "'" 
    '                        '  uMemory_ProgFiles.Cmd_str =  uMemory_ProgFiles.Cmd_str & ", Currency_format=" & "'"  & tCurrency_format & "'" 
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & ", Currency_ISO_code=" & "'"  & tCurrency_ISO_code & "'" 
    '                        uMemory_ProgFiles.Cmd_str = uMemory_ProgFiles.Cmd_str & " WHERE Country_name=" & "'"  & tCountry & "'" 
    '                        Stop
    '                     Else
    '                        Stop
    '                     End If
    '                     If uMemory_ProgFiles.Cmd_str <> "" Then Call Database_general(uMemory_ProgFiles)
    '                     uOp.Subr =  tLocals.Subr 

    '                  End If

    '                  tColumn_count = tColumn_count + 1
    '               Next varCell
    '               tCountry_last = tCountry
    '               tRow_count = tRow_count + 1
    '            Next varRow
    '         End If
    '      Next varTable
    '      Stop

    'Cleanup:
    '      uOp.Subr =  tLocals.Subr 
    '            tLocals.Action  = "Cleanup"
    '      varCell = Nothing
    '      varCells = Nothing
    '      varRow = Nothing
    '      varRows = Nothing
    '      varTable = Nothing
    '      varTables = Nothing
    '      If tIE IsNot Nothing Then tIE.Quit()
    '      tIE = Nothing

Error_captured:
    '          tLocals.Error_number = Err.Number 
    '          tLocals.Error_description = Err.Description 
    '          tLocals.Error_source = Err.Source 
    '      If Err.Number <> 0 Then
    '         Stop ' Indefinite.
    '                tLocals.Error_count    =        tLocals.Error_count    + 1
    '         uOp.Success = False
    '          uError.Count  =  uError.Count  + 1
    '         If  uError.Count  >  udtError.Infinite_loop_limit  Or        tLocals.Error_count    >  udtError.Infinite_loop_limit  Then Call Infinite_loop(       tLocals.Error_count   )
    '         If uApp.Terminating = 0 Then
    '                    Select Case tLocals.Error_number 
    '                  Stop ' Permanent.
    '               Case 91 ' Object variable or With block variable not set.
    '                  Select Case       tLocals.Action 
    '                     Case "Cleanup"
    '                        uError.Number = 0
    '                        uError.Description = ""
    '                        uError.Source = ""
    '                        Resume Next
    '                     Case Else
    '                        Stop ' Permanent.
    '                                    Call Error_display(tLocals) 
    '                  End Select
    '               Case Else
    '                  Stop ' Permanent.
    '                              Call Error_display(tLocals) 
    '            End Select
    '         End If
    '      End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    '          Call Log_write( tLocals ,  1) 
    '      uOp.Subr =  tLocals.Subr 

    '      uOp.Subr = ""
  End Sub

End Module
