﻿' Form: Dialogue.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner. 
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson, 2015.04.03.
' Width:  450.
' Height: 223.

Option Explicit On
Option Strict Off ' Allows translation of numeric variables into strings.

Public Class frmDialogue
  Public Const cfrmDialogue_version As Date = #4/9/2021# ' M/d/y.

  Private Sub frmDialogue_Load(sender As System.Object, e As System.EventArgs) Handles Me.Load
    ' Revised 2016.11.05. Revised 2021.04.09.
    Dim tLocals As udtLocals = Nothing

    Dim Me_Top_before As Integer = Me.Top
    Dim Me_Left_before As Integer = Me.Left
    Dim Me_Width_before As Integer = Me.Width
    Dim Me_Height_before As Integer = Me.Height
    Dim tDialogue_parent As String = ""
    Dim tDialogue_parent_name As String = ""

    tLocals.Subr = "frmDialogue_Load"
    tLocals.Action = udtuStandard_texts.Main_start

    If Not IsNothing(uDialogue.Parent) Then
      tDialogue_parent = uDialogue.Parent.ToString
      Try
        tDialogue_parent_name = uDialogue.Parent.Name.ToString
      Catch ex As Exception
        Stop ' Permanent.
        tLocals.Error_description = ex.Message
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
        ' Call the object, not it's name.
      End Try
      Dim tDialogue_parent_type As String = uDialogue.Parent.GetType.ToString
      Dim tDialogue_parent_top As Integer = uDialogue.Parent.Top
      Dim tDialogue_parent_left As Integer = uDialogue.Parent.Left
      Dim tDialogue_parent_height As Integer = uDialogue.Parent.height
      If uApp.Debug Then tLocals.Msg = uDialogue.Parent.GetType.ToString
      If uApp.Debug Then tLocals.Msg = uDialogue.Parent.name
    End If

    Dim tMy_computer_screen_bounds_height As Integer = My.Computer.Screen.Bounds.Height
    Dim tMy_computer_screen_bounds_width As Integer = My.Computer.Screen.Bounds.Width
    Dim tMy_computer_screen_working_area_height As Integer = My.Computer.Screen.WorkingArea.Height
    Dim tMy_computer_screen_working_area_width As Integer = My.Computer.Screen.WorkingArea.Width
    Dim tFrmMain_left As Integer = frmMain.Left

    tLocals.Action = "Check or set form parameters"
    frmMain.tabControl_top.Enabled = False
    frmMain.btnFirst_run_back.BackColor = Color.Transparent
    frmMain.btnFirst_run_next.BackColor = Color.Transparent
    frmMain.btnFirst_run_cancel.BackColor = Color.Transparent
    frmMain.tabControl_main.Enabled = False
    If uDialogue.Prompt = "" Then
      Stop
      Call Get_file_name()
      If uDialogue.Dialogue_result = Windows.Forms.DialogResult.None Then
        tLocals.Success = udtBoolean_extended.False_
        Me.Close()
      End If
    Else
      tLocals.Msg = Me.TopLevel
      Me.TopMost = False ' 2020.11.20.
      ' https://docs.microsoft.com/en-us/dotnet/api/system.windows.forms.form.topmost?redirectedfrom=MSDN&view=netframework-4.8#System_Windows_Forms_Form_TopMost.

      Select Case uDialogue.Position

        Case udtDialogue_position.Full
          Stop ' To do, to develop.
          Me.Top = uDialogue.Parent.top
          Me.Left = uDialogue.Parent.left
          Me.Width = uDialogue.Parent.width
          Me.Height = uDialogue.Parent.height
          GroupBox1.Width = Me.Width - 3
          GroupBox1.Height = Me.Height - 3

        Case udtDialogue_position.Top_left
          Me.Top = uDialogue.Parent.Top - 10
          tLocals.Msg = uDialogue.Parent.GetType.ToString
          If InStr(uDialogue.Parent.GetType.ToString, "frm") > 0 Then
            Me.Top = uDialogue.Parent.Top + 55
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "Tab") > 0 Then
            Me.Top = uDialogue.Parent.Top + 85
            If Me_Left_before > tMy_computer_screen_bounds_width Then Me.Top = uDialogue.Parent.Top + 85 + 180
            Me.Left = frmMain.Left + uDialogue.Parent.Left + 8
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "MenuStrip") > 0 Then
            Me.Top = uDialogue.Parent.Top + 96
          Else
            Me.Top = uDialogue.Parent.top + frmMain.frmMain_splitcontainer.SplitterDistance + 115
          End If
          Me.Left = frmMain.Left + uDialogue.Parent.Left + 4

        Case udtDialogue_position.Top_right
          If uApp.App_name = udtApplication.App_Financier_Personal_Edition Or uApp.App_name = udtApplication.App_Financier_Commercial_Edition Then
          Else
            Stop ' Settings for Financier, 2020.04.13.
          End If
          Me.Top = uDialogue.Parent.Top
          If InStr(uDialogue.Parent.GetType.ToString, "frm") > 0 Then
            Me.Top = uDialogue.Parent.Top + 55
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "Tab") > 0 Then
            ' Me.Top = frmMain.MainMenu1.Height + frmMain.top_split_container.Top + frmMain.top_split_container.Height + 100 ' 2021.03.07 For Financier. Was 90.
            Me.Top = frmMain.MainMenu1.Height + frmMain.top_split_container.Top + frmMain.top_split_container.Height + 90 ' 2021.04.09 For Financier.
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "MenuStrip") > 0 Then
            Me.Top = uDialogue.Parent.Top + 96
          Else
            Me.Top = uDialogue.Parent.top + frmMain.frmMain_splitcontainer.SplitterDistance + 115
          End If
          ' Me.Left = frmMain.Left + uDialogue.Parent.Width - Me.Width + 5 ' Revised for Financier, 2020.05.01.
          Me.Left = frmMain.Left + uDialogue.Parent.Width - Me.Width + 8 ' Revised for Financier, 2021.04.09.

        Case udtDialogue_position.Bottom_left
          Stop ' Indefinite.
          tLocals.Msg = uDialogue.Parent.Top
          tLocals.Msg = uDialogue.Parent.Height
          Me.Top = uDialogue.Parent.Top + uDialogue.Parent.Height - Me.Height
          If InStr(uDialogue.Parent.GetType.ToString, "frm") > 0 Then
            Stop ' Indefinite.
            Me.Top = uDialogue.Parent.Top + 55
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "Tab") > 0 Then
            tLocals.Msg = frmMain.MainMenu1.Height
            tLocals.Msg = frmMain.grpCon_help.Height
            Me.Top = Me.Top + frmMain.MainMenu1.Height + 44
            If Me_Left_before > tMy_computer_screen_bounds_width Then Me.Top = uDialogue.Parent.Top + 85 + 180
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "MenuStrip") > 0 Then
            Me.Top = uDialogue.Parent.Top + 96
          Else
            Me.Top = frmMain.MainMenu1.Height + frmMain.tabControl_main.Top + uDialogue.Parent.Top + 62
          End If
          Me.Left = frmMain.Left + uDialogue.Parent.Left + 8

        Case udtDialogue_position.Bottom_right
          If uApp.Debug Then tLocals.Msg = uDialogue.Parent.Top
          If uApp.Debug Then tLocals.Msg = uDialogue.Parent.Height
          Me.Top = frmMain.tabControl_top.Height + uDialogue.Parent.Top + uDialogue.Parent.Height - Me.Height
          If InStr(uDialogue.Parent.GetType.ToString, "frm") > 0 Then
            Me.Top = uDialogue.Parent.Top + 55
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "Tab") > 0 Then
            If uApp.Debug Then tLocals.Msg = frmMain.MainMenu1.Height
            Me.Top = Me.Top + frmMain.MainMenu1.Height + 83
            If Me_Left_before > tMy_computer_screen_bounds_width Then Me.Top = uDialogue.Parent.Top + 85 + 180
          ElseIf InStr(uDialogue.Parent.GetType.ToString, "MenuStrip") > 0 Then
            Me.Top = uDialogue.Parent.Top + 96
          Else
            Me.Top = frmMain.MainMenu1.Height + frmMain.tabControl_main.Top + uDialogue.Parent.Top + 62
          End If
          Me.Left = frmMain.Left + uDialogue.Parent.Width - Me.Width + 16

        Case Else
          tLocals.Msg = uDialogue.Position
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Status = udtuStandard_texts.Failed
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process
      End Select ' Select Case uDialogue.Position

      tLocals.Action = "Check basics"
      tLocals.Response = Nothing
      If uDialogue.Alert = 0 Then
        Stop ' Indefinite.
        uDialogue.Prompt = "Please ensure that uDialogue.Alert is set."
        uDialogue.Alert = udtAlert_types.Critical
        uDialogue.Dialogue_type = udtDialogue_types.Okay_only
      End If
      If uDialogue.Dialogue_type = 0 Then
        Stop ' Indefinite.
        uDialogue.Prompt = "Please ensure that uDialogue.Dialogue_type is set."
        uDialogue.Alert = udtAlert_types.Critical
        uDialogue.Dialogue_type = udtDialogue_types.Okay_only
      End If
      uDialogue.Dialogue_result = Nothing

      tLocals.Action = "Set form items"
      If Not Me.Modal Then Me.Parent = uDialogue.Parent
      If InStr(uDialogue.Parent.GetType.ToString, "frm") > 0 Then Me.Owner = uDialogue.Parent
      Me.ShowInTaskbar = False
      Me.Text = uApp.App_name & ": Dialogue:"
      lblPrompt.Text = uDialogue.Prompt
      txtDialogue_response.Visible = False
      cboDialogue_response.SelectedIndex = -1
      cboDialogue_response.Text = ""
      cboDialogue_response.Visible = False
      btnDialogue_okay_button.Enabled = True
      btnDialogue_okay_button.BackColor = uApp.Colours.Okay
      btnDialogue_cancel_button.Visible = False
      btnDialogue_cancel_button.BackColor = uApp.Colours.Cancel

      tLocals.Action = "Apply dialogue type logo"
      Select Case uDialogue.Alert
        Case udtAlert_types.Critical
          PictureBox1.Image = My.Resources.Critical
          If uDialogue.Called_from <> "Error display" Then Call Sound_alert()
        Case udtAlert_types.Exclamation
          PictureBox1.Image = My.Resources.Exclamation
          'Case udtAlert_types.Information
        Case Else
          ' Default to Information if not set.
          PictureBox1.Image = My.Resources.Information
      End Select
      PictureBox1.SizeMode = PictureBoxSizeMode.StretchImage

      btnDialogue_okay_button.Text = "&Okay"
      btnDialogue_cancel_button.Text = "&Cancel"

      Select Case uDialogue.Dialogue_type
        Case udtDialogue_types.Chooser
          cboDialogue_response.Visible = True
          btnDialogue_okay_button.Enabled = False
          btnDialogue_cancel_button.Visible = True
          cboDialogue_response.Focus()

        Case udtDialogue_types.Okay_only
          cboDialogue_response.SelectedIndex = -1
          btnDialogue_okay_button.Focus()

        Case udtDialogue_types.Okay_cancel
          cboDialogue_response.Items.Clear()
          cboDialogue_response.SelectedIndex = -1
          btnDialogue_cancel_button.Visible = True
          btnDialogue_okay_button.Focus()

        Case udtDialogue_types.Yes_no
          txtDialogue_response.Visible = False
          cboDialogue_response.Items.Clear()
          cboDialogue_response.Visible = False
          cboDialogue_response.SelectedIndex = -1
          btnDialogue_okay_button.Text = "&Yes"
          btnDialogue_cancel_button.Visible = True
          btnDialogue_cancel_button.Text = "&No"

        Case udtDialogue_types.Question
          txtDialogue_response.Enabled = True
          txtDialogue_response.Visible = True
          txtDialogue_response.Text = uDialogue.Response_str
          cboDialogue_response.Visible = False
          btnDialogue_cancel_button.Visible = True
          txtDialogue_response.Focus()

        Case Else
          Stop ' Permanent.
      End Select
      uDialogue.Active = True
    End If ' If uDialogue.Prompt = "" Then

Error_process:
    If uOp.Event_ = "" Or uError.Number <> 0 Then
      Stop ' Permanent.
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    Me.Refresh()
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or tLocals.Success = udtBoolean_extended.False_ Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Public Function Get_file_name() As String
    ' https://stackoverflow.com/questions/1256130/setting-the-start-position-for-openfiledialog-savefiledialog.
    ' Revised 2019.12.17.
    ' Gets an input file name from the user. Works with multi-monitors.
    Dim OpenFileDialog1 As New OpenFileDialog
    Dim PositionForm As New Form
    Dim MyInputFile As String

    Stop ' To review.

    ' The FileDialog() opens in the last Form that was created. It's buggy! To ensure it appears in the
    ' area of the current Form, we create a new hidden PositionForm and then delete it afterwards.

    PositionForm.TopLevel = False
    PositionForm.Parent = Me
    PositionForm.StartPosition = FormStartPosition.Manual
    'PositionForm.Left = Me.Left + CInt(Me.Width / 2)
    'PositionForm.Top = Me.Top + CInt(Me.Height / 2)
    'PositionForm.Width = 0
    'PositionForm.Height = 0
    PositionForm.FormBorderStyle = Windows.Forms.FormBorderStyle.None
    PositionForm.Visible = False
    PositionForm.Show()

    ' Added the statement "ShowHelp = True" to workaround a problem on W8.1 machines with SkyDrive installed.
    ' It causes the "old" W7 control to be used that does not point to SkyDrive in error.

    OpenFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
    OpenFileDialog1.Filter = "Excel files (*.xls*)|*.xls*|CSV Files (*.csv)|*.csv"
    OpenFileDialog1.FilterIndex = 1
    OpenFileDialog1.RestoreDirectory = True
    OpenFileDialog1.AutoUpgradeEnabled = False
    OpenFileDialog1.ShowHelp = True
    OpenFileDialog1.FileName = ""
    OpenFileDialog1.SupportMultiDottedExtensions = False
    OpenFileDialog1.Title = "Select an Excel or .csv file containing patent data or list of publication numbers for your project."

    If OpenFileDialog1.ShowDialog(PositionForm) <> System.Windows.Forms.DialogResult.OK Then
      Console.WriteLine("No file was selected. Please try again.")
      OpenFileDialog1.Dispose()
      Return ""
    End If
    PositionForm.Close()
    PositionForm.Dispose()

    MyInputFile = OpenFileDialog1.FileName
    OpenFileDialog1.Dispose()
    Return MyInputFile

  End Function

  Private Sub cboDialogue_response_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cboDialogue_response.SelectedIndexChanged
    If cboDialogue_response.SelectedIndex <> -1 Then btnDialogue_okay_button.Enabled = True
  End Sub

  Private Sub Okay_button_click(sender As System.Object, e As System.EventArgs) Handles btnDialogue_okay_button.Click
    ' Revised 2021.02.06.
    ' uUser.Cancel = False
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "Okay_button_click"
    If uOp.Event_ = "" Then uOp.Event_ = tLocals.Subr
    Me.DialogResult = DialogResult.OK
    uDialogue.Dialogue_result = DialogResult.OK
    Select Case uDialogue.Dialogue_type
      Case udtDialogue_types.Chooser
        uDialogue.Response_str = cboDialogue_response.Text
        uDialogue.Response_num = cboDialogue_response.SelectedIndex
        If uDialogue.Response_str = "" Or uDialogue.Response_num = -1 Then
          Stop ' Indefinite.
        End If
      Case udtDialogue_types.Okay_only
        uDialogue.Response_str = Nothing
      Case udtDialogue_types.Okay_cancel
        uDialogue.Response_str = Nothing
      Case udtDialogue_types.Question
        uDialogue.Response_str = txtDialogue_response.Text
      Case udtDialogue_types.Yes_no
      Case Else
        Stop ' Permanent.
    End Select

    ' Dim Me_Top_after As Integer = Me.Top ' 228 on second screen.
    ' Dim Me_Left_after As Integer = Me.Left ' 1679.
    Me.Close()

    uDialogue.Active = False
    frmMain.tabControl_top.Enabled = True
    frmMain.tabControl_main.Enabled = True
    If uOp.Event_ = tLocals.Subr Then uOp.Event_ = ""
  End Sub

  Private Sub Cancel_Button_Click(sender As System.Object, e As System.EventArgs) Handles btnDialogue_cancel_button.Click
    ' Revised 2021.02.06.
    Dim tLocals As udtLocals = Nothing
    ' Dim Me_Top_after As Integer = Me.Top
    ' Dim Me_Left_after As Integer = Me.Left
    tLocals.Subr = "Cancel_Button_Click"
    If uOp.Event_ = "" Then uOp.Event_ = tLocals.Subr
    uUser.Cancel = True
    Me.DialogResult = Windows.Forms.DialogResult.Cancel
    uOp.Success = False
    uDialogue.Dialogue_result = DialogResult.Cancel

    Me.Close()

    uDialogue.Active = False
    frmMain.tabControl_top.Enabled = True
    frmMain.tabControl_main.Enabled = True

    uOp.Success = True
    If uOp.Event_ = tLocals.Subr Then uOp.Event_ = ""
  End Sub

End Class
