﻿' Form: Main.
' Copyright © LivingInfo Systems, 1999. All rights reserved.
' Except as provided by the Copyright Act 1994, no part of this publication may be reproduced or stored in a retrieval system in any form or by any means without the prior written permission of the copyright owner.
' www.livinginfosystems.com.
' Written by Michael John Boyack Hodgson.

Option Explicit On
Option Strict Off ' Allows variable type conversion.

Imports System.Reflection ' Used by tabSystem_information.
Imports VB = Microsoft.VisualBasic

Public Class frmMain
  Public Const cfrmMain_version As Date = #5/9/2021# ' M/d/y.

#Region "Form element events"

  Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' Revised 2021.05.02.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.Form_load
    uOp.Event_ = tLocals.Subr
    uOp.Subr = tLocals.Subr
    tLocals.Action = udtuStandard_texts.Initiation
    tLocals.Status = udtuStandard_texts.Initiation
    uApp.Initialising = True
    uOp.Form_initialising = True
    tLocals.Status = ""

    tLocals.Action = udtuStandard_texts.Main_start
    If uApp.Startup_sequence < 1 Then
      uApp.Progressbar_show = True
      uApp.Progressbar_steps_total = 25 ' Initial value.
      If InStr(Environment.MachineName, "MJBH") = 0 And InStr(Environment.MachineName, "SURFACE") = 0 Then
        Stop ' Temporary.
        tLocals.Msg = Environment.MachineName
        tLocals.Msg = Environment.UserName
      End If

      uApp.Startup_sequence = 1
    End If

    If uApp.Startup_sequence < 2 Then
      tLocals.Action = "Set form objects visibility, defaults, or as needed"
      NotifyIcon1.Visible = False
      Call Get_taskbar_location()
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
      uOp.Success = False

      Me.ShowInTaskbar = True
      tLocals.Action = "Set form objects visibility, defaults, or as needed: Menu bar"
      tLocals.Action = "Hide menu items"
      tLocals.Action = "Set form objects visibility, defaults, or as needed: File menu"
      ' FileToolStripMenuItem.Visible = False
      NewToolStripMenuItem.Visible = False
      OpenToolStripMenuItem.Visible = False
      toolStripSeparator.Visible = False
      SaveToolStripMenuItem.Visible = False
      SaveAsToolStripMenuItem.Visible = False
      toolStripSeparator1.Visible = False
      PrintToolStripMenuItem.Visible = False
      PrintPreviewToolStripMenuItem.Visible = False
      toolStripSeparator2.Visible = False

      tLocals.Action = "Set form objects visibility, defaults, or as needed"
      uApp.Startup_sequence = 2
    End If

    If uApp.Startup_sequence < 3 Then
      tLocals.Action = "Set form objects visibility, defaults, or as needed: Edit menu"
      ' EditToolStripMenuItem1.Visible = False
      UndoToolStripMenuItem.Visible = False
      RedoToolStripMenuItem.Visible = False
      toolStripSeparator3.Visible = False
      CutToolStripMenuItem.Visible = False
      CopyToolStripMenuItem.Visible = False
      PasteToolStripMenuItem.Visible = False
      toolStripSeparator4.Visible = False
      SelectAllToolStripMenuItem.Visible = False
      ToolStripSeparator6.Visible = False
      SettingsToolStripMenuItem.Text = "Settings..."

      tLocals.Action = "Set form objects visibility, defaults, or as needed: View menu"
      tLocals.Action = "Set form objects visibility, defaults, or as needed: Window menu"
      tLocals.Action = "Set form objects visibility, defaults, or as needed: Help menu"

      tLocals.Action = "Set form objects visibility, defaults, or as needed"
      uApp.Startup_sequence = 3
    End If

    If uApp.Startup_sequence < 4 Then
      tLocals.Action = "Set TabControl_top appearance"
      tabControl_top.Appearance = TabAppearance.FlatButtons
      tabControl_top.ItemSize = New Size(0, 1)
      tabControl_top.SizeMode = TabSizeMode.Fixed

      uApp.Startup_sequence = 4
    End If

    If uApp.Startup_sequence < 5 Then
      tLocals.Action = "Set or hide form elements, part 1"
      tLocals.Action = "Set top dialogue elements"
      tLocals.Msg = top_split_container.Panel1.Width
      tLocals.Msg = top_split_container.Panel2.Width
      top_split_container.Panel1Collapsed = True
      tLocals.Msg = top_split_container.Panel1.Width
      tLocals.Msg = top_split_container.Panel2.Width
      tLocals.Msg = ""
      tLocals.Action = "Set or hide form elements, part 1"
      txtCon_help.Width = grpCon_help.Width - 10 ' Only needed if btnContext_more exists.
      txtCon_help.Text = "Welcome to " & udtApplication.App_Template & "™! The generic programme." & vbCrLf
      txtCon_help.Text = txtCon_help.Text & "Brought to you by " & udtLivingInfoSystems.Name_short & "."
      btnContext_more.Visible = True

      Call tabControl_top_tabs_hide()
      uOp.Subr = tLocals.Subr
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
      uOp.Success = False

      Call tabControl_main_tabs_hide()
      uOp.Subr = tLocals.Subr
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
      uOp.Success = False

      txtHome_description.Text = "A description of this application." & vbCrLf
      txtHome_description.Text = txtHome_description.Text & "This is a template application; for use in creating a new application, and co-ordinating common code." & vbCrLf

      uApp.Startup_sequence = 5
    End If

    If uApp.Startup_sequence < 6 Then
      tLocals.Action = "Set initial form position"
      uUser.Main_top = 0
      If uUser.Taskbar_location = Taskbar_Location.Top Then uUser.Main_top = My.Computer.Screen.Bounds.Height - My.Computer.Screen.WorkingArea.Height
      uUser.Main_left = 0
      If System.Environment.OSVersion.Version.Major >= 10 And uUser.Main_left = 0 Then uUser.Main_left = -8
      Me.Top = uUser.Main_top ' !
      Me.Left = uUser.Main_left ' !
      If System.Environment.OSVersion.Version.Major >= 10 Then Me.Left = -8 ' !
      tLocals.Action = "Me show"
      Me.Show()
      uOp.Subr = tLocals.Subr
      Call Statuslabel1_set("Status: perceiving environment...")
      Call Statuslabel2_set()
      Me.Refresh()

      uApp.Startup_sequence = 6
    End If

    If uApp.Startup_sequence < 37 Then
      tLocals.Action = "frmMain_Load_part_02"
      Call frmMain_Load_part_02()
      If uDialogue.Active Then GoTo Ender_full
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
      uOp.Success = False
      txtCon_help.Width = Me.Width - btnContext_more.Width - 30

      uApp.Startup_sequence = 37
    End If

Error_process:
    If tLocals.Error_count <> 0 Or uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Msg = uApp.App_name & " failed to load fully and properly."
      Call Msgbox_LIS_top(tLocals.Msg, udtAlert_types.Critical, udtDialogue_types.Okay_only, tLocals.Subr)
    Else
      uOp.Form_loaded = True
    End If

Ender_full:
    If Not uDialogue.Active Then
      uApp.Initialising = False
      uOp.Form_initialising = False
      uApp.First_run_in_progress = False
    End If
    uOp.Subr = ""
    uOp.Success = False ' Start-up sequence completed.
    uOp.Event_ = ""
  End Sub
  Sub frmMain_Load_part_02()
    ' Separated 2019.03.24. Revised 2021.04.27.
    Dim tLocals As udtLocals = Nothing
    Dim tWelcome As String
    If Not uApp.Initialising And uApp.Startup_sequence >= 38 Then GoTo Ender_full

    uOp.Event_ = "Form load"
    tLocals.Subr = "Form load, part 2"
    tLocals.Status = udtuStandard_texts.Initiation
    uOp.Subr = tLocals.Subr
    On Error GoTo Error_captured
    tLocals.Status = ""

    tLocals.Action = udtuStandard_texts.Main_start

    If uApp.Startup_sequence < 27 Then
      tLocals.Action = "Environment determine"
      Call Environment_determine()
      If uDialogue.Active Then GoTo Ender_full
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Ender_partial
      End If
      uOp.Success = False

      uApp.Startup_sequence = 27
    End If

    If uApp.Startup_sequence < 28 Then
      tLocals.Action = "Set form elements"
      Me.Text = uApp.App_name
      Call Statuslabel1_set()
      NotifyIcon1.Text = uApp.App_name
      NotifyIcon1.Visible = False
      txtCon_help.Text = "Welcome to " & uApp.App_name & "™! The generic programme." & vbCrLf
      txtCon_help.Text = txtCon_help.Text & uCon_help.Home_default
      Call Statuslabel2_set()

      uApp.Startup_sequence = 28
    End If

    If uApp.Startup_sequence < 29 Then
      tLocals.Action = "Set form position"
      Me.Top = uUser.Main_top
      If System.Environment.OSVersion.Version.Major >= 10 And uUser.Main_left = 0 Then uUser.Main_left = -8
      Me.Left = uUser.Main_left
      Me.Height = uUser.Main_height
      tLocals.Action = "Resize"
      Me.Width = uUser.Main_width
      If uUser.Start_maximised Then Me.WindowState = FormWindowState.Maximized ' !
      tLocals.Action = "Set form position"

      uApp.Startup_sequence = 29
    End If

    If uApp.Startup_sequence < 30 Then
      tLocals.Action = "Set or hide form elements, part 2"
      EnterRegistrationCodeToolStripMenuItem.Visible = Not uReg.Registered
      ' Me.ToolTip1.SetToolTip(Me.lstList1, "List One: press Right, Enter, or double-click to select an item.")

      uApp.Startup_sequence = 30
    End If

    If uApp.Startup_sequence < 31 Then
      tLocals.Action = "Show tabs"
      Call tabControl_top_tabs_show()
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Ender_partial
      End If
      uOp.Success = False

      Call tabControl_main_tabs_show()
      If uDialogue.Active Then GoTo Ender_full
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Ender_partial
      End If
      uOp.Success = False

      uApp.Startup_sequence = 31
    End If

    If uApp.Startup_sequence < 32 Then
      tLocals.Action = udtApplication_subroutine_names.Speak_greeting
      Call Speak_greeting()
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Ender_partial
      End If
      uOp.Success = False

      Call Statuslabel1_set()
      uApp.Startup_sequence = 32
    End If

Main:
    If uApp.Startup_sequence < 33 Then
      tLocals.Action = "Greeting, part 2"
      If uApp.Upgraded Then
        tWelcome = uApp.Short_name & " has been upgraded to version " & Kernel_common.Date_format_fn(uApp.App_revision_date, True) & "."
        Call Speak_it(tLocals.Subr, tWelcome, 2)
        If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Status = udtuStandard_texts.Failed
          tLocals.Success = udtBoolean_extended.False_
          GoTo Ender_partial
        End If
        uOp.Success = False
      Else
        tWelcome = uApp.Short_name & " version: " & uApp.App_revision_date & "."
      End If
      tWelcome = "Ready. " & tWelcome
      If uApp.Log_loc = "" Then
        tWelcome = tWelcome & " Text memory is not available. Please restart this computer as soon as possible."
      End If
      If uReg.Registered Then
        tWelcome = tWelcome & " " & uApp.Short_name & " is registered."
      Else
        If uReg.Trial_30_day_20_days_notified Then tWelcome = tWelcome & " Your 30 day trial has nearly expired."
      End If
      If uError.Speech_error_reported Then
        tWelcome = tWelcome & " " & uUser.First_name & ", speech is unavailable."
      End If
      If Not uApp.Email_udt.Smtp_working Then
        tWelcome = tWelcome & " Email is unavailable."
      End If

      tLocals.Action = "Internet connection check"
      Call Internet_connection_check()
      uOp.Success = False

      tLocals.Action = "Status welcome"
      Call Statuslabel1_set(tWelcome)
      uApp.Startup_sequence = 33
    End If

    If uApp.Startup_sequence < 34 Then
      'If Not uReg.Registered Then
      '  If Not uReg.Code_sent Or uReg.Email_address = "" Then
      '          tLocals.Action  = "Re-test registration"
      '    Call Registration_request_email()
      '  End If
      'End If

      uApp.Startup_sequence = 34
    End If

    If uApp.Startup_sequence < 35 Then
      ' Section revised 2021.05.02.
      tLocals.Action = "Test for key press"
      ' Stop
      ' GetKeyState() method of user32.dll might be what you need; http://msdn.microsof...301(VS.85).aspx.
      ' If e.keycode <> "" Then Stop
      tLocals.Msg = Control.ModifierKeys

      ' To do, to test:
      tLocals.Msg = My.Computer.Keyboard.CtrlKeyDown
      tLocals.Msg = My.Computer.Keyboard.ShiftKeyDown
      tLocals.Msg = My.Computer.Keyboard.AltKeyDown

      tLocals.Msg = ""
      uApp.Startup_sequence = 35
    End If

    If uApp.Startup_sequence < 36 Then
      tLocals.Action = "Take command line arguments"
      Select Case My.Application.CommandLineArgs.Count
        Case 0
        Case Else
          tLocals.Action = "External call with " & My.Application.CommandLineArgs.Count & " parameters."
          Call Log_write(tLocals, 0)
          If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
            Stop ' Permanent.
            tLocals.Error_count = tLocals.Error_count + 1
            tLocals.Status = udtuStandard_texts.Cancelled
            tLocals.Success = udtBoolean_extended.False_
            GoTo Ender_partial
          End If
          uOp.Success = False

          Stop ' To develop:
          For Each tArgument As String In My.Application.CommandLineArgs
            tLocals.Msg = tArgument(1)
            tLocals.Msg = Val(tArgument(1))
            tLocals.Msg = tArgument(2)
            tLocals.Msg = tArgument(3)
          Next
      End Select

      uApp.Startup_sequence = 36
    End If

    If uApp.Startup_sequence < 37 Then
      If uMachine.Name = uMachine.Development_machine_name Then
        tLocals.Action = "Fill txtKernel_distribute.Text"
        If txtKernel_distribute.Text = "" Then
          uMemory_ProgFiles.Table_name = udtTables_local.Preference_common
          uMemory_ProgFiles.Cmd_str = "SELECT * FROM " & uMemory_ProgFiles.Table_name
          Call Database_general(uMemory_ProgFiles)
          If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Or Not uMemory_ProgFiles.Success Then
            Stop ' Permanent.
            tLocals.Error_count = tLocals.Error_count + 1
            tLocals.Status = udtuStandard_texts.Failed
            tLocals.Success = udtBoolean_extended.False_
            GoTo Ender_partial
          End If
          uMemory_ProgFiles.Success = False
          tLocals.Msg = ""
          uOp.Success = False

          If uMemory_ProgFiles.Rows_affected > 0 Then
            If Not IsDBNull(uMemory_ProgFiles.Dataset.Tables(uMemory_ProgFiles.Table_name).Rows(0).Item("Kernel_distribute_date")) Then
              tLocals.Action = udtuStandard_texts.Dataset_read
              txtKernel_distribute.Text = uMemory_ProgFiles.Dataset.Tables(uMemory_ProgFiles.Table_name).Rows(0).Item("Kernel_distribute_date")
              txtKernel_distribute.Text = txtKernel_distribute.Text & ", "
              txtKernel_distribute.Text = txtKernel_distribute.Text & uMemory_ProgFiles.Dataset.Tables(uMemory_ProgFiles.Table_name).Rows(0).Item("Kernel_distribute_time")
            End If
            tLocals.Action = "Fill txtKernel_distribute.Text"
          End If
        End If
      End If

      uApp.Startup_sequence = 37
    End If

    If uApp.Startup_sequence < 38 Then
      tLocals.Action = "Template testing"
      Call Template_testing()
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Ender_partial
      End If
      uOp.Success = False

      uApp.Startup_sequence = 38
    End If

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Then
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case 0
            Call Error_clear(tLocals)
            Resume
          Case 51 ' Internal error.
            Stop ' Indefinite.
            Resume Next
          Case Else
            Stop ' Permanent.
            Call Error_display(tLocals)
        End Select
      End If
    End If

Ender_full:
    uApp.Progressbar_show = False
    Call ToolStripProgressBar1_set()
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
      If uDialogue.Active Then tLocals.Status = "Dialogue active"
    End If
    If tLocals.Action = "" And tLocals.Status <> udtuStandard_texts.Cancelled And tLocals.Status <> udtuStandard_texts.Failed Then
      tLocals.Action = tLocals.Status
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = tLocals.Subr

    If Not uDialogue.Active Then
      uApp.Initialising = False
      uOp.Form_initialising = False
      uOp.Form_loaded = True
      tLocals.Action = "Start-up sequence completion"
      tLocals.Success = udtBoolean_extended.True_
      Call Log_write(tLocals, 0)
    End If

    Call Context_sensitive_help_set()
    uOp.Subr = tLocals.Subr
    Call Statuslabel1_set(tWelcome)
    Call Statuslabel2_set()
    uOp.Subr = ""
    Call Ready(True, tWelcome)

Ender_partial:
    If uOp.Called_from = udtApplication_subroutine_names.top_dialogue_okay_button_Click_handler Or _
      uOp.Called_from = udtApplication_subroutine_names.top_dialogue_cancel_button_Click Then
      uOp.Event_ = ""
    End If
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub
  Private Sub frmMain_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
    ' Revised 2021.03.24.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.frmMain_FormClosed

    uApp.Shutdown = True
    ToolStripStatusLabel1.Text = "Status: Shutting down."
    NotifyIcon1.Visible = False
    NotifyIcon1.Dispose()
    uApp.Progressbar_step = 0
    uApp.Progressbar_steps_total = 0
    If uApp.Progressbar_steps_total = 0 Then uApp.Progressbar_steps_total = 6
    uApp.Progressbar_show = True
    Call ToolStripProgressBar1_set()

    If uOp.Called_from <> udtApplication_subroutine_names.End_game Then
      If uOp.Called_from = udtApplication_subroutine_names.Version_check Or uOp.Called_from = udtApplication_subroutine_names.Version_check_after_dialogue_tab Then
      Else
        uOp.Called_from = uOp.Subr
      End If
      Call End_game()
    End If

    Try
      End ' That's all, folks!
    Catch ex As Exception
      Stop ' Permanent.
      tLocals.Error_description = ex.Message
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_process
    End Try
  End Sub
  Private Sub frmMain_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    ' Copied from FormClosed 2019.06.02. Revised 2021.03.24.
    Dim tLocals As udtLocals = Nothing
    uOp.Event_ = "frmMain_FormClosing"
    tLocals.Subr = uOp.Event_

    uApp.Shutdown = True
    ToolStripStatusLabel1.Text = "Status: Shutting down."
    If uOp.Called_from <> udtApplication_subroutine_names.End_game Then
      tLocals.Action = "Shut-down sequence begins"
      tLocals.Success = udtBoolean_extended.True_
      Call Log_write(tLocals, 0)
    End If
    NotifyIcon1.Visible = False
    NotifyIcon1.Dispose()
    If uOp.Called_from <> udtApplication_subroutine_names.End_game Then uApp.Progressbar_step = 0
    If uApp.Progressbar_steps_total = 0 Then uApp.Progressbar_steps_total = 11
    uApp.Progressbar_show = True
    Call ToolStripProgressBar1_set()

    If uOp.Called_from <> udtApplication_subroutine_names.End_game Then
      If uOp.Called_from = udtApplication_subroutine_names.Version_check Or uOp.Called_from = udtApplication_subroutine_names.Version_check_after_dialogue_tab Then
      Else
        uOp.Called_from = tLocals.Subr
      End If
      Call End_game()
    End If

    tLocals.Action = "Shut-down sequence completion"
    tLocals.Success = udtBoolean_extended.True_
    Call Log_write(tLocals, 0)

    uApp.App_name = ""
    Try
      End ' That's all, folks!
    Catch ex As Exception
      Stop ' Permanent.
      tLocals.Error_description = ex.Message
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_process
    End Try
    uOp.Event_ = ""
  End Sub
  Private Sub frmMain_GotFocus(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Me.GotFocus
    If uUser.First_run_wizard Then
      Stop ' Indefinite.
    Else
      tabHome.Focus()
    End If
  End Sub
  Private Sub frmMain_KeyPress(ByVal sender As Object, ByVal kp As System.Windows.Forms.KeyPressEventArgs) Handles Me.KeyPress
    Call Key_press_handle(kp)
    ' See C:\LivingInfo Systems\Dept 11A-2, Application development\0 Resources\Key_press_handle.txt.
  End Sub
  Private Sub frmMain_KeyUp(ByVal sender As Object, ByVal k As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
    Call Key_handle(k)
  End Sub
  Private Sub frmMain_Move(sender As Object, e As System.EventArgs) Handles Me.Move
    If uApp.App_name = "" Then Exit Sub
    Call Form_resize()
  End Sub
  Private Sub frmMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
    If uApp.App_name = "" Then Exit Sub
    If uApp.Initialising Then Exit Sub
    Call Form_resize()
  End Sub

  Private Sub MainMenu1_MouseHover(sender As Object, e As System.EventArgs) Handles MainMenu1.MouseHover
    txtCon_help.Text = "This is the Menu Bar." & vbCrLf
    txtCon_help.Text = txtCon_help.Text & "Most of the functions of " & uApp.App_name & " are in the tabs you see below me. Some additional functions are available in the menus. One useful example is Settings, in the Edit Menu, where you can select your preferences."
  End Sub
  Private Sub MainMenu1_MouseLeave(sender As Object, e As System.EventArgs) Handles MainMenu1.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
    uOp.Subr = "ExitToolStripMenuItem_Click"
    Me.Close()
  End Sub

  Public Sub SettingsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SettingsToolStripMenuItem.Click
    ' Revised 2016.03.06.
    If Not tabControl_main.TabPages.Contains(tabSettings) Then
      tabControl_main.TabPages.Insert(tabControl_main.TabPages.Count, tabSettings)
      uUser.Preferences_changed = True
    End If

    uUser.Tab_last = tabControl_main.SelectedTab.Name
    tabControl_main.SelectedIndex = tabControl_main.TabPages.IndexOf(tabSettings)
  End Sub

  Private Sub RefreshToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RefreshToolStripMenuItem.Click
    uOp.Event_ = "RefreshToolStripMenuItem_Click"
    Call Form_refresh(True)
    uOp.Event_ = ""
  End Sub

  Private Sub FirstRunWizardToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FirstRunWizardToolStripMenuItem.Click
    ' Written 2016.10.17. Revised 2020.12.08.
    Call btnSettings_first_run_wizard_Click(Nothing, Nothing)
  End Sub

  Private Sub SearchToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchToolStripMenuItem.Click
    ' Call File_detail_search()
  End Sub

  Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
    ' Revised 2016.03.06.
    uOp.Subr = "AboutToolStripMenuItem_Click"
    If Not tabControl_main.TabPages.Contains(tabAbout) Then
      tabControl_main.TabPages.Insert(tabControl_main.TabPages.Count, tabAbout)
      uUser.Preferences_changed = True
    End If
    uUser.Tab_last = tabControl_main.SelectedTab.Name
    tabControl_main.SelectedIndex = tabControl_main.TabPages.IndexOf(tabAbout)
    uOp.Subr = ""
  End Sub

  Private Sub EnterRegistrationCodeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnterRegistrationCodeToolStripMenuItem.Click
    ' Revised 2019.04.28.
    uOp.Subr = "EnterRegistrationCodeToolStripMenuItem_Click"
    Call Enter_registration_code()
    uOp.Subr = ""
  End Sub
  Public Sub Enter_registration_code_tool_strip_menu_item_visibility(ByVal tVisibility As Boolean)
    ' Separated 2020.02.06.
    EnterRegistrationCodeToolStripMenuItem.Visible = tVisibility
  End Sub
  Sub Enter_registration_code()
    ' Separated 2019.04.28. Revised 2021.05.02.
    uOp.Event_ = udtApplication_subroutine_names.Enter_registration_code
    uOp.Subr = uOp.Event_

    Call Inputbox_LIS_top("Please enter a registration code.", "", uOp.Subr)

    uOp.Result = Nothing
    uOp.Subr = ""
    uOp.Event_ = ""
  End Sub

  Private Sub AdministratorLoginToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AdministratorLoginToolStripMenuItem.Click
    If Not tabControl_main.TabPages.Contains(tabPassword) Then tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabPassword)
    tabControl_main.SelectedIndex = tabControl_main.TabPages.IndexOf(tabPassword)
  End Sub

  Private Sub NotifyIcon1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotifyIcon1.Click
    Call NotifyIcon1_DoubleClick(sender, e)
  End Sub
  Private Sub NotifyIcon1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotifyIcon1.DoubleClick
    ' Revised 2021.02.17.
    uOp.Subr = "NotifyIcon1_DoubleClick"

    NotifyIcon1.Visible = False
    Me.Show()

    If uUser.Main_top = 0 And uUser.Main_left = 0 And uUser.Main_height = 0 And uUser.Main_width = 0 Then
      Me.WindowState = FormWindowState.Maximized
    Else
      If uUser.Start_maximised Then
        Me.WindowState = FormWindowState.Maximized
      Else
        Me.WindowState = FormWindowState.Normal
        Me.Top = uUser.Main_top
        Me.Left = uUser.Main_left
        Me.Height = uUser.Main_height
        Me.Width = uUser.Main_width
      End If
    End If
    uOp.Subr = ""
  End Sub

  Sub Statuslabel1_set(Optional ByVal tStatus As String = "", Optional ByVal tSilent As Boolean = False)
    ' Revised 2021.03.07.
    ' Set uOp.Subr before calling me.
    ' tSilent:  Speech, or not.
    Dim tSubr As String = "Set status label 1"
    ToolStripStatusLabel1.ForeColor = Color.Black
    ToolStripStatusLabel1.Font = New Font(ToolStripStatusLabel1.Font, FontStyle.Regular)

    Call ToolStripProgressBar1_set(False)

    If udtuStandard_texts.Diagnostic <> "" And InStr(tStatus, udtuStandard_texts.Diagnostic) > 0 Then
      ToolStripStatusLabel1.Text = tStatus
    Else
      If uApp.Initialising Or uOp.Form_initialising Then
        If uMachine.Development_machine Or uMachine.Testing_machine Or uApp.Debug Or uOp.Administer Then
          If tStatus = "" Then
            If uOp.Subr = "" And Not uOp.Administer Then
              ToolStripStatusLabel1.Text = uApp.English_name & " is starting up..."
            Else
              ToolStripStatusLabel1.Text = uApp.English_name & ": " & uOp.Subr & ": working..."
            End If
          Else
            If IsNothing(uApp.English_name) Or uApp.English_name = "" Then
              ToolStripStatusLabel1.Text = tStatus
            Else
              ToolStripStatusLabel1.Text = uApp.English_name & ": " & tStatus
            End If
            If InStr(ToolStripStatusLabel1.Text, "working") > 0 Then
              ToolStripStatusLabel1.Text = ToolStripStatusLabel1.Text
            End If
          End If
        Else ' If uMachine.Development_machine Or uMachine.Testing_machine Or uApp.Debug Or uOp.Administer Then
          If uApp.English_name = "" Then
            ToolStripStatusLabel1.Text = "Starting up..."
          Else
            ToolStripStatusLabel1.Text = uApp.English_name & " is starting up..."
          End If
        End If ' If uMachine.Development_machine Or uMachine.Testing_machine Or uApp.Debug Or uOp.Administer Then
      Else ' If uApp.Initialising Or uOp.Form_initialising Then
        If tStatus = "" Then
          If uOp.Subr = "" Then
            Call Ready(Not tSilent)
          Else
            ToolStripStatusLabel1.Text = uApp.English_name & ": " & uOp.Subr & ": working..."
          End If
        Else
          If IsNothing(uApp.English_name) Or uApp.English_name = "" Then
            ToolStripStatusLabel1.Text = tStatus
          Else
            ToolStripStatusLabel1.Text = uApp.English_name & ": " & tStatus
            If InStr(ToolStripStatusLabel1.Text, "working") > 0 Then
              ToolStripStatusLabel1.Text = ToolStripStatusLabel1.Text
            End If
          End If
        End If
      End If ' If uApp.Initialising Then
    End If

    If uApp.Debug Then uOp.Result = ToolStripStatusLabel1.Text
    Me.Refresh()
  End Sub
  Sub Statuslabel1_set(ByVal tStatus1 As String, ByVal tColour As Color, Optional ByRef tStyle As FontStyle = FontStyle.Regular)
    ' Revised 2021.03.07.
    ' Colour.Black, FontStyle.Regular
    Dim tSubr As String = "Set status label 1"
    Call ToolStripProgressBar1_set(False)

    If tStatus1 = "" Then
      ToolStripStatusLabel1.Text = uApp.Internal_name & " status: Ready."
    Else
      ToolStripStatusLabel1.Text = tStatus1
    End If
    ToolStripStatusLabel1.ForeColor = tColour
    ToolStripStatusLabel1.Font = New Font(ToolStripStatusLabel1.Font, tStyle)

    If uApp.Debug Then uOp.Result = ToolStripStatusLabel1.Text
    Me.Refresh()
  End Sub
  Sub Statuslabel1_failed(ByVal tSubr As String)
    Call Statuslabel1_set(tSubr & " failed.", Color.Red, FontStyle.Bold)
  End Sub
  Sub ToolStripProgressBar1_set(Optional tRefresh As Boolean = True)
    ' Written MJBH 2019.06.22. Revised 2021.01.05.
    Dim tSubr As String = "ToolStripProgressBar1 set"

    If uApp.Progressbar_show Then
      uApp.Progressbar_step = uApp.Progressbar_step + 1
      If uApp.Progressbar_step > uApp.Progressbar_steps_total Then
        Stop ' Permanent.
        uApp.Progressbar_steps_total = uApp.Progressbar_step
      End If
      ToolStripProgressBar1.Enabled = True
      ToolStripProgressBar1.Visible = True
      If uApp.Progressbar_steps_total > 0 Then ToolStripProgressBar1.Maximum = uApp.Progressbar_steps_total
      ToolStripProgressBar1.Value = uApp.Progressbar_step
    Else
      uApp.Progressbar_step = 0
      uApp.Progressbar_steps_difference = 0
      uApp.Progressbar_steps_total = 0
      ToolStripProgressBar1.Enabled = False
      ToolStripProgressBar1.Visible = False
    End If
    uApp.Progressbar_steps_difference = uApp.Progressbar_steps_total - uApp.Progressbar_step
    If tRefresh Then Me.Refresh()
  End Sub
  Sub Statuslabel2_set(Optional ByVal tStatus As String = "", Optional ByVal tColour As Color = Nothing)
    ' Written MJBH 2017.01.04. Revised 2021.03.07.
    Dim tLocals As udtLocals = Nothing
    Dim tVersion As String = ""
    tLocals.Subr = "Set status label 2"
    ToolStripStatusLabel2.ForeColor = Color.Black
    If tColour <> Nothing Then ToolStripStatusLabel2.ForeColor = tColour
    ToolStripStatusLabel2.Font = New Font(ToolStripStatusLabel1.Font, FontStyle.Regular)

    tVersion = "Version " & Application.ProductVersion
    If uOp.Form_initialising Then If uApp.App_build_number > 0 Then tVersion = tVersion & ", build: " & uApp.App_build_number
    If uApp.App_revision_date <> udtuStandard_texts.Time_null Then tVersion = tVersion & ", " & uApp.App_revision_date & "."
    If VB.Right(tVersion, 1) <> "." Then tVersion = tVersion & "."

    If tStatus = udtuStandard_texts.Upgrading Then
      ' Don't change it.
    ElseIf uOp.Form_initialising Then
      tStatus = tVersion
      If uUser.First_run_wizard And uDialogue.Active = False Then tStatus = tStatus & " First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & "."
    ElseIf uUser.First_run_wizard Then
      tStatus = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & ". " & tStatus
      ToolStripStatusLabel2.ForeColor = Color.Red
    Else
      Select Case tabControl_main.SelectedTab.Name
        ' Common tabs:
        Case tabHome.Name
        Case tabAbout.Name
        Case tabDiagnostic.Name
        Case tabPassword.Name
        Case tabMemory_query.Name
          ' tStatus = "Records found: " & txtMemory_query_result.Lines.Length
          tStatus = "Records found: " & uMemory.Rows_affected & "."
        Case tabSettings.Name
        Case tabSystem_information.Name

          ' Application specific tabs:
        Case tabMusic.Name
          If tStatus = "" And gMusic.Message <> "" Then tStatus = gMusic.Message
        Case tabPlay.Name
        Case Else
          tLocals.Msg = tabControl_main.SelectedTab.Name
          Stop ' Permanent.
      End Select
    End If
    If tStatus = "" Then tStatus = tVersion
    ToolStripStatusLabel2.Text = tStatus

    If uApp.Debug Then tLocals.Msg = Len(ToolStripStatusLabel2.Text)
    If Len(ToolStripStatusLabel2.Text) <= 30 Then
      ToolStripStatusLabel2.Width = 210
    ElseIf Len(ToolStripStatusLabel2.Text) <= 40 Then
      ToolStripStatusLabel2.Width = 250
    ElseIf Len(ToolStripStatusLabel2.Text) <= 60 Then
      ToolStripStatusLabel2.Width = 400
    ElseIf Len(ToolStripStatusLabel2.Text) <= 70 Then
      ToolStripStatusLabel2.Width = 420
    ElseIf Len(ToolStripStatusLabel2.Text) <= 80 Then
      ToolStripStatusLabel2.Width = 440
    ElseIf Len(ToolStripStatusLabel2.Text) <= 100 Then
      ToolStripStatusLabel2.Width = 480
    Else
      Stop ' Indefinite.
    End If

    If uApp.Debug Then uOp.Result = ToolStripStatusLabel2.Text
    Me.Refresh()
  End Sub
  Sub Statusbar_set(ByVal tStatus1 As String, ByRef tColour1 As Color, ByRef tStyle1 As FontStyle, ByRef tStatus2 As String, ByRef tColour2 As Color, ByRef tStyle2 As FontStyle)
    ' Revised 2021.03.04.
    uOp.Subr = "Set statusbar"

    If tStatus1 = "" Then
      ToolStripStatusLabel1.Text = uApp.App_name & " status: Ready."
    Else
      ToolStripStatusLabel1.Text = tStatus1
    End If
    ToolStripStatusLabel1.ForeColor = tColour1
    ToolStripStatusLabel1.Font = New Font(ToolStripStatusLabel2.Font, tStyle1)

    Call Statuslabel2_set(tStatus2, tColour2)
    ToolStripStatusLabel2.Font = New Font(ToolStripStatusLabel2.Font, tStyle2)

    uOp.Result = ToolStripStatusLabel2.Text
    Me.Refresh()
    uOp.Subr = ""
  End Sub
  Private Sub StatusStrip1_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles staStatusStrip1.MouseHover
    txtCon_help.Text = "The Status Strip gives the current status of " & uApp.App_name & "." & vbCrLf
    txtCon_help.Text = txtCon_help.Text & "The current status is:" & vbCrLf
    txtCon_help.Text = txtCon_help.Text & ToolStripStatusLabel1.Text
  End Sub
  Private Sub StatusStrip1_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles staStatusStrip1.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub ToolStripStatusLabel2_MouseHover(sender As Object, e As System.EventArgs) Handles ToolStripStatusLabel2.MouseHover
    txtCon_help.Text = "This section of the status bar shows the version of " & uApp.App_name & ", or something about the contents of the current tab."
  End Sub
  Private Sub ToolStripStatusLabel2_MouseLeave(sender As Object, e As System.EventArgs) Handles ToolStripStatusLabel2.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub ToolStripStatusLabel3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripStatusLabel3.Click
    ' Revised 2021.03.17.
    uOp.Subr = "ToolStripStatusLabel3_Click"
    If uApp.Debug Then uOp.Result = Get_default_browser_fn()
    Process.Start(ToolStripStatusLabel3.Text)
    ToolStripStatusLabel3.LinkVisited = True
    uOp.Subr = ""
  End Sub
  Private Sub ToolStripStatusLabel3_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripStatusLabel3.MouseHover
    txtCon_help.Text = "Click here to jump to the " & udtLivingInfoSystems.Name_short & " web site."
  End Sub
  Private Sub ToolStripStatusLabel3_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripStatusLabel3.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

#End Region ' End region, "Form element events."

#Region "Form common sub-routines"
  ' Revised 2021.01.13.

  Sub Form_minimum_size()
    ' Separated 2017.01.03. Revised 2021.03.04.
    ' No height higher than 735, to allow for smaller screen sizes.
    Dim tMe_MinimumSize_height As Short = Me.MinimumSize.Height
    Dim tMe_MinimumSize_width As Short = Me.MinimumSize.Width
    uOp.Subr = "Me minimum size"

    Select Case tabControl_main.SelectedTab.Name
      ' Common tabs:
      Case tabHome.Name
      Case tabAbout.Name
      Case tabDiagnostic.Name
      Case tabPassword.Name
      Case tabMemory_query.Name
        Stop ' Indefinite.
      Case tabSettings.Name
      Case tabSystem_information.Name

        ' Application specific tabs:
      Case Else
        Stop ' Permanent.
    End Select

    uOp.Subr = ""
  End Sub

  Private Sub Form_resize()
    ' Revised 2021.04.04.
    Dim tLocals As udtLocals = Nothing
    If uApp.App_name = "" Or uApp.Initialising Or uOp.Form_initialising Then Exit Sub ' Runs before I want it to.
    tLocals.Subr = "frmMain_Resize"
    Dim tMy_computer_screen_bounds_height As Integer = My.Computer.Screen.Bounds.Height
    Dim tMy_computer_screen_bounds_width As Integer = My.Computer.Screen.Bounds.Width
    Dim tMy_computer_screen_working_area_height As Integer = My.Computer.Screen.WorkingArea.Height
    Dim tMy_computer_screen_working_area_width As Integer = My.Computer.Screen.WorkingArea.Width
    Dim tMe_window_state As Integer = Me.WindowState
    Dim tMe_top As Integer = Me.Top
    Dim tMe_left As Integer = Me.Left
    Dim tMe_height As Integer = Me.Height
    Dim tMe_width As Integer = Me.Width

    Select Case Me.WindowState
      Case FormWindowState.Minimized
        If uUser.Min_sys_tray Then
          Me.Hide()
          NotifyIcon1.Visible = True
        End If
      Case FormWindowState.Maximized
        NotifyIcon1.Visible = False
        If Me.Left < 10 Or Me.Left > (My.Computer.Screen.Bounds.Width - 10) Then
          ' Moved from one screen to another.
          'uUser.Main_top = Me.Top
          'uUser.Main_left = Me.Left
          'uUser.Main_height = Me.Height
          'uUser.Main_width = Me.Width
        End If

      Case FormWindowState.Normal
        If uOp.Form_initialising Then
          Me.Top = uUser.Main_top
          Me.Left = uUser.Main_left
          Me.Height = uUser.Main_height
          Me.Width = uUser.Main_width
        Else
          If Me.Top < (uApp.Default_top + 10) Then Me.Top = uApp.Default_top
          If Me.Left <= 2 Then Me.Left = uApp.Default_left
          If (Me.Top + Me.Height) > (My.Computer.Screen.Bounds.Height - 10) Then
            Me.Height = My.Computer.Screen.Bounds.Height - Me.Top
          End If
          If (Me.Left + Me.Width) > (My.Computer.Screen.Bounds.Width - 10) And (Me.Left + Me.Width) < (My.Computer.Screen.Bounds.Width + 20) Then
            Me.Width = My.Computer.Screen.Bounds.Width - Me.Left
          End If
          If Me.Height > My.Computer.Screen.Bounds.Height - uApp.Default_top Then Me.Height = My.Computer.Screen.Bounds.Height - uApp.Default_top
          uUser.Main_top = Me.Top
          uUser.Main_left = Me.Left
          uUser.Main_height = Me.Height
          uUser.Main_width = Me.Width
        End If
    End Select

    If uApp.Debug Then
      tLocals.Msg = NotifyIcon1.Visible
      tMe_window_state = Me.WindowState
      tMe_top = Me.Top
      tMe_left = Me.Left
      tMe_height = Me.Height
      tMe_width = Me.Width
    End If

    uOp.Subr = ""
  End Sub

  Private Sub Key_handle(ByRef k As KeyEventArgs)
    ' Separated 2020.11.04. Revised 2011.04.11.
    ' Tests for k.(modifier key), rather than Control.ModifierKeys.
    ' Set the KeyPressEventArgs.Handled property in your form's KeyPress event-handling method to true.
    Dim tLocals As udtLocals = Nothing
    If uOp.Event_ = "" Then uOp.Event_ = udtApplication_subroutine_names.Key_handle
    tLocals.Subr = uOp.Event_
    If uApp.Debug Then
      tLocals.Msg = k.ToString
      tLocals.Msg = Chr(k.KeyCode)
      tLocals.Msg = k.KeyCode
      tLocals.Msg = k.KeyData
      tLocals.Msg = k.KeyValue
      tLocals.Msg = k.Modifiers
      tLocals.Msg = k.Shift
      tLocals.Msg = k.Control
      tLocals.Msg = k.Alt
    End If
    If k.Handled Then GoTo Ender_full

    If k.Control And Not k.Shift And Not k.Alt Then

      Select Case k.KeyValue
        Case Keys.D1, Keys.D2, Keys.D3, Keys.D4, Keys.D5, Keys.D6, Keys.D7, Keys.D8, Keys.D9
          Dim tDecimal As Short = k.KeyValue - 48
          If tDecimal <= 0 Then
            tabControl_main.SelectTab(0)
          ElseIf tDecimal = 9 Then
            tabControl_main.SelectTab(tabControl_main.TabCount - 1)
          Else
            If tDecimal <= tabControl_main.TabCount Then
              tabControl_main.SelectTab(tDecimal - 1)
            Else
              tabControl_main.SelectTab(tabControl_main.TabCount)
            End If
          End If
          k.Handled = True

        Case Keys.NumPad1, Keys.NumPad2, Keys.NumPad3, Keys.NumPad4, Keys.NumPad5, Keys.NumPad6, Keys.NumPad7, Keys.NumPad8, Keys.NumPad9
          Dim tDecimal As Short = k.KeyValue - 96
          If tDecimal <= 0 Then
            tabControl_main.SelectTab(0)
          ElseIf tDecimal = 9 Then
            tabControl_main.SelectTab(tabControl_main.TabCount - 1)
          Else
            If tDecimal <= tabControl_main.TabCount Then
              tabControl_main.SelectTab(tDecimal - 1)
            Else
              tabControl_main.SelectTab(tabControl_main.TabCount)
            End If
          End If
          k.Handled = True

        Case Keys.PageUp
          If tabControl_main.SelectedIndex = tabControl_main.TabCount Then
            tabControl_main.SelectedIndex = 1
          Else
            tabControl_main.SelectedIndex = tabControl_main.SelectedIndex + 1
          End If
          k.Handled = True

        Case Keys.PageDown
          If tabControl_main.SelectedIndex = 1 Then
            tabControl_main.SelectedIndex = tabControl_main.TabCount
          Else
            tabControl_main.SelectedIndex = tabControl_main.SelectedIndex - 1
          End If
          k.Handled = True

      End Select

    ElseIf k.Alt And Not k.Shift And Not k.Control Then

    Else ' No modifier.
      Select Case k.KeyValue

        Case Keys.Escape
          ' Specific handlings for each tab as needed.
          Select Case tabControl_main.SelectedTab.Name
            Case tabHome.Name
              ' Case Else
              ' Call End_game()
          End Select
          k.Handled = True

        Case Keys.F1 ' 112.
          txtCon_help.Text = uCon_help.F1_default
          k.Handled = True

        Case Keys.F5 ' Refresh.
          Call Form_refresh(True)
          uOp.Subr = tLocals.Subr
          k.Handled = True

        Case Else
          ' k.Handled = True
      End Select

    End If
    ' k.Handled = True

Ender_full:
    uOp.Subr = ""
    If uOp.Event_ = tLocals.Subr Then uOp.Event_ = ""
  End Sub

  Private Sub Key_press_handle(ByRef kp As KeyPressEventArgs)
    ' Revised 2021.02.17.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.Key_handle
    If uOp.Event_ = "" Then uOp.Event_ = tLocals.Subr
    If uApp.Debug Then
      tLocals.Msg = kp.ToString
      tLocals.Msg = kp.KeyChar
    End If
    If kp.Handled Then GoTo Ender_full

    Select Case Control.ModifierKeys
      Case Keys.Shift

      Case Keys.ControlKey, Keys.Control ' 17, 131072.
        Select Case kp.KeyChar
          Case Keys.Tab.ToString
          Case Keys.D1.ToString, Keys.D2.ToString, Keys.D3.ToString, Keys.D4.ToString, Keys.D5.ToString, Keys.D6.ToString, Keys.D7.ToString, Keys.D8.ToString, Keys.D9.ToString
            Dim tDecimal As Short = kp.KeyChar.ToString - 48
            If tDecimal <= 0 Then
              tabControl_main.SelectTab(0)
            ElseIf tDecimal = 9 Then
              tabControl_main.SelectTab(tabControl_main.TabCount - 1)
            Else
              If tDecimal <= tabControl_main.TabCount Then
                tabControl_main.SelectTab(tDecimal - 1)
              Else
                tabControl_main.SelectTab(tabControl_main.TabCount)
              End If
            End If
            kp.Handled = True

          Case Keys.NumPad1.ToString, Keys.NumPad2.ToString, Keys.NumPad3.ToString, Keys.NumPad4.ToString, Keys.NumPad5.ToString, Keys.NumPad6.ToString, Keys.NumPad7.ToString, Keys.NumPad8.ToString, Keys.NumPad9.ToString
            Dim tDecimal As Short = kp.KeyChar.ToString - 96
            If tDecimal <= 0 Then
              tabControl_main.SelectTab(0)
            ElseIf tDecimal = 9 Then
              tabControl_main.SelectTab(tabControl_main.TabCount - 1)
            Else
              If tDecimal <= tabControl_main.TabCount Then
                tabControl_main.SelectTab(tDecimal - 1)
              Else
                tabControl_main.SelectTab(tabControl_main.TabCount)
              End If
            End If
            kp.Handled = True

          Case Keys.PageUp.ToString
            If tabControl_main.SelectedIndex = tabControl_main.TabCount Then
              tabControl_main.SelectedIndex = 1
            Else
              tabControl_main.SelectedIndex = tabControl_main.SelectedIndex + 1
            End If
            kp.Handled = True

          Case Keys.PageDown.ToString
            If tabControl_main.SelectedIndex = 1 Then
              tabControl_main.SelectedIndex = tabControl_main.TabCount
            Else
              tabControl_main.SelectedIndex = tabControl_main.SelectedIndex - 1
            End If
            kp.Handled = True

        End Select

      Case Keys.Alt

      Case Else ' No modifier.
        Select Case kp.KeyChar
          ' Alphabetical.

          Case Keys.Escape.ToString
            Select Case tabControl_main.SelectedTab.Name
              ' Specific handlings for each tab as needed.
              Case Else
                Stop ' To develop.
            End Select
            kp.Handled = True

          Case Keys.F1.ToString ' 112.
            txtCon_help.Text = uCon_help.F1_default
            kp.Handled = True

          Case Keys.F5.ToString ' Refresh.
            Call Form_refresh(True)
            kp.Handled = True

          Case Else
            ' kp.Handled = True ' Messes with entering text into a text field.
        End Select
    End Select
    ' k.Handled = True

Ender_full:
    uOp.Subr = ""
    If uOp.Event_ = tLocals.Subr Then uOp.Event_ = ""
  End Sub

#End Region ' End region, "Form common sub-routines."

#Region "tabControl_top"

  Private Sub tabControl_top_tabs_hide()
    ' Separated MJBH 2020.03.13. Revised 2021.01.24.
    uOp.Subr = "Hide tabControl_top tabs"

    tabControl_main.TabPages.Remove(tabFirst_run_wizard)

    uOp.Success = True
    ' Call Log_write(tLocals, 0) ' Too early.
    uOp.Subr = ""
  End Sub

  Private Sub tabControl_top_tabs_show()
    ' Separated 2020.03.13. Revised 2021.04.27.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.tabControl_top_tabs_show
    On Error GoTo Error_captured
    uOp.Subr = tLocals.Subr
    If uOp.Called_from = "" Then uOp.Called_from = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start
    If (uUser.First_run_wizard Or uUser.First_run_wizard_completed = False) And uOp.Called_from <> udtApplication_subroutine_names.Top_dialogue_preparation Then
      tLocals.Action = "Show " & tabFirst_run_wizard.Name
      top_split_container.SplitterDistance = top_split_container.Width * 2 / 3
      If Not tabControl_top.TabPages.Contains(tabFirst_run_wizard) Then
        tLocals.Action = "Insert tabFirst_run_wizard"
        tabControl_top.TabPages.Insert(tabControl_top.TabCount, tabFirst_run_wizard)
      End If
      tLocals.Action = "Select tabFirst_run_wizard"
      tabControl_top.SelectTab(tabFirst_run_wizard.Name)
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Cancelled
        tLocals.Success = udtBoolean_extended.False_
        GoTo Ender_partial
      End If
      uOp.Success = False

    Else
      tLocals.Action = "Show " & tabMain.Name
      If Not tabControl_top.TabPages.Contains(tabMain) Then
        tLocals.Action = "Insert tabMain"
        tabControl_top.TabPages.Insert(tabControl_top.TabCount, tabMain)
      End If
      tLocals.Action = "Select tabMain"
      tabControl_top.SelectTab(tabMain.Name)
      If uOp.Subr <> tLocals.Subr Then
        If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Status = udtuStandard_texts.Cancelled
          tLocals.Success = udtBoolean_extended.False_
          GoTo Ender_partial
        End If
      End If

    End If
    uOp.Subr = tLocals.Subr
    If uDialogue.Active Then
      tLocals.Success = udtBoolean_extended.True_
      GoTo Ender_partial
    End If

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Then
      Stop ' Indefinite.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case Else
            Stop ' Permanent.
            Call Error_display(tLocals)
        End Select
      End If
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or tLocals.Success = udtBoolean_extended.False_ Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If
    Call Log_write(tLocals, 0)

Ender_partial:
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub tabControl_top_SelectedIndexChanged(sender As Object, e As System.EventArgs) Handles tabControl_top.SelectedIndexChanged
    ' Written 2020.03.01. Revised 2021.03.28.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.tabControl_top_SelectedIndexChanged
    If uOp.Event_ = "" Then uOp.Event_ = tLocals.Subr
    uOp.Subr = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start

    If IsNothing(tabControl_top.SelectedTab) Then
      tabControl_top.TabPages.Insert(tabControl_top.TabCount, tabMain)
    End If

    tLocals.Action = "Activate " & tabControl_top.SelectedTab.Name
    tLocals.Success = udtBoolean_extended.True_
    Call Log_write(tLocals, 0)
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    tLocals.Msg = frmMain_splitcontainer.SplitterDistance

    Select Case tabControl_top.SelectedTab.Name
      Case tabMain.Name
        ' frmMain_splitcontainer.SplitterDistance = 148

      Case tabFirst_run_wizard.Name
        tabControl_top.TabPages.Remove(tabMain)
        Call tabFirst_run_wizard_preparation()
        uOp.Subr = tLocals.Subr
        If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Status = udtuStandard_texts.Failed
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process
        End If
        uOp.Success = False

      Case Else
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process

    End Select

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
    If uOp.Event_ = tLocals.Subr Then uOp.Event_ = ""
  End Sub

#Region "tab Main"

#Region "Top dialogue"
  ' Region written MJBH 2019.03.07. Revised 2021.05.02.

  Sub Top_dialogue_preparation()
    ' Written MJBH 2019.03.07. Revised 2021.03.14.
    Dim tLocals As udtLocals = Nothing
    Dim tFrmMain_splitcontainer_splitter_distance As Integer

    If uDialogue.Active Then
      Stop ' Permanent.
      GoTo Ender_partial
    End If

    tLocals.Subr = udtApplication_subroutine_names.Top_dialogue_preparation
    If uOp.Called_from = tLocals.Subr Then GoTo Ender_full
    tFrmMain_splitcontainer_splitter_distance = 0
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr
    uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 1

    tLocals.Action = "Check, set basics"
    tLocals.Response = Nothing
    If uDialogue.Alert = 0 Then
      Stop ' Permanent.
      uDialogue.Prompt = "Please ensure that uDialogue.Alert is set."
      uDialogue.Alert = udtAlert_types.Critical
      uDialogue.Dialogue_type = udtDialogue_types.Okay_only
    End If
    If uDialogue.Called_from = "" Then
      Stop ' Permanent.
      uDialogue.Prompt = "Please ensure that uDialogue.Called_from is set."
      uDialogue.Alert = udtAlert_types.Critical
      uDialogue.Dialogue_type = udtDialogue_types.Okay_only
    End If
    If uDialogue.Dialogue_type = 0 Then
      Stop ' Permanent.
      uDialogue.Prompt = "Please ensure that uDialogue.Dialogue_type is set."
      uDialogue.Alert = udtAlert_types.Critical
      uDialogue.Dialogue_type = udtDialogue_types.Okay_only
    End If
    uDialogue.Dialogue_result = Nothing

    tLocals.Action = "Set form items"
    tabControl_main.Enabled = False
    ' To do: Priority: Low. Display animation:
    top_split_container.Panel1Collapsed = False
    tFrmMain_splitcontainer_splitter_distance = top_split_container.Width / 2
    If Len(uDialogue.Prompt) <= 170 And tFrmMain_splitcontainer_splitter_distance < 160 Then
      tFrmMain_splitcontainer_splitter_distance = 160
    ElseIf Len(uDialogue.Prompt) <= 265 And tFrmMain_splitcontainer_splitter_distance < 180 Then
      tFrmMain_splitcontainer_splitter_distance = 180
    Else
      tFrmMain_splitcontainer_splitter_distance = 190
    End If
    frmMain_splitcontainer.SplitterDistance = tFrmMain_splitcontainer_splitter_distance
    If top_split_container.SplitterDistance < 600 Then top_split_container.SplitterDistance = 600

    Call tabControl_top_tabs_show()
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    Top_dialogue_groupbox.Text = uApp.App_name & ": Dialogue:"
    Top_dialogue_txtPrompt.Text = uDialogue.Prompt
    Top_dialogue_txtResponse.Visible = False
    Top_dialogue_cboResponse.Visible = False
    Top_dialogue_cboResponse.SelectedIndex = -1
    Top_dialogue_cboResponse.Text = ""
    Top_dialogue_okay_button.Enabled = True
    Top_dialogue_cancel_button.Visible = True

    tLocals.Action = "Apply dialogue type logo"
    Select Case uDialogue.Alert
      Case udtAlert_types.Critical
        Top_dialogue_PictureBox1.Image = My.Resources.Critical
        If uDialogue.Called_from <> udtApplication_subroutine_names.Error_display Then
          Call Sound_alert(True)
        End If
      Case udtAlert_types.Exclamation
        Top_dialogue_PictureBox1.Image = My.Resources.Exclamation
        ' Case udtAlert_types.Information
      Case Else
        ' Default to Information if not set.
        Top_dialogue_PictureBox1.Image = My.Resources.Information
    End Select
    Top_dialogue_PictureBox1.SizeMode = PictureBoxSizeMode.StretchImage

    Top_dialogue_okay_button.Text = "&Okay"
    Top_dialogue_cancel_button.Text = "&Cancel"
    Select Case uDialogue.Dialogue_type
      Case udtDialogue_types.Chooser
        Top_dialogue_cboResponse.Left = 21
        Top_dialogue_cboResponse.Enabled = True
        Top_dialogue_cboResponse.Visible = True
        Top_dialogue_okay_button.Enabled = False ' Until something is selected.
        Top_dialogue_cboResponse.Focus()
      Case udtDialogue_types.Okay_only
        Top_dialogue_txtResponse.Width = Top_dialogue_txtPrompt.Width
        Top_dialogue_cancel_button.Visible = False
        Top_dialogue_okay_button.Focus()
      Case udtDialogue_types.Okay_cancel
        Top_dialogue_txtResponse.Width = Top_dialogue_txtPrompt.Width
        Top_dialogue_okay_button.Focus()
      Case udtDialogue_types.Yes_no
        Top_dialogue_txtResponse.Visible = False
        Top_dialogue_okay_button.Text = "&Yes"
        Top_dialogue_cancel_button.Text = "&No"
      Case udtDialogue_types.Question
        Top_dialogue_txtResponse.Width = Top_dialogue_txtPrompt.Width
        Top_dialogue_txtResponse.Enabled = True
        Top_dialogue_txtResponse.Visible = True
        Top_dialogue_txtResponse.Text = uDialogue.Response_str
        Top_dialogue_txtResponse.Focus()
      Case Else
        tLocals.Msg = uDialogue.Dialogue_type
        Stop ' Indefinite.
    End Select

    Top_dialogue_okay_button.BackColor = uApp.Colours.Okay
    Top_dialogue_cancel_button.BackColor = uApp.Colours.Cancel
    Me.AcceptButton = Top_dialogue_okay_button
    Me.CancelButton = Top_dialogue_cancel_button
    btnContext_more.Visible = False
    tabControl_main.Enabled = False

    uDialogue.Active = True

Error_process:
    If tLocals.Error_count <> 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
      uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
    End If

Ender_full:
    Me.Refresh()
    If uDialogue.Prompt = "Please ensure that uDialogue.Called_from is set." Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_handler
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If

Ender_partial:
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub Top_dialogue_PictureBox1_MouseHover(sender As Object, e As System.EventArgs) Handles Top_dialogue_PictureBox1.MouseHover
    txtCon_help.Text = "This is the type of dialogue; it can be Critical, Exclamation, or Information."
  End Sub
  Private Sub Top_dialogue_PictureBox1_MouseLeave(sender As Object, e As System.EventArgs) Handles Top_dialogue_PictureBox1.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub Top_dialogue_txtPrompt_MouseHover(sender As Object, e As System.EventArgs) Handles Top_dialogue_txtPrompt.MouseHover
    txtCon_help.Text = udtDialogue.txtPrompt_MouseHover
  End Sub
  Private Sub Top_dialogue_txtPrompt_MouseLeave(sender As Object, e As System.EventArgs) Handles Top_dialogue_txtPrompt.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub Top_dialogue_txtResponse_MouseHover(sender As Object, e As System.EventArgs) Handles Top_dialogue_txtResponse.MouseHover
    If uDialogue.Response_str = "" Then
      txtCon_help.Text = "Please enter a value or answer, and select Okay when you are ready."
    Else
      txtCon_help.Text = "This is a suggested response."
    End If
  End Sub
  Private Sub Top_dialogue_txtResponse_MouseLeave(sender As Object, e As System.EventArgs) Handles Top_dialogue_txtResponse.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub Top_dialogue_cboResponse_MouseHover(sender As Object, e As System.EventArgs) Handles Top_dialogue_cboResponse.MouseHover
    txtCon_help.Text = udtDialogue.cboResponse_MouseHover
  End Sub
  Private Sub Top_dialogue_cboResponse_MouseLeave(sender As Object, e As System.EventArgs) Handles Top_dialogue_cboResponse.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub Top_dialogue_cboResponse_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles Top_dialogue_cboResponse.SelectedIndexChanged
    Stop
  End Sub

  Private Sub Top_dialogue_okay_button_Click(sender As System.Object, e As System.EventArgs) Handles Top_dialogue_okay_button.Click
    uOp.Event_ = "Top_dialogue_okay_button_Click"
    Call Top_dialogue_okay_button_Click_handler()
    uOp.Event_ = ""
  End Sub
  Private Sub Top_dialogue_okay_button_MouseHover(sender As Object, e As System.EventArgs) Handles Top_dialogue_okay_button.MouseHover
    txtCon_help.Text = udtDialogue.Okay_button_MouseHover
  End Sub
  Private Sub Top_dialogue_okay_button_MouseLeave(sender As Object, e As System.EventArgs) Handles Top_dialogue_okay_button.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Public Sub Top_dialogue_okay_button_Click_handler()
    ' Copied and revised from tabDialogue 2019.03.15. Separated 2019.08.10. Revised 2021.05.02.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.top_dialogue_okay_button_Click_handler
    uOp.Subr = tLocals.Subr
    tLocals.Success = udtBoolean_extended.False_
    uDialogue.Active = False

    uDialogue.Dialogue_result = DialogResult.OK
    Select Case uDialogue.Dialogue_type
      Case udtDialogue_types.Chooser
        uDialogue.Response_str = Trim(Top_dialogue_cboResponse.Text)
        uDialogue.Response_num = Top_dialogue_cboResponse.SelectedIndex
        If uDialogue.Response_str = "" Or uDialogue.Response_num = -1 Then
          Stop
        End If
      Case udtDialogue_types.Okay_only
        uDialogue.Response_str = Nothing
      Case udtDialogue_types.Okay_cancel
        uDialogue.Response_str = Nothing
      Case udtDialogue_types.Question
        uDialogue.Response_str = Trim(Top_dialogue_txtResponse.Text)
      Case udtDialogue_types.Yes_no
      Case Else
        Stop ' Permanent.
    End Select

    tLocals.Action = "Hide top dialogue"
    top_split_container.Panel1Collapsed = True
    tabControl_main.Enabled = True
    uDialogue.Active = False
    btnContext_more.Visible = True
    Call Context_sensitive_help_set()
    uOp.Subr = tLocals.Subr

    tLocals.Action = "Some question"
    Select Case uDialogue.Called_from

      ' Any sub. except from frmMain, alphabetical:

      Case udtApplication_subroutine_names.Operating_system_determine
        uApp.Terminating = uApp.Terminating + 1

      Case udtApplication_subroutine_names.App_revision_upgrade
        Stop ' Indefinite.
        '  If uApp.App_revision_date < #10/14/2018# Then uApp.App_revision_date = #10/14/2018#

      Case udtApplication_subroutine_names.Check_run_count
        Call Run_count_check_after_dialogue_tab()

      Case udtApplication_subroutine_names.Check_run_count_local
        Call Run_count_check_local_after_dialogue_tab()

      Case udtApplication_subroutine_names.Database_general
        uApp.Terminating = uApp.Terminating + 1

      Case udtApplication_subroutine_names.Environment_dump
        ' No action needed, continue.

      Case udtApplication_subroutine_names.Error_display
        uApp.Terminating = uApp.Terminating + 1

      Case udtApplication_subroutine_names.First_run_check_resources
        uApp.Terminating = uApp.Terminating + 1

      Case udtApplication_subroutine_names.First_run_make_folders
        uApp.Terminating = uApp.Terminating + 1

      Case udtApplication_subroutine_names.Preferences_load
        If InStr(uDialogue.Prompt, "This is not the latest version of ") > 0 Then
          uApp.Terminating = uApp.Terminating + 1
        Else
          Stop ' Permanent.
        End If

      Case udtApplication_subroutine_names.Registration
        uReg.Message_reported = True
        Call Register(uDialogue.Response_str)
        If uDialogue.Active Then GoTo Ender_full

      Case udtApplication_subroutine_names.Register
        uReg.Message_reported = True

      Case udtApplication_subroutine_names.Registration_request_email
        ' No action needed, continue.

      Case udtApplication_subroutine_names.Registration_validate_email_fn
        If InStr(uDialogue.Prompt, "The submitted email") > 0 And InStr(uDialogue.Prompt, "was determined to be invalid.") > 0 Or uDialogue.Response_str = "" Then
          uApp.Terminating = uApp.Terminating + 1
        Else
          uReg.Email_address = uDialogue.Response_str
          Call Registration_request()
          uOp.Subr = tLocals.Subr
          If uDialogue.Active Then GoTo Ender_full
        End If

      Case udtApplication_subroutine_names.Version_check
        Call Version_check_after_dialogue_tab()

        ' Any sub. from frmMain, alphabetical:

      Case udtApplication_subroutine_names.Enter_registration_code
        uReg.Message_reported = True
        Call Register(uDialogue.Response_str)

      Case udtApplication_subroutine_names.Form_load
        uApp.Terminating = uApp.Terminating + 1

      Case Else
        If uDialogue.Prompt = "Please ensure that uDialogue.Called_from is set." Then
          uApp.Terminating = uApp.Terminating + 1
          Me.Close()
        Else
          tLocals.Msg = uDialogue.Called_from
        End If
        If uDialogue.Called_from <> "" Then Call Clipboard_copy_to(uDialogue.Called_from)
        Stop ' Permanent.
    End Select
    Call Dialogue_clear(False)

    If uUser.Preferences_changed Then Call Preferences_write()
    uOp.Subr = tLocals.Subr

    If uApp.Terminating = 0 Then
      uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 3
      uOp.Called_from = tLocals.Subr
      Call frmMain_Load_part_02()
      uOp.Subr = tLocals.Subr
    Else
      Me.Close()
    End If

Ender_full:
    ' Call Dialogue_clear ' Causes a fail if a second dialogue is called straight after a previous one.
    uOp.Subr = tLocals.Subr

    uOp.Subr = ""
  End Sub

  Public Sub Top_dialogue_cancel_button_Click(sender As System.Object, e As System.EventArgs) Handles Top_dialogue_cancel_button.Click
    ' Copied and revised from tabDialogue 2019.03.15. Revised 2021.05.01.
    Dim tLocals As udtLocals = Nothing
    uOp.Event_ = udtApplication_subroutine_names.top_dialogue_cancel_button_Click
    tLocals.Subr = uOp.Event_
    uOp.Subr = tLocals.Subr
    uDialogue.Active = False
    uDialogue.Dialogue_result = DialogResult.Cancel
    uDialogue.Response_str = Nothing

    top_split_container.Panel1Collapsed = True
    tabControl_main.Enabled = True
    Call Context_sensitive_help_set()
    uOp.Subr = tLocals.Subr

    uDialogue.Active = False
    tLocals.Action = "Do something..."
    Select Case uDialogue.Called_from

      ' Any sub. except from frmMain, alphabetical:

      Case udtApplication_subroutine_names.Environment_determine
        If uDialogue.Alert = udtAlert_types.Critical Then uApp.Terminating = uApp.Terminating + 1

      Case udtApplication_subroutine_names.Check_run_count
        Call Run_count_check_after_dialogue_tab()

      Case udtApplication_subroutine_names.Check_run_count_local
        Call Run_count_check_local_after_dialogue_tab()

      Case udtApplication_subroutine_names.Error_display
        ' Carry on.

      Case udtApplication_subroutine_names.Registration
        uReg.Message_reported = True
        If DateDiff(DateInterval.Day, uReg.Trial_30_day_from_date, Date.Today) >= 30 Then
          Me.Close()
        End If

      Case udtApplication_subroutine_names.Enter_registration_code
        uReg.Message_reported = True

      Case udtApplication_subroutine_names.Registration_validate_email_fn
        Me.Close()

        ' Any sub. from frmMain, alphabetical:

      Case Else
        tLocals.Msg = uDialogue.Called_from
        Me.Close()

    End Select
    Call Dialogue_clear(False)

    If uUser.Preferences_changed Then Call Preferences_write()
    uOp.Subr = tLocals.Subr

    If uApp.Terminating = 0 Then
      uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 3
      uOp.Called_from = tLocals.Subr
      Call frmMain_Load_part_02()
    Else
      Me.Close()
    End If
    uOp.Subr = tLocals.Subr

    ' Call Dialogue_clear ' Causes a fail if a second dialogue is called straight after a previous one.
    uOp.Subr = tLocals.Subr

    uOp.Subr = ""
    uOp.Event_ = ""
  End Sub
  Private Sub Top_dialogue_cancel_button_MouseHover(sender As Object, e As System.EventArgs) Handles Top_dialogue_cancel_button.MouseHover
    txtCon_help.Text = udtDialogue.Cancel_button_MouseHover
  End Sub
  Private Sub Top_dialogue_cancel_button_MouseLeave(sender As Object, e As System.EventArgs) Handles Top_dialogue_cancel_button.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

#End Region ' End region, "Top dialogue."

#Region "Context Sensitive Help"

  Private Sub grpCon_help_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles grpCon_help.MouseHover
    txtCon_help.Text = uCon_help.Default_
  End Sub
  Private Sub grpCon_help_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles grpCon_help.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub txtCon_help_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtCon_help.MouseHover
    txtCon_help.Text = uCon_help.Default_
  End Sub
  Private Sub txtCon_help_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtCon_help.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub txtCon_help_MouseWheel(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles txtCon_help.MouseWheel
    Try
      txtCon_help.Font = New Font(txtCon_help.Font.Name, Int(txtCon_help.Font.Size + System.Math.Sign(e.Delta)))
    Catch ex As Exception

    End Try
  End Sub

  Private Sub btnContext_more_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnContext_more.Click
    uOp.Called_from = udtApplication_subroutine_names.btnContext_more_Click
    Call Context_more_click()
  End Sub
  Private Sub btnContext_more_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnContext_more.MouseHover
    txtCon_help.Text = "Expand the context sensitive help window to show more information."
  End Sub
  Private Sub btnContext_more_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnContext_more.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Sub Context_sensitive_help_set()
    ' Revised 2021.05.02.
    ' Call me from sub-routines.
    ' When a form element triggers, set txtCon_help.Text specific to that element.
    Dim tLocals As udtLocals = Nothing
    If tabControl_main.SelectedIndex = -1 Then Exit Sub
    If uApp.Debug Then tLocals.Msg = tabControl_main.SelectedTab.Name
    If IsNothing(tabControl_main.SelectedTab.Name) Then Exit Sub
    If uApp.Initialising Or uOp.Form_initialising Then Exit Sub
    tLocals.Subr = "Context sensitive help set"
    txtCon_help.Text = ""

    Select Case tabControl_main.SelectedTab.Name
      ' Common tabs:
      Case tabHome.Name
        txtCon_help.Text = uCon_help.Home_default
      Case tabAbout.Name
        txtCon_help.Text = uCon_help.About_default
      Case tabDiagnostic.Name
        txtCon_help.Text = uCon_help.Diagnostic_default
      Case tabPassword.Name
        txtCon_help.Text = uCon_help.Password_default
      Case tabMemory_query.Name
        txtCon_help.Text = uCon_help.Memory_query_default
      Case tabSettings.Name
        txtCon_help.Text = uCon_help.Settings_default
      Case tabSystem_information.Name
        txtCon_help.Text = uCon_help.System_information_default

        ' Application specific tabs:
      Case tabMusic.Name
      Case tabPlay.Name
      Case Else
        tLocals.Msg = tabControl_main.SelectedTab.Name
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
    End Select

    If top_split_container.Panel1Collapsed Then
      If Len(txtCon_help.Text) > 700 Then
        If frmMain_splitcontainer.SplitterDistance < 165 Then frmMain_splitcontainer.SplitterDistance = 165
      End If
    Else
      If Len(txtCon_help.Text) > 200 Then
        If frmMain_splitcontainer.SplitterDistance < 150 Then frmMain_splitcontainer.SplitterDistance = 150
      End If
    End If

    uOp.Subr = ""
  End Sub

  Sub Context_more_click()
    ' Revised 2021.03.17.
    Dim tLocals As udtLocals = Nothing
    tLocals.Msg = btnContext_more.Width
    tLocals.Msg = btnContext_more.Visible
    If Not btnContext_more.Visible Then Exit Sub
    tLocals.Subr = "Context more click"
    Stop

    tLocals.Msg = tabControl_main.SelectedTab.Name
    Select Case tabControl_main.SelectedTab.Name
      ' Common tabs:
      Case tabHome.Name
      Case tabAbout.Name
      Case tabDiagnostic.Name
      Case tabPassword.Name
      Case tabMemory_query.Name
      Case tabSettings.Name
      Case tabSystem_information.Name

        ' Application specific tabs:
      Case tabMusic.Name
      Case Else
        tLocals.Msg = tabControl_main.SelectedTab.Name
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        ' If Not tLocals.Continue_ Then GoTo Error_process
    End Select

    uOp.Subr = ""
  End Sub

#End Region ' End region, "Context Sensitive Help."

#End Region ' End region, "tab Main."

#Region "Tab First Run Wizard"

  Private Sub tabFirst_run_wizard_preparation()
    ' Separated 2018.03.14. Revised 2021.03.21.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "tabFirst_run_wizard preparation"
    uOp.Subr = tLocals.Subr
    tLocals.Status = udtuStandard_texts.Initiation
    Call Statuslabel1_set("Loading...")
    Call Form_minimum_size()
    tLocals.Status = ""

    tLocals.Action = udtuStandard_texts.Main_start
    If uOp.Called_from <> udtApplication_subroutine_names.First_run_wizard_set Then
      uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 39
      Call First_run_wizard_set()
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Success = udtBoolean_extended.False_
      End If
      uOp.Success = False
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Failed Then tLocals.Success = udtBoolean_extended.False_ Else tLocals.Success = udtBoolean_extended.True_

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Sub First_run_wizard_set(Optional ByVal tShow As Boolean = True)
    ' Revised 2021.05.09.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.First_run_wizard_set
    If uApp.Terminating Then
      tLocals.Success = udtBoolean_extended.True_ ' This did it's job, and didn't fail, and needs to report to the calling sub-routine.
      GoTo Ender_partial
    End If
    uOp.Subr = tLocals.Subr
    tLocals.Action = udtuStandard_texts.Initiation
    If uOp.Called_from = "" Then uOp.Called_from = tLocals.Subr
    Call Statuslabel1_set("Loading...")
    tLocals.Success = udtBoolean_extended.Null

    tLocals.Action = udtuStandard_texts.Main_start
    ' See Financier for a full example of how to design a First_run_wizard.
    tLocals.Action = "Set defaults"
    If tShow Then
      top_split_container.Enabled = True
      top_split_container.Panel1Collapsed = False
      tabFirst_run_wizard.Enabled = True
      grpFRW.Enabled = True

      tLocals.Action = "Test uUser.First_run_wizard, or another wizard"
      If uUser.First_run_wizard Or uUser.First_run_wizard_completed = False Then
        Call Statuslabel1_set()
        If uUser.First_run_wizard_step > 1 Then btnFirst_run_back.Visible = True
        btnFirst_run_next.Enabled = True
        btnFirst_run_next.BackColor = uApp.Colours.Okay
        btnFirst_run_next.Text = "&Next"
        btnFirst_run_cancel.BackColor = uApp.Colours.Cancel

        txtFRW.Dock = DockStyle.None
        txtFRW.Anchor = AnchorStyles.Top + AnchorStyles.Left + AnchorStyles.Right + AnchorStyles.Bottom
        uUser.First_run_wizard_loading = True
        grpFRW.Text = "First Run Wizard:"
        If Not tabControl_top.TabPages.Contains(tabFirst_run_wizard) Then tabControl_top.TabPages.Insert(tabControl_top.TabCount, tabFirst_run_wizard)
        tabControl_top.SelectedTab = tabFirst_run_wizard
        If uOp.Subr <> tLocals.Subr Then
          If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
            Stop ' Permanent.
            tLocals.Error_count = tLocals.Error_count + 1
            tLocals.Status = udtuStandard_texts.Failed
            tLocals.Success = udtBoolean_extended.False_
            GoTo Error_process
          End If
          uOp.Success = False
        End If
        uOp.Subr = tLocals.Subr

        If uUser.First_run_wizard_step <= 1 Then
          top_split_container.Panel2Collapsed = True ' Until introducing the context sensitive help.
        Else
          top_split_container.Panel2Collapsed = False
          top_split_container.SplitterDistance = top_split_container.Width * 2 / 3
        End If
        Call Statuslabel1_set()

        txtFRW.Text = "First run wizard step" & Str(uUser.First_run_wizard_step) & " of" & Str(uUser.First_run_wizard_max) & "." & vbCrLf
        tLocals.Action = "Set defaults"
        Me.AcceptButton = btnFirst_run_next
        Me.CancelButton = btnFirst_run_cancel
        btnFirst_run_next.Focus()

        Select Case uUser.First_run_wizard_step
          Case Is <= 1
            If uUser.First_run_wizard_step < 1 Then uUser.First_run_wizard_step = 1
            tLocals.Action = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & "."
            If frmMain_splitcontainer.SplitterDistance < 220 Then frmMain_splitcontainer.SplitterDistance = 220
            Call tabControl_main_tabs_hide()
            uOp.Subr = tLocals.Subr
            If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
              Stop ' Permanent.
              tLocals.Error_count = tLocals.Error_count + 1
              tLocals.Status = udtuStandard_texts.Failed
              tLocals.Success = udtBoolean_extended.False_
              GoTo Error_process
            End If
            uOp.Success = False
            btnFirst_run_back.Visible = False
            txtFRW.Text = txtFRW.Text & "Step 1, initial introduction to " & uApp.App_name & "."

          Case 2
            tLocals.Action = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & "."
            If frmMain_splitcontainer.SplitterDistance < 155 Then frmMain_splitcontainer.SplitterDistance = 155
            txtFRW.Text = txtFRW.Text & "Introduction to Context Sensitive Help." & vbCrLf
            txtFRW.Text = txtFRW.Text & vbCrLf
            txtFRW.Text = txtFRW.Text & "The text box to my right is context-sensitive help. The help shown there depends on what you point to, or what you select." & vbCrLf
            txtFRW.Text = txtFRW.Text & "As you go through the rest of the first run wizard, keep pointing to items in the window to get information about what you're pointing to." & vbCrLf
            txtFRW.Text = txtFRW.Text & "You can also use a mouse scroll wheel, or two fingers on a track-pad, to change the context-sensitive help box text size." & vbCrLf
            uCon_help.Default_ = uCon_help.Default_ & "Try pointing to the items in this window, to see."
            btnFirst_run_next.Focus()

          Case 3
            tLocals.Action = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & "."
            ' If frmMain_splitcontainer.SplitterDistance < 260 Then frmMain_splitcontainer.SplitterDistance = 260
            txtFRW.Text = txtFRW.Text & "Step 3."

          Case 4
            tLocals.Action = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & "."
            top_split_container.Panel2Collapsed = False
            top_split_container.SplitterDistance = top_split_container.Width * 2 / 3
            txtFRW.Text = txtFRW.Text & "First run wizard step " & uUser.First_run_wizard_step & " text."
            btnFirst_run_next.Text = "&Show me"
            ' Display and select any tabControl_main tabs as needed.

          Case 5
            tLocals.Action = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & "."
            If frmMain_splitcontainer.SplitterDistance < 155 Then frmMain_splitcontainer.SplitterDistance = 155
            top_split_container.Panel2Collapsed = False
            top_split_container.SplitterDistance = top_split_container.Width * 2 / 3
            txtFRW.Text = txtFRW.Text & vbCrLf
            txtFRW.Text = txtFRW.Text & "That's the end of the First Run Wizard." & vbCrLf
            txtFRW.Text = txtFRW.Text & "You can view the first run wizard again at any time by selecting the First Run Wizard button in " & tabSettings.Text & ", in the Edit menu." & vbCrLf
            txtFRW.Text = txtFRW.Text & "Click the Start button to close the First Run Wizard, and start using " & uApp.Short_name & "." & vbCrLf
            btnFirst_run_next.Text = "&Start"

          Case Else
            tLocals.Action = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max & "."
            Stop ' Permanent.
            tLocals.Error_count = tLocals.Error_count + 1
            tLocals.Status = udtuStandard_texts.Failed
            tLocals.Success = udtBoolean_extended.False_
            GoTo Error_process
        End Select
      Else ' If uUser.First_run_wizard Or uUser.First_run_wizard_completed = False Then
        tLocals.Action = "Another wizard is true"
        uUser.First_run_wizard = False
        uUser.First_run_wizard_step = uUser.First_run_wizard_max
        top_split_container.Panel1Collapsed = True

        Stop ' To test: Check what has focus.
        tLocals.Action = "Check what has focus"
        tLocals.Msg = Me.ActiveControl.Name

      End If ' If uUser.First_run_wizard Or uUser.First_run_wizard_completed = False Then

      If Len(txtFRW.Text) > 700 Then
        If frmMain_splitcontainer.SplitterDistance < 165 Then frmMain_splitcontainer.SplitterDistance = 165
      End If

    Else ' If tShow Then
      top_split_container.Panel1Collapsed = True

    End If ' If tShow Then

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
    End If

Ender_full:
    If uUser.First_run_wizard Then
      tLocals.Action = "First run wizard step " & uUser.First_run_wizard_step & " of " & uUser.First_run_wizard_max
    Else
      tLocals.Action = udtuStandard_texts.Completion
    End If

    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If

    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If

    Call Log_write(tLocals, 0)
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
      GoTo Ender_partial
    End If
    uOp.Success = False

Ender_partial:
    uUser.First_run_wizard_loading = False
    If uOp.Called_from = tLocals.Subr Then uOp.Called_from = ""
    Call Statuslabel1_set("Loading...")
    Call Statuslabel2_set()

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub grpFRW_MouseHover(sender As Object, e As System.EventArgs) Handles grpFRW.MouseHover
    txtCon_help.Text = "That group box shows the First Run Wizard guide. Stepping through the guide lets you learn how to use " & uApp.App_name & "."
  End Sub
  Private Sub grpFRW_MouseLeave(sender As Object, e As System.EventArgs) Handles grpFRW.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub txtFRW_MouseHover(sender As Object, e As System.EventArgs) Handles txtFRW.MouseHover
    txtCon_help.Text = "That text box shows the First Run Wizard guide. Stepping through the guide lets you learn how to use " & uApp.App_name & "."
  End Sub
  Private Sub txtFRW_MouseLeave(sender As Object, e As System.EventArgs) Handles txtFRW.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub txtFRW_MouseWheel(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles txtFRW.MouseWheel
    Try
      txtFRW.Font = New Font(txtFRW.Font.Name, Int(txtFRW.Font.Size + System.Math.Sign(e.Delta)))
    Catch ex As Exception

    End Try
  End Sub

  Private Sub btnFirst_run_back_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFirst_run_back.Click
    ' Revised 2021.02.14.
    Dim tLocals As udtLocals = Nothing
    uOp.Event_ = "btnFirst_run_back_Click"
    tLocals.Subr = uOp.Event_
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr

    If True Then
      uUser.First_run_wizard_step = uUser.First_run_wizard_step - 1
      uUser.Preferences_changed = True
      Call Preferences_write_one("First_run_wizard_step", uUser.First_run_wizard_step)
      uOp.Subr = tLocals.Subr
      Call First_run_wizard_set()
    Else

    End If

    uOp.Subr = ""
    Call Statuslabel1_set("", False)
    Call Statuslabel2_set()
    uOp.Event_ = ""
  End Sub
  Private Sub btnFirst_run_back_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFirst_run_back.MouseHover
    txtCon_help.Text = "Move back to the previous step of the first run wizard."
  End Sub
  Private Sub btnFirst_run_back_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFirst_run_back.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnFirst_run_next_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFirst_run_next.Click
    ' Revised 2021.05.02.
    Dim tLocals As udtLocals = Nothing
    uOp.Event_ = udtApplication_subroutine_names.btnFirst_run_next_Click
    tLocals.Subr = uOp.Event_
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start
    If (Control.ModifierKeys = Keys.Shift Or Control.ModifierKeys = Keys.Control) And uUser.First_run_wizard_completed Then
      btnFirst_run_next.Text = "&Start"
    End If

    If True Then
      uUser.First_run_wizard_step = uUser.First_run_wizard_step + 1
      uUser.Preferences_changed = True
      Call Preferences_write_one("First_run_wizard_step", uUser.First_run_wizard_step)
      uOp.Subr = tLocals.Subr
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
      uOp.Success = False

      Select Case btnFirst_run_next.Text
        Case "&Show me"
          Call Form_minimum_size()
          uOp.Subr = tLocals.Subr
          btnFirst_run_next.Text = "&Start"

        Case "&Start"
          tLocals.Action = "Reset any variables from first run wizard mode to normal operation"
          top_split_container.Panel1Collapsed = True
          uUser.First_run_wizard_step = uUser.First_run_wizard_max
          uUser.First_run_wizard = False
          uUser.First_run_wizard_completed = True
          uUser.Preferences_changed = True
          Call Preferences_write()
          uOp.Subr = tLocals.Subr
          If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
            Stop ' Permanent.
            tLocals.Error_count = tLocals.Error_count + 1
            tLocals.Status = udtuStandard_texts.Failed
            tLocals.Success = udtBoolean_extended.False_
            GoTo Error_process
          End If
          uOp.Success = False

          tLocals.Action = "Hide sample data, and load real data"
          uOp.Subr = tLocals.Subr
          uUser.Tab_last = tabHome.Name
          tabControl_main.SelectedTab = tabHome
          If uOp.Subr = tLocals.Subr Then
            Call tabControl_main_SelectedIndexChanged(Nothing, Nothing)
            If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
              Stop ' Permanent.
              tLocals.Error_count = tLocals.Error_count + 1
              tLocals.Status = udtuStandard_texts.Failed
              tLocals.Success = udtBoolean_extended.False_
              GoTo Error_process
            End If
            uOp.Success = False
          End If

        Case Else
          Call First_run_wizard_set()
          If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
            Stop ' Permanent.
            tLocals.Error_count = tLocals.Error_count + 1
            tLocals.Status = udtuStandard_texts.Failed
            tLocals.Success = udtBoolean_extended.False_
            GoTo Error_process
          End If
          uOp.Success = False
      End Select

    Else
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If

Error_process:
    If tLocals.Error_count <> 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
    End If ' If True Then

Ender_full:
    uOp.Subr = ""
    Call Statuslabel1_set("", False)
    Call Statuslabel2_set()
    uOp.Event_ = ""
  End Sub
  Private Sub btnFirst_run_next_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFirst_run_next.MouseHover
    ' Revised 2021.04.22.
    txtCon_help.Text = "Move to the next step of the first run wizard." & vbCrLf
    If uUser.First_run_wizard_completed Then
      txtCon_help.Text = txtCon_help.Text & "Since you have completed the First Run Wizard at least once, you may shift-click, or control-click the Next button, to complete the wizard and return to normal."
    End If
  End Sub
  Private Sub btnFirst_run_next_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFirst_run_next.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnFirst_run_cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFirst_run_cancel.Click
    ' Revised 2021.02.14.
    uOp.Event_ = "btnFirst_run_cancel_Click"
    If uUser.First_run_wizard_completed Then
      uUser.First_run_wizard = False
      uUser.First_run_wizard_step = uUser.First_run_wizard_max
      uUser.Preferences_changed = True
      Call Preferences_write()
      Call First_run_wizard_set(False)
    Else
      Me.Close()
    End If
  End Sub
  Private Sub btnFirst_run_cancel_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFirst_run_cancel.MouseHover
    txtCon_help.Text = "Quit " & uApp.App_name & "."
  End Sub
  Private Sub btnFirst_run_cancel_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFirst_run_cancel.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

#End Region ' End tab First Run Wizard.

#End Region ' End region, "tabControl_top."

#Region "tabControl_main"

  Private Sub tabControl_main_tabs_hide()
    ' Separated MJBH 2017.10.07. Revised 2021.01.27.
    ' De-activate for Template; activate for anything else:
    ' If uApp.App_name = udtApplication.App_Template Then Exit Sub ' Turn on for testing.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "Hide tabControl_main tabs"

    tLocals.Action = "Hide common tabs"
    ' If uDialogue.Active Then tabControl_main.TabPages.Remove(tabHome)
    ' tabControl_main.TabPages.Remove(tabAbout)
    ' tabControl_main.TabPages.Remove(tabDiagnostic)
    ' tabControl_main.TabPages.Remove(tabPassword)
    ' tabControl_main.TabPages.Remove(tabMemory_query)
    ' tabControl_main.TabPages.Remove(tabSettings)
    ' tabControl_main.TabPages.Remove(tabSystem_information)

    tLocals.Action = "Hide application specific tabs"
    ' tabControl_main.TabPages.Remove(tabMusic)
    tLocals.Success = udtBoolean_extended.True_

    If Not uOp.Form_initialising Then
      If tLocals.Status <> udtuStandard_texts.Cancelled And tLocals.Status <> udtuStandard_texts.Failed Then tLocals.Status = udtuStandard_texts.Completion
      Call Log_write(tLocals, 0)
    End If
    uOp.Subr = ""
    If tLocals.Status <> udtuStandard_texts.Failed Then uOp.Success = True Else uOp.Success = False : Stop
  End Sub

  Private Sub tabControl_main_tabs_show()
    ' Separated 2016.01.11. Revised 2021.04.27.
    Dim tLocals As udtLocals = Nothing
    Dim tShow As Boolean = False
    tLocals.Subr = udtApplication_subroutine_names.tabControl_main_show_tabs
    On Error GoTo Error_captured
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Show tabHome"
    If Not tabControl_main.TabPages.Contains(tabHome) Then
      tLocals.Action = "Insert tabHome"
      tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabHome)
    End If

    If uUser.First_run_wizard = False And uUser.First_run_wizard_completed Then
      tLocals.Action = "Show common tabs"
      If uOp.Administer Or uMachine.Development_machine Then tShow = True
      tShow = True ' For applications used by LivingInfo Systems internally only, such as Template and LIS Server.
      If tShow And Not tabControl_main.TabPages.Contains(tabAbout) Then
        tLocals.Action = "Insert tabAbout"
        tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabAbout)
      End If
      If Not tabControl_main.TabPages.Contains(tabDiagnostic) Then
        tLocals.Action = "Insert tabDiagnostic"
        tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabDiagnostic)
        If uApp.Environment_dump_completed_date = udtuStandard_texts.Date_null Or _
           uApp.First_run_completed_date = udtuStandard_texts.Date_null Or _
           uApp.Memory_check_completed_date = udtuStandard_texts.Date_null Then
          tabDiagnostic.Text = tabDiagnostic.Text & " *"
        End If
      End If
      If tShow And Not tabControl_main.TabPages.Contains(tabPassword) Then
        tLocals.Action = "Insert tabPassword"
        tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabPassword)
      End If
      If Not tabControl_main.TabPages.Contains(tabMemory_query) Then
        tLocals.Action = "Insert tabMemory_query"
        tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabMemory_query)
      End If
      If tShow And Not tabControl_main.TabPages.Contains(tabSettings) Then
        tLocals.Action = "Insert tabSettings"
        tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabSettings)
      End If

      If uMachine.Development_machine Or uMachine.Testing_machine Or uOp.Administer Then tShow = True
      If Not tabControl_main.TabPages.Contains(tabSystem_information) Then
        tLocals.Action = "Insert tabSystem_information"
        tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabSystem_information)
      End If

      tLocals.Action = "Show application specific tabs"
      If Not tabControl_main.TabPages.Contains(tabMusic) And Environ("USERNAME") = "myk_h" Then
        tLocals.Action = "Insert tabMusic"
        tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabMusic)
      End If

Activate_tab:
      tLocals.Action = "Activate tab"
      If uUser.Tab_last = "" Or uUser.Tab_last = tabHome.Name Or uUser.Start_home_tab = udtStandard_off_on.On_ Then
        tabControl_main.SelectTab(tabControl_main.TabPages(0)) ' !
      Else
        tabControl_main.SelectTab(uUser.Tab_last) ' !
      End If
      If uOp.Subr <> tLocals.Subr Then
        If uOp.Event_ = "" Or tLocals.Error_count > 0 Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Status = udtuStandard_texts.Cancelled
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process
        End If
        uOp.Success = False
      End If
      uOp.Subr = tLocals.Subr
      If uUser.Tab_last = "" Or uUser.Tab_last = tabHome.Name Or uUser.Tab_last <> tabControl_main.SelectedTab.Name Then
        ' If uUser.Tab_last = "tabHome" Then Tab_change needs to be called manually; whereas otherwise, it will be called automatically.
        Call tabControl_main_SelectedIndexChanged(Nothing, Nothing)
        uOp.Subr = tLocals.Subr
        If uDialogue.Active Then GoTo Ender_partial
        If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process
        End If
        uOp.Success = False
      End If

    End If ' If uUser.First_run_wizard = False And uUser.First_run_wizard_completed Then

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
    End If

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Then
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case 5 ' Value cannot be null. Parameter name: tabPage.
            Select Case tLocals.Action
              Case "Activate tab"
                If uError.Description = "Value cannot be null." & vbCrLf & "Parameter name: tabPage" Then
                  uUser.Tab_last = tabHome.Name
                  Resume Activate_tab
                Else
                  Stop ' Permanent.
                  Call Error_display(tLocals)
                End If
              Case Else
                Stop ' Permanent.
                uUser.Tab_last = tabHome.Name
                Resume
            End Select
          Case Else
            Stop ' Permanent.
            Call Error_display(tLocals)
        End Select
      End If
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If uOp.Event_ <> "" And tLocals.Error_count = 0 And uError.Number = 0 And uApp.Terminating = 0 Then tLocals.Success = udtBoolean_extended.True_
    Call Log_write(tLocals, 0)
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_process
    End If

Ender_partial:
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub tabControl_main_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles tabControl_main.MouseHover
    ' Private Sub tabControl_main_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs, ByVal m As Windows.Forms.MouseEventArgs) Handles tabControl_main.MouseHover
    ' Revised 2021.03.13.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "tabControl_main_MouseHover"
    txtCon_help.Text = "Each tab shows you more detail for that item; and lets you use the main functions of " & uApp.App_name & "."

    tLocals.Msg = MousePosition.ToString
    tLocals.Msg = MousePosition.X - Me.Left
    ' Stop
    '  tLocals.Msg  = e.location.x
    tLocals.Msg = MousePosition.X
    ' Select Case tabControl1.SelectedTab.Name
    'Select Case (MousePosition.X - Me.Left)
    '   Case 0 To 50
    '      ' "Home"
    '      txt_ConHelp.Text = "This is your starting point, and introduction.
    '   Case 50 To 100
    '      ' "tabIncome"
    '      txt_ConHelp.Text = "This tab shows you details of your income."
    '   Case 100 To 150
    '      ' "tabDisb"
    '      txt_ConHelp.Text = "This tab shows you details of your expenses."
    '   Case 150 To 200
    '      ' "tabRec"
    '      txt_ConHelp.Text = "This tab shows you details of what you are owed."
    '   Case 200 To 250
    '      ' "tabPay"
    '      txt_ConHelp.Text = "This tab shows you details of what you owe."
    '   Case 250 To 300
    '      ' "tabSAS"
    '      txt_ConHelp.Text = "This tab shows you how much you have set-aside, and for what."
    '   Case 300 To 350
    '      ' "tabFinPlan"
    '      txt_ConHelp.Text = "This tab shows you your financial plan."
    'End Select

    uOp.Subr = ""
  End Sub
  Private Sub tabControl_main_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles tabControl_main.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub tabControl_main_SelectedIndexChanged(sender As Object, e As System.EventArgs) Handles tabControl_main.SelectedIndexChanged
    ' Revised 2021.05.09.
    Dim tLocals As udtLocals = Nothing
    Dim tCalled_from As String
    tLocals.Subr = udtApplication_subroutine_names.tabControl_main_SelectedIndexChanged
    If uDialogue.Active Then GoTo Ender_partial
    If uOp.Event_ = "" Then uOp.Event_ = tLocals.Subr
    uOp.Subr = tLocals.Subr
    tCalled_from = uOp.Called_from
    If uOp.Called_from = "" Then uOp.Called_from = tLocals.Subr
    If uApp.Debug Then tLocals.Msg = tabControl_main.SelectedIndex
    Call Statuslabel1_set()
    uApp.Progressbar_step = uApp.Progressbar_step + 1

    tLocals.Action = udtuStandard_texts.Main_start
    If IsNothing(tabControl_main.SelectedTab) Then
      tabControl_main.SelectTab(tabHome)
    Else
      If uApp.Debug Then tLocals.Msg = tabControl_main.SelectedTab.Name
    End If

    If uUser.Tab_last <> tabControl_main.SelectedTab.Name Then
      If tabControl_main.SelectedTab Is tabAbout Or _
        tabControl_main.SelectedTab Is tabDiagnostic Or _
        tabControl_main.SelectedTab Is tabPassword Or _
        tabControl_main.SelectedTab Is tabSettings Or _
        tabControl_main.SelectedTab Is tabSystem_information Then
      Else
        uUser.Tab_last = tabControl_main.SelectedTab.Name
        uUser.Preferences_changed = True
      End If
      tLocals.Action = "Activate " & tabControl_main.SelectedTab.Name
      tLocals.Success = udtBoolean_extended.True_
      Call Log_write(tLocals, 0)
      uOp.Subr = tLocals.Subr
      uOp.Success = False
    End If
    uOp.Form_updating = True

    tLocals.Action = "Conditionally run " & udtApplication_subroutine_names.First_run_wizard_set
    If uUser.First_run_wizard Or uUser.First_run_wizard_completed = False Then
      If tabControl_main.SelectedTab Is tabHome Then ' Or which-ever tabs are valid during first run wizard.
        If uOp.Called_from = udtApplication_subroutine_names.First_run_wizard_set Then
          tLocals.Success = udtBoolean_extended.True_
        Else
          Call First_run_wizard_set(True) ' Show.
        End If
      Else
        Call First_run_wizard_set(False) ' Hide.
      End If
    Else
      Call First_run_wizard_set(False) ' Hide.
    End If
    If uOp.Subr <> tLocals.Subr Then
      If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
    End If
    uOp.Subr = tLocals.Subr
    uOp.Success = False

    tLocals.Action = "Prepare tab"
    Select Case tabControl_main.SelectedTab.Name
      Case tabHome.Name
        ' Common tabs:
        Call tabHome_preparation()
      Case tabAbout.Name
        Call tabAbout_preparation()
      Case tabDiagnostic.Name
        Call tabDiagnostic_preparation()
      Case tabPassword.Name
        Call tabPassword_preparation()
      Case tabMemory_query.Name
        Call tabMemory_query_preparation()
      Case tabSettings.Name
        Call tabSettings_preparation()
      Case tabSystem_information.Name
        Call tabSystem_information_preparation()

        ' Application specific tabs:
      Case tabMusic.Name
        Call tabMusic_preparation()
      Case tabPlay.Name
        Call tabPlay_preparation()
      Case Else
        tLocals.Msg = tabControl_main.SelectedTab.Name
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
    End Select
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    tLocals.Action = "Call " & udtApplication_subroutine_names.Variable_update
    Call Variable_update(False, True) ' Load.
    uOp.Subr = tLocals.Subr
    If uDialogue.Active Then GoTo Ender_partial
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    tLocals.Action = "Call Context sensitive help set"
    Call Context_sensitive_help_set()
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr
    Call Statuslabel1_set(ToolStripStatusLabel1.Text, ToolStripStatusLabel1.ForeColor)

    tLocals.Action = "Check what has focus"
    tLocals.Msg = Me.ActiveControl.Name

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      GoTo Ender_partial
    End If

Ender_full:
    If uUser.Preferences_changed Then Call Preferences_write()
    uOp.Subr = tLocals.Subr

    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If
    Call Log_write(tLocals, 0)
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Status = udtuStandard_texts.Failed
    End If
    uOp.Success = False

    uOp.Form_updating = False
    If Not uOp.Form_initialising Then uApp.Progressbar_show = False
    Call ToolStripProgressBar1_set()
    If Not uUser.First_run_wizard_loading And uOp.Event_ = tLocals.Subr Then uOp.Subr = ""
    Call Statuslabel1_set("working...", uOp.Form_initialising Or uOp.Form_refreshing Or uOp.Form_updating)
    Call Statuslabel2_set("", Color.Black)

Ender_partial:
    If uOp.Called_from = tLocals.Subr Then uOp.Called_from = ""
    uOp.Subr = ""
    If uOp.Event_ = tLocals.Subr Then
      uOp.Event_ = ""
      Call Statuslabel1_set("", uOp.Form_initialising Or uOp.Form_refreshing Or uOp.Form_updating)
    Else
      If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
    End If
  End Sub

  Sub Variable_update(ByVal tClear As Boolean, ByVal tLoad As Boolean)
    ' Revised 2021.02.17.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.Variable_update
    tLocals.Status = ""
    uOp.Subr = tLocals.Subr

    If tClear = tLoad Then
      ' Don't call me with both equal.
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If

    If tClear Then
      tLocals.Action = "Set variable elements = null"
      Select Case tabControl_main.SelectedTab.Name
        ' Common tabs:
        Case tabHome.Name
          uOp.Success = True
        Case tabAbout.Name
          uOp.Success = True
        Case tabDiagnostic.Name
          uOp.Success = True
        Case tabPassword.Name
          uOp.Success = True
        Case tabMemory_query.Name
          uOp.Success = True
        Case tabSettings.Name
          uOp.Success = True
        Case tabSystem_information.Name
          uOp.Success = True

          ' Application specific tabs:
        Case tabMusic.Name
          Call Gmusic_clear()

        Case Else
          tLocals.Msg = tabControl_main.SelectedTab.Name
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process
      End Select

    ElseIf tLoad Then
      tLocals.Action = "Load"
      Select Case tabControl_main.SelectedTab.Name
        ' Common tabs:
        Case tabHome.Name
          uOp.Success = True
        Case tabAbout.Name
          uOp.Success = True
        Case tabDiagnostic.Name
          uOp.Success = True
        Case tabMemory_query.Name
          uOp.Success = True
        Case tabPassword.Name
          uOp.Success = True
        Case tabSettings.Name
          uOp.Success = True
        Case tabSystem_information.Name
          uOp.Success = True

          ' Application specific tabs:
        Case tabMusic.Name
          uOp.Success = True
        Case tabPlay.Name
          uOp.Success = True
        Case Else
          tLocals.Msg = tabControl_main.SelectedTab.Name
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          tLocals.Success = udtBoolean_extended.False_
          GoTo Error_process
      End Select

    Else
      ' False, false; don't clear, don't load.
      ' Variable element = form element value. Really, just call Form_fill.
    End If
    If Not uOp.Success Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    If tClear Or tLoad Then
      Call Form_fill(tClear)
      uOp.Subr = tLocals.Subr
      If Not uOp.Success Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
    End If

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    If uOp.Called_from = uOp.Subr Then uOp.Called_from = ""
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub Form_fill(ByVal tClear As Boolean)
    ' Revised 2021.04.12.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.Form_fill
    uOp.Subr = tLocals.Subr
    On Error GoTo Error_captured
    If uOp.Called_from = "" Then uOp.Called_from = tLocals.Subr

Main:
    tLocals.Action = udtuStandard_texts.Main_start
    uOp.Form_updating = True
    ' Use this by filling any variables as needed, then filling the form elements from those variable values.
    ' Can be used to fill form elements with data, or to blank them to null values.
    Select Case tabControl_main.SelectedTab.Name
      ' Common tabs:
      Case tabHome.Name
        uOp.Success = True
      Case tabAbout.Name
        uOp.Success = True
      Case tabDiagnostic.Name
        uOp.Success = True
      Case tabMemory_query.Name
        If tClear Then
          ' cboMemory_query_subr.Items.Clear()
          ' cboMemory_query_action.Items.Clear()
          txtMemory_query_result.Text = ""
        End If
        uOp.Success = True
      Case tabPassword.Name
        uOp.Success = True
      Case tabSettings.Name
        uOp.Success = True
      Case tabSystem_information.Name
        uOp.Success = True

        ' Application specific tabs:
      Case tabMusic.Name
        If tClear Then
          Call dgvMusic_naming_clear()
          Call dgvMusic_details_clear_contents()
        Else
          Call tabMusic_load_files()
        End If
      Case tabPlay.Name
        uOp.Success = True
      Case Else
        tLocals.Msg = tabControl_main.SelectedTab.Name
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
    End Select
    uOp.Subr = tLocals.Subr
    If Not uOp.Success Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    tLocals.Success = udtBoolean_extended.True_

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)
    End If

Error_captured:
    tLocals.Error_number = Err.Number
    tLocals.Error_description = Err.Description
    tLocals.Error_source = Err.Source
    If Err.Number <> 0 Then
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      If uApp.Terminating = 0 Then
        Select Case tLocals.Error_number
          Case 5 ' Index was out of range. Must be non-negative and less than the size of the collection. Parameter name: index.
            Stop ' For development only.
            Resume Next
          Case Else
            Stop ' Permanent.
            Call Error_display(tLocals)
        End Select
      End If
    End If

Ender_full:
    uOp.Form_updating = False
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_process
    End If
    Me.Refresh()

    If uOp.Called_from = uOp.Subr Then uOp.Called_from = ""
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Sub Form_refresh(ByVal tAsk As Boolean)
    ' Revised 2021.02.17.
    ' tAsk if the user wants to save any changes first.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.Form_refresh
    tLocals.Error_count = 0
    uOp.Subr = tLocals.Subr
    If uDialogue.Active Then
      Stop ' Indefinite.
      GoTo Ender_full
    End If
    Call Statuslabel1_set("Refreshing data...")
    uOp.Called_from = tLocals.Subr
    uOp.Form_refreshing = True
    Me.Refresh()

    Call Variable_update(True, False) ' Clear.
    uOp.Subr = tLocals.Subr
    If Not uOp.Success Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    uOp.Called_from = ""
    Call tabControl_main_SelectedIndexChanged(Nothing, Nothing)
    uOp.Subr = tLocals.Subr
    If Not uOp.Success Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    If uOp.Called_from = uOp.Subr Then uOp.Called_from = ""
    If uOp.Called_from = "" Then
      uOp.Subr = ""
      Call Statuslabel1_set()
    Else
      Call Statuslabel1_set()
      uOp.Subr = ""
    End If

Error_process:
    If tLocals.Error_count <> 0 Then
      Stop ' Indefinite.
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    uOp.Form_refreshing = False
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or tLocals.Success = udtBoolean_extended.False_ Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

#Region "Tabs common"

#Region "Tab Home"

  Private Sub tabHome_preparation()
    ' Separated 2018.03.14. Revised 2021.03.16.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "tabHome preparation"
    uOp.Subr = tLocals.Subr
    tLocals.Action = udtuStandard_texts.Initiation
    uApp.Progressbar_show = True
    uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 3
    Call Statuslabel1_set("Loading...")
    Call Form_minimum_size()
    uOp.Subr = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Set form elements"
    Me.AcceptButton = btnKernel_distribute
    Me.CancelButton = Nothing
    If Not IsNothing(Me.ActiveControl) Then tLocals.Msg = Me.ActiveControl.ToString
    btnKernel_distribute.Focus()
    txtHome_description.Select(txtHome_description.Text.Length, txtHome_description.Text.Length)
    tLocals.Success = udtBoolean_extended.True_

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub tabHome_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles tabHome.MouseHover
    txtCon_help.Text = uCon_help.Home_default
  End Sub
  Private Sub tabHome_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles tabHome.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub txtHome_description_MouseHover(sender As Object, e As System.EventArgs) Handles txtHome_description.MouseHover
    txtCon_help.Text = uCon_help.Home_default
  End Sub
  Private Sub txtHome_description_MouseLeave(sender As Object, e As System.EventArgs) Handles txtHome_description.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub txtHome_description_MouseWheel(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles txtHome_description.MouseWheel
    Try
      txtHome_description.Font = New Font(txtHome_description.Font.Name, Int(txtHome_description.Font.Size + System.Math.Sign(e.Delta)))
    Catch ex As Exception

    End Try
  End Sub

  Private Sub lblHome_Brought_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblHome_brought.MouseHover
    txtCon_help.Text = uCon_help.Brought
  End Sub
  Private Sub lblHome_Brought_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblHome_brought.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub picHome_LIS_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles picHome_LIS.MouseHover
    txtCon_help.Text = uCon_help.Brought
  End Sub
  Private Sub picHome_LIS_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles picHome_LIS.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub lblHome_LIS_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblHome_LIS.MouseHover
    txtCon_help.Text = uCon_help.Brought
  End Sub
  Private Sub lblHome_LIS_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblHome_LIS.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnKernel_distribute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKernel_distribute.Click
    ' Revised 2021.01.26.
    Dim tLocals As udtLocals = Nothing
    uOp.Event_ = "btnKernel_distribute_Click"
    gOp.Kernel_distributed = False
    Call Kernel_distribute()
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      ' GoTo Error_process
    End If
    uOp.Success = False

    Call Statuslabel1_set()
    uOp.Event_ = ""
  End Sub

#End Region ' End region, "Tab Home."

#Region "Tab About"

  Private Sub tabAbout_preparation()
    ' Separated 2018.03.18. Revised 2021.05.09.
    Dim tLocals As udtLocals = Nothing
    Dim tApplication_title As String = ""
    Dim tVersion As String = ""
    tLocals.Subr = "tabAbout preparation"
    uOp.Subr = tLocals.Subr
    tLocals.Status = udtuStandard_texts.Initiation
    Call Statuslabel1_set("Loading...")
    uOp.Subr = tLocals.Subr
    uUser.Cancel = False

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Set form elements"
    tabAbout.Text = tabAbout.Text & " " & uApp.Short_name
    tApplication_title = uApp.App_name
    If VB.Right(tApplication_title, 1) <> "." Then tApplication_title = tApplication_title & "."
    ToolStripStatusLabel1.Text = String.Format("About {0}", tApplication_title)

    lblAbout_product_name.Text = "Application: " & uApp.App_name & "."
    If VB.Right(lblAbout_product_name.Text, 1) <> "." Then lblAbout_product_name.Text = lblAbout_product_name.Text & ":"

    tVersion = My.Application.Info.Version.Major
    If My.Application.Info.Version.MajorRevision <> 0 Then tVersion = tVersion & "." & My.Application.Info.Version.MajorRevision
    tVersion = tVersion & "." & My.Application.Info.Version.Minor
    If My.Application.Info.Version.MinorRevision <> 0 Then tVersion = tVersion & "." & My.Application.Info.Version.MinorRevision
    lblAbout_version.Text = "Application version: " & tVersion & ", build number " & uApp.App_build_number & ", build date " & uApp.App_revision_date & "."
    ' lblAbout_version.Text = String.Format("Application version: {0}", My.Application.Info.Version.ToString) & ", build date " & uApp.App_revision_date & "."
    lblAbout_copyright.Text = My.Application.Info.Copyright
    If VB.Right(lblAbout_copyright.Text, 1) <> "." Then lblAbout_copyright.Text = lblAbout_copyright.Text & "."

    txtAbout_description.Text = "Description: " & My.Application.Info.Description
    If VB.Right(txtAbout_description.Text, 1) <> "." Then txtAbout_description.Text = txtAbout_description.Text & "."
    txtAbout_description.Text = txtAbout_description.Text & vbCrLf
    txtAbout_description.Text = txtAbout_description.Text & uApp.App_name & " is made in New Zealand." & vbCrLf
    txtAbout_description.Text = txtAbout_description.Text & udtLivingInfoSystems.Name_long & " is proudly 100% New Zealand owned and operated." & vbCrLf
    If uLIS.Prog_file_path = uLIS.Profile_path Then
      txtAbout_description.Text = txtAbout_description.Text & vbCrLf
      txtAbout_description.Text = txtAbout_description.Text & uApp.Short_name & " is not properly installed, and does not have read-write access to " & Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles)
      txtAbout_description.Text = txtAbout_description.Text & " to be able to fix it."
    End If

    lblAbout_link.Text = "Web: " & uLIS.LLC & "."

    'lblAbout_registration_status.Text = "Registration status: "
    'If uApp.App_name = udtApplication.App_Seer Then
    '  lblAbout_registration_status.Text = lblAbout_registration_status.Text & udtApplication.App_Seer & " is free. No registration is required."
    'Else
    '  If uReg.Registered Then
    '    lblAbout_registration_status.Text = lblAbout_registration_status.Text & uApp.App_name & " is registered with " & udtLivingInfoSystems.Name_short & "."
    '  ElseIf uReg.Trial_30_day Then
    '    lblAbout_registration_status.Text = lblAbout_registration_status.Text & "This is a trial. You have 30 days from " & DateAndTime.DateValue(uReg.Trial_30_day_from_date)
    '    lblAbout_registration_status.Text = lblAbout_registration_status.Text & " to register " & uApp.App_name & " with " & udtLivingInfoSystems.Name_short & "."
    '  Else
    '    lblAbout_registration_status.Text = lblAbout_registration_status.Text & "This copy of " & uApp.App_name & " is not registered with " & udtLivingInfoSystems.Name_short & "."
    '  End If
    'End If

    btnAbout_okay.BackColor = uApp.Colours.Okay
    Me.AcceptButton = btnAbout_okay
    tLocals.Success = udtBoolean_extended.True_

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub btnAbout_okay_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbout_okay.Click
    ' Re-select the tab that was previously selected.
    If uUser.Tab_last <> "" Then tabControl_main.SelectTab(uUser.Tab_last)
  End Sub

#End Region ' End region, "Tab About."

#Region "tab Diagnostic"

  Private Sub tabDiagnostic_preparation()
    ' Written 2020.05.10. Revised 2021.05.03.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "tabDiagnostic preparation"
    uOp.Subr = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start
    If Not tabControl_main.TabPages.Contains(tabDiagnostic) Then
      tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabDiagnostic)
    End If
    tabControl_main.SelectTab(tabDiagnostic)

    If uApp.Environment_dump_completed_date = udtuStandard_texts.Date_null Then
      lblDiagnostic_env_dump.Text = "Not done yet."
    Else
      lblDiagnostic_env_dump.Text = Date_format_fn(uApp.Environment_dump_completed_date)
    End If

    If uApp.First_run_completed_date = udtuStandard_texts.Date_null Then
      lblDiagnostic_first_run.Text = "Not done yet."
    Else
      lblDiagnostic_first_run.Text = Date_format_fn(uApp.First_run_completed_date)
    End If

    If uApp.Memory_check_completed_date = udtuStandard_texts.Time_null Or uApp.Memory_check_completed_date = udtuStandard_texts.Date_null Then
      lblDiagnostic_memory_check.Text = "Not done yet."
    Else
      lblDiagnostic_memory_check.Text = Date_format_fn(uApp.Memory_check_completed_date)
    End If

    chkDiagnostic_development_machine.Checked = uMachine.Development_machine
    If chkDiagnostic_development_machine.Checked Then chkDiagnostic_development_machine.BackColor = uApp.Colours.Okay
    chkDiagnostic_testing_machine.Checked = uMachine.Testing_machine
    If chkDiagnostic_testing_machine.Checked Then chkDiagnostic_testing_machine.BackColor = uApp.Colours.Okay

    lblDiagnostic_run_count.Text = "Run count: " & uApp.Run_count.Count & " times."

    uOp.Subr = ""
    If tLocals.Success <> udtBoolean_extended.False_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub btnDiagnostic_environment_dump_Click(sender As System.Object, e As System.EventArgs) Handles btnDiagnostic_environment_dump.Click
    ' Written 2020.05.11. Revised 2021.04.22.
    Dim tLocals As udtLocals = Nothing
    If uOp.Event_ = "" Then
      uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_environment_dump_Click
      uApp.Progressbar_step = 0
    End If
    tLocals.Subr = "Diagnostic environment dump"
    uOp.Subr = tLocals.Subr
    uOp.Called_from = uOp.Event_
    tLocals.Status = udtuStandard_texts.Initiation
    Call Log_write(tLocals, 2)
    uOp.Diagnostics.In_progress = True
    uApp.Progressbar_show = True
    If uApp.Progressbar_steps_total = 0 Then uApp.Progressbar_steps_total = 5
    tLocals.Status = ""

    tLocals.Action = udtuStandard_texts.Main_start
    txtDiagnostic_result.Focus()
    tLocals.Action = "Call " & udtApplication_subroutine_names.Environment_dump
    Call Environment_dump(True)
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    lblDiagnostic_env_dump.Text = Date_format_fn(uApp.Environment_dump_completed_date)
    Call txtDiagnostic_result_append(System.IO.File.ReadAllText(uMachine.Environment_dump))

Error_process:
    If tLocals.Error_count <> 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_

      uError.Count = uError.Count + 1
      If tLocals.Error_count >= udtError.Infinite_loop_limit Or uError.Count >= udtError.Infinite_loop_limit Then Call Infinite_loop(tLocals)

      Call txtDiagnostic_result_append(tLocals.Subr & " check cancelled." & vbCrLf)
    End If

Ender_full:
    tLocals.Action = "Ender full"
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or tLocals.Success = udtBoolean_extended.False_ Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
      Call txtDiagnostic_result_append(tLocals.Subr & " check failed.")
    Else
      tLocals.Success = udtBoolean_extended.True_
      Call txtDiagnostic_result_append(tLocals.Subr & " check completion." & vbCrLf)
    End If
    Call Log_write(tLocals, 2)
    uOp.Subr = tLocals.Subr
    uOp.Called_from = ""
    Call Statuslabel1_set()
    uApp.Progressbar_show = False
    Call ToolStripProgressBar1_set()
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
    If uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_environment_dump_Click Then
      uOp.Diagnostics.In_progress = False
      uOp.Event_ = ""
    End If
  End Sub
  Private Sub btnDiagnostic_environment_dump_MouseHover(sender As Object, e As System.EventArgs) Handles btnDiagnostic_environment_dump.MouseHover
    txtCon_help.Text = "The Windows operating system contains a lot of variables, some of which can be useful in diagnosing any problem of the operation of " & uApp.Short_name & ". This button will detect and display them all."
  End Sub
  Private Sub btnDiagnostic_environment_dump_MouseLeave(sender As Object, e As System.EventArgs) Handles btnDiagnostic_environment_dump.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnDiagnostic_first_run_Click(sender As System.Object, e As System.EventArgs) Handles btnDiagnostic_first_run.Click
    ' Written 2020.05.11. Revised 2021.03.03.
    Dim tLocals As udtLocals = Nothing
    If uOp.Event_ = "" Then
      uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_first_run_Click
      uApp.Progressbar_step = 0
    End If
    tLocals.Subr = "Diagnostic first run"
    tLocals.Status = udtuStandard_texts.Initiation
    Call Log_write(tLocals, 2)
    tLocals.Continue_ = True ' Until set false.
    tLocals.Error_count = 0
    tLocals.Success = udtBoolean_extended.Null
    uOp.Diagnostics.In_progress = True
    uApp.First_run_completed_date = udtuStandard_texts.Date_null
    uApp.Progressbar_show = True
    If uApp.Progressbar_steps_total = 0 Then uApp.Progressbar_steps_total = 6
    tLocals.Status = ""

    tLocals.Action = udtuStandard_texts.Main_start
    txtDiagnostic_result.Focus()
    Call txtDiagnostic_result_append(vbCrLf)

    tLocals.Action = "Call " & udtApplication_subroutine_names.First_run
    Call First_run()
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    lblDiagnostic_first_run.Text = Date_format_fn(uApp.First_run_completed_date)

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or tLocals.Success = udtBoolean_extended.False_ Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
      Call txtDiagnostic_result_append(tLocals.Subr & " check failed.")
    Else
      tLocals.Success = udtBoolean_extended.True_
      Call txtDiagnostic_result_append(tLocals.Subr & " check completion." & vbCrLf)
    End If
    Call Log_write(tLocals, 2)
    uOp.Subr = tLocals.Subr
    uOp.Called_from = ""
    Call Statuslabel1_set()
    uApp.Progressbar_show = False
    Call ToolStripProgressBar1_set()
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
    If uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_first_run_Click Then
      uOp.Diagnostics.In_progress = False
      uOp.Event_ = ""
    End If
  End Sub
  Private Sub btnDiagnostic_first_run_MouseHover(sender As Object, e As System.EventArgs) Handles btnDiagnostic_first_run.MouseHover
    txtCon_help.Text = "When " & uApp.Short_name & " first runs, I will check that I am fully installed, such as, that files needed exist, and in the right place. You can re-check this here."
  End Sub
  Private Sub btnDiagnostic_first_run_MouseLeave(sender As Object, e As System.EventArgs) Handles btnDiagnostic_first_run.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnDiagnostic_check_memory_structure_Click(sender As System.Object, e As System.EventArgs) Handles btnDiagnostic_check_memory_structure.Click
    ' Written 2020.05.11. Revised 2021.03.05.
    Dim tLocals As udtLocals = Nothing
    If uOp.Event_ = "" Then
      uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_check_memory_structure_Click
      uApp.Progressbar_step = 0
    End If
    tLocals.Subr = "Diagnostic check memory structure"
    tLocals.Status = udtuStandard_texts.Initiation
    Call Statuslabel1_set("Running system wide memory diagnostic tests.", Color.Red, FontStyle.Bold)
    Call Log_write(tLocals, 2)
    tLocals.Continue_ = True ' Until set false.
    tLocals.Msg = ""
    tLocals.Error_count = 0
    tLocals.Success = udtBoolean_extended.Null
    uApp.Progressbar_show = True
    uApp.Progressbar_steps_total = 46
    uApp.Progressbar_step = 0
    uOp.Diagnostics.In_progress = True
    Call txtDiagnostic_result_append("Running system wide memory diagnostic tests." & vbCrLf & vbCrLf)

Main:
    tLocals.Action = udtuStandard_texts.Main_start
    uOp.Diagnostics.All_tables_in_progress = True
    uOp.Diagnostics.All_tables_done = False
    txtDiagnostic_result.Focus()

    tLocals.Action = "Call " & udtApplication_subroutine_names.Diagnostic_all_tables
    Call Diagnostic_all_tables()
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or tLocals.Error_count > 0 Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False
    uApp.Memory_check_completed_date = Date.Today
    uUser.Preferences_changed = True
    lblDiagnostic_memory_check.Text = Date_format_fn(uApp.Memory_check_completed_date)

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or tLocals.Success = udtBoolean_extended.False_ Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
      Call txtDiagnostic_result_append(tLocals.Subr & " check failed." & vbCrLf)
    Else
      tLocals.Success = udtBoolean_extended.True_
      Call txtDiagnostic_result_append(tLocals.Subr & " check completion." & vbCrLf)
    End If
    Call Log_write(tLocals, 2)
    If uOp.Called_from <> "" Then uOp.Subr = tLocals.Subr
    uOp.Called_from = ""
    Call Statuslabel1_set()
    uApp.Progressbar_show = False
    Call ToolStripProgressBar1_set()
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
    If uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_check_memory_structure_Click Then
      uOp.Diagnostics.All_tables_in_progress = False
      uOp.Diagnostics.In_progress = False
      uOp.Event_ = ""
    End If
  End Sub
  Private Sub btnDiagnostic_check_memory_structure_MouseHover(sender As Object, e As System.EventArgs) Handles btnDiagnostic_check_memory_structure.MouseHover
    txtCon_help.Text = uApp.Short_name & " can do a detailed check of my own memory; the structure, and the contents, such as the sample data; and repair these."
  End Sub
  Private Sub btnDiagnostic_check_memory_structure_MouseLeave(sender As Object, e As System.EventArgs) Handles btnDiagnostic_check_memory_structure.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnDiagnostic_check_all_Click(sender As System.Object, e As System.EventArgs) Handles btnDiagnostic_check_all.Click
    ' Written 2020.05.11. Revised 2021.03.03.
    Dim tLocals As udtLocals = Nothing
    If uOp.Event_ = "" Then
      uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_check_all_Click
      uApp.Progressbar_step = 0
    End If
    tLocals.Subr = "Diagnostic check all"
    tLocals.Status = udtuStandard_texts.Initiation
    Call Log_write(tLocals, 2)
    uOp.Subr = tLocals.Subr
    tLocals.Continue_ = True ' Until set false.
    tLocals.Error_count = 0
    tLocals.Success = udtBoolean_extended.Null
    uOp.Diagnostics.In_progress = True
    uApp.Progressbar_show = True
    uApp.Progressbar_steps_total = 6
    Call txtDiagnostic_result_append("Running system wide all diagnostic tests." & vbCrLf & vbCrLf)
    tLocals.Status = ""

Main:
    tLocals.Action = udtuStandard_texts.Main_start
    txtDiagnostic_result.Focus()

    tLocals.Action = udtApplication_subroutine_names.btnDiagnostic_environment_dump_Click
    Call btnDiagnostic_environment_dump_Click(Nothing, Nothing)
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or tLocals.Error_count > 0 Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    tLocals.Action = udtApplication_subroutine_names.btnDiagnostic_first_run_Click
    Call btnDiagnostic_first_run_Click(Nothing, Nothing)
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or tLocals.Error_count > 0 Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    tLocals.Action = udtApplication_subroutine_names.btnDiagnostic_check_memory_structure_Click
    Call btnDiagnostic_check_memory_structure_Click(Nothing, Nothing)
    uOp.Subr = tLocals.Subr
    If uOp.Event_ = "" Or tLocals.Error_count > 0 Or Not uOp.Success Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

Error_process:
    If tLocals.Error_count <> 0 Or uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      Stop ' Permanent.
      tLocals.Success = udtBoolean_extended.False_
    End If

Ender_full:
    tLocals.Action = tLocals.Subr
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Or tLocals.Success = udtBoolean_extended.False_ Or _
       uOp.Event_ = "" Or uError.Number <> 0 Or uApp.Terminating > 0 Then
      tLocals.Success = udtBoolean_extended.False_
      Call txtDiagnostic_result_append(tLocals.Subr & " check failed.")
    Else
      tLocals.Success = udtBoolean_extended.True_
      Call txtDiagnostic_result_append(tLocals.Subr & " check completion." & vbCrLf)
    End If
    Call Log_write(tLocals, 2)
    uOp.Subr = tLocals.Subr
    uOp.Called_from = ""
    uOp.Subr = ""
    Call Statuslabel1_set()
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
    If uOp.Event_ = udtApplication_subroutine_names.btnDiagnostic_check_all_Click Then
      uApp.Progressbar_show = False
      uOp.Diagnostics.In_progress = False
      uOp.Event_ = ""
    End If
  End Sub
  Private Sub btnDiagnostic_check_all_MouseHover(sender As Object, e As System.EventArgs) Handles btnDiagnostic_check_all.MouseHover
    txtCon_help.Text = uApp.Short_name & " will each of the three above checks."
  End Sub
  Private Sub btnDiagnostic_check_all_MouseLeave(sender As Object, e As System.EventArgs) Handles btnDiagnostic_check_all.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnDiagnostic_clear_results_Click(sender As System.Object, e As System.EventArgs) Handles btnDiagnostic_clear_results.Click
    txtDiagnostic_result.Clear()
  End Sub
  Private Sub btnDiagnostic_clear_results_MouseHover(sender As Object, e As System.EventArgs) Handles btnDiagnostic_clear_results.MouseHover
    txtCon_help.Text = "Clear the results box."
  End Sub
  Private Sub btnDiagnostic_clear_results_MouseLeave(sender As Object, e As System.EventArgs) Handles btnDiagnostic_clear_results.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Sub txtDiagnostic_result_append(ByVal tString As String)
    ' Revised 2021.01.07.
    If uOp.Diagnostics.In_progress Then
      txtDiagnostic_result.Text = txtDiagnostic_result.Text & tString
      txtDiagnostic_result.Select(txtDiagnostic_result.Text.Length, 0)
      txtDiagnostic_result.ScrollToCaret()
    End If
    Me.Refresh()
  End Sub

#End Region ' End region, "Tab Diagnostic."

#Region "Tab Password"
  ' Written 2016.01.11. Revised 2021.02.14.

  Private Sub tabPassword_preparation()
    ' Separated 2018.03.18. Revised 2021.03.03.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "tabPassword preparation"
    tLocals.Status = udtuStandard_texts.Initiation
    Call Statuslabel1_set("Loading...")
    Call Form_minimum_size()
    uOp.Subr = tLocals.Subr
    uUser.Cancel = False

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Set form elements"
    txtPw_username.Enabled = True
    txtPw_username.Text = ""
    txtPw_password.Enabled = True
    txtPw_password.Text = ""
    btnPw_okay.BackColor = uApp.Colours.Okay
    btnPw_okay.Enabled = False
    btnPw_cancel.BackColor = uApp.Colours.Cancel
    txtPw_username.Focus()
    tLocals.Success = udtBoolean_extended.True_

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub txtPw_username_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtPw_username.LostFocus
    ' Written 2016.01.11. Revised 2018.11.25.
    If txtPw_username.Text <> "" Then
      txtPw_password.Enabled = True
      If txtPw_username.Text = "." Or LCase(txtPw_username.Text) = "logout" Then
        btnPw_okay.Enabled = True
        btnPw_okay.Focus()
        uOp.Administer = False
      End If
    End If
  End Sub

  Private Sub txtPw_password_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtPw_password.LostFocus
    If txtPw_password.Text <> "" Then
      btnPw_okay.Enabled = True
      btnPw_okay.Focus()
    End If
  End Sub

  Private Sub btnPw_okay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPw_okay.Click
    ' Written 2016.01.11. Revised 2021.02.14.
    Dim tLocals As udtLocals = Nothing
    Dim tLogin As String
    Dim tPw As String
    tLocals.Subr = "btnPw_okay_Click"
    uOp.Event_ = tLocals.Subr

    tLocals.Msg = "michael@" & udtLivingInfoSystems.Domain
    tLocals.Msg = uLIS.Support_email
    '     uOp.Result  = Encrypt_it_fn(      tLocals.Msg , True)
    tLocals.Msg = "12BF370A5FED37B44E27D703C7347C670EE9FA24CF5AD8BCE4E5C05099"
    tLogin = Encrypt_it_fn(tLocals.Msg, False)
    uOp.Subr = tLocals.Subr
    uOp.Success = False

    tLocals.Msg = "lisystems!"
    '     uOp.Result  = Encrypt_it_fn(      tLocals.Msg , True)
    tLocals.Msg = "13BF271B4DFC3E99516F"
    tPw = Encrypt_it_fn(tLocals.Msg, False)
    uOp.Subr = tLocals.Subr
    uOp.Success = False

    If txtPw_username.Text = tLogin And txtPw_password.Text = tPw Then
      tLocals.Action = "Enable administrator priveledges"
      uOp.Administer = True
      uOp.Called_from = tLocals.Subr
      tLocals.Action = "Show all menu items"
      EnterRegistrationCodeToolStripMenuItem.Visible = True
      tLocals.Action = "Show tabs"
      Call tabControl_main_tabs_show()
      uOp.Subr = tLocals.Subr
      uOp.Success = False

      tLocals.Action = "Show form elements"
      txtCon_help.Width = Me.Width - btnContext_more.Width - 30
      btnContext_more.Visible = True
      btnSettings_diagnostic.Visible = True
      tLocals.Msg = "Administrator successfully logged in."
    Else
      tLocals.Action = "Hide all menu items"
      EnterRegistrationCodeToolStripMenuItem.Visible = Not uReg.Registered
      tLocals.Action = "Hide form elements"
      btnSettings_diagnostic.Visible = False
      tLocals.Action = "Hide tabs"
      Call tabControl_main_tabs_hide()
      uOp.Subr = tLocals.Subr
      uOp.Success = False
      If txtPw_username.Text = "." Or LCase(txtPw_username.Text) = "logout" Then
        tLocals.Msg = "Administrator successfully logged out."
      Else
        Beep()
        tLocals.Msg = "Administration login attempt failed."
      End If
      uOp.Administer = False
    End If
    If tLocals.Msg <> "" Then Call Statuslabel1_set(tLocals.Msg)

Ender_full:
    txtPw_username.Text = ""
    txtPw_password.Text = ""
    tLocals.Action = "Return to previous tab"
    If uUser.Tab_last <> "" Then tabControl_main.SelectTab(uUser.Tab_last)
    uOp.Success = False
    uOp.Event_ = ""
  End Sub

  Private Sub btnPw_cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPw_cancel.Click
    uUser.Cancel = True
    txtPw_username.Text = ""
    txtPw_password.Text = ""
    ' Return to previous tab:
    If uUser.Tab_last <> "" Then tabControl_main.SelectTab(uUser.Tab_last)
  End Sub

#End Region ' End region, "Tab Password."

#Region "Tab Memory query"
  ' Revised 2021.03.04.

  Private Sub tabMemory_query_preparation()
    ' Separated 2018.03.18. Revised 2021.03.16.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = udtApplication_subroutine_names.tabMemory_query_preparation
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr
    Call Statuslabel1_set("Loading...")

    Stop ' To do; check that: 
    ' 1. The cboMemory_query_action contents is derived from cboMemory_query_subr, and 
    ' 2. Then the results text box is filled.

    tLocals.Error_count = 0
    ' Call  Form_minimum_size ()
    uOp.Subr = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Set form elements"
    If cboMemory_query_time.Items.Count = 0 Then
      cboMemory_query_time.Items.Add("First time")
      cboMemory_query_time.Items.Add("Last time")
    End If

    If cboMemory_query_subr.Items.Count = 0 Then
      uMemory.Table_name = uTables.Log
      uMemory.Cmd_str = "SELECT DISTINCT Subr FROM " & uMemory.Table_name
      Call Database_general(uMemory)
      uOp.Subr = tLocals.Subr
      If Not uMemory.Success Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
      uOp.Success = False
      For i As Integer = 0 To uMemory.Rows_affected - 1
        If uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item("Subr") <> "" Then cboMemory_query_subr.Items.Add(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item("Subr"))
      Next
    End If

    If cboMemory_query_action.Items.Count = 0 Then
      uMemory.Table_name = uTables.Log
      uMemory.Cmd_str = "SELECT DISTINCT Action FROM " & uMemory.Table_name
      Call Database_general(uMemory)
      uOp.Subr = tLocals.Subr
      If Not uOp.Success Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
      uOp.Success = False
      For i As Integer = 0 To uMemory.Rows_affected - 1
        If uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item("Action") <> "" Then cboMemory_query_action.Items.Add(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item("Action"))
      Next
    End If

    If cboMemory_query_time.Items.Count > 0 Then cboMemory_query_time.SelectedIndex = 0 ' !

Error_process:
    If uOp.Event_ = "" Or tLocals.Error_count <> 0 Or uError.Number <> 0 Or uApp.Terminating <> 0 Then
      Stop ' Indefinite.
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Success = udtBoolean_extended.True_
    End If

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub rdoMemory_query_when_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoMemory_query_when.CheckedChanged
    ' Revised 2021.02.17.
    If uApp.App_name = "" Then Exit Sub
    uOp.Subr = "Memory query"

    ' cboMemory_query_time.Enabled = False

    uOp.Subr = ""
  End Sub
  Private Sub rdoMemory_query_when_KeyUp(ByVal sender As Object, ByVal k As System.Windows.Forms.KeyEventArgs) Handles rdoMemory_query_when.KeyUp
    Stop ' To do, does this work? 2021.03.16: yes.
    Call Key_handle(k)
  End Sub
  Private Sub rdoMemory_query_how_many_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoMemory_query_how_many.CheckedChanged
    ' Revised 2019.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tSearch As udtSearch = Nothing
    Dim i As Integer
    Stop
    If rdoMemory_query_how_many.Checked Then
      cboMemory_query_time.Enabled = True

      uMemory.Table_name = uTables.Log
      uMemory.Cmd_str = "SELECT DISTINCT Subr" & vbCr
      uMemory.Cmd_str = uMemory.Cmd_str & "FROM " & uMemory.Table_name & vbCr
      uMemory.Cmd_str = uMemory.Cmd_str & "ORDER BY Subr"
      Call Database_general(uMemory)

      For i = 0 To uMemory.Rows_affected
        tSearch.Keyword = "Subr"
        If Not IsDBNull(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword)) Then
          tLocals.Action = udtuStandard_texts.Dataset_read
          If uApp.Debug Then tLocals.Msg = uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword)
          cboMemory_query_subr.Items.Add(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword))
        End If
      Next
    End If
  End Sub

  Private Sub cboMemory_query_time_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMemory_query_time.SelectedIndexChanged
    Call cboMemory_query_action_SelectedIndexChanged(sender, e)
  End Sub

  Private Sub cboMemory_query_subr_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMemory_query_subr.SelectedIndexChanged
    ' Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tSearch As udtSearch = Nothing
    Dim i As Integer
    uOp.Subr = "cboMemory_query_subr_SelectedIndexChanged"

    cboMemory_query_action.Items.Clear()
    txtMemory_query_result.Text = ""

    uMemory.Table_name = uTables.Log
    uMemory.Cmd_str = "SELECT DISTINCT Action " & vbCr
    uMemory.Cmd_str = uMemory.Cmd_str & "FROM " & uMemory.Table_name & vbCr
    uMemory.Cmd_str = uMemory.Cmd_str & "WHERE Subr='" & cboMemory_query_subr.Text & "'" & vbCr
    uMemory.Cmd_str = uMemory.Cmd_str & "ORDER BY Action"
    Call Database_general(uMemory)
    For i = 0 To uMemory.Rows_affected - 1
      tSearch.Keyword = "Action"
      If Not IsDBNull(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword)) Then
        tLocals.Action = udtuStandard_texts.Dataset_read
        If uApp.Debug Then tLocals.Msg = uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword)
        If uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword) <> "" Then
          cboMemory_query_action.Items.Add(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword))
        End If
      End If
    Next

    cboMemory_query_action.SelectedIndex = 0
    ' Call cboMemory_query_action_SelectedIndexChanged(Nothing, Nothing)

    cboMemory_query_action.Focus()
  End Sub

  Private Sub cboMemory_query_action_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMemory_query_action.SelectedIndexChanged
    ' Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tSearch As udtSearch = Nothing
    Dim i As Integer
    tLocals.Subr = "cboMemory_query_action_SelectedIndexChanged"
    tLocals.Action = "Execute query"
    txtMemory_query_result.Text = ""

    uMemory.Table_name = uTables.Log
    If rdoMemory_query_when.Checked Then
      tLocals.Action = udtuStandard_texts.Sql_build_select
      ' uMemory.Cmd_str = "SELECT TOP 1 [Date], [Time] " & vbCr
      uMemory.Cmd_str = "SELECT [Date], [Time] " & vbCr
      uMemory.Cmd_str = uMemory.Cmd_str & "FROM " & uMemory.Table_name & " WHERE" & vbCr
      ' If cboMemory_query_subr.Text <> "" Then uMemory.Cmd_str = uMemory.Cmd_str & "Subr  ='" & cboMemory_query_subr.Text & "' AND" & vbCr
      uMemory.Cmd_str = uMemory.Cmd_str & "Subr  ='" & cboMemory_query_subr.Text & "' AND" & vbCr
      uMemory.Cmd_str = uMemory.Cmd_str & "Action='" & cboMemory_query_action.Text & "'" & vbCr
      If cboMemory_query_time.Text = "First time" Then
        uMemory.Cmd_str = uMemory.Cmd_str & "ORDER BY Date, Time"
      ElseIf cboMemory_query_time.Text = "Last time" Then
        uMemory.Cmd_str = uMemory.Cmd_str & "ORDER BY Date DESC, Time DESC"
      Else
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      End If
    ElseIf rdoMemory_query_how_many.Checked Then
      Stop
    Else
      Stop
    End If
    If uMemory.Cmd_str = "" Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    Call Database_general(uMemory)
    uOp.Subr = tLocals.Subr
    If Not uOp.Success Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If
    uOp.Success = False

    Call Statuslabel2_set()
    uApp.Progressbar_show = True
    uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + uMemory.Rows_affected / 100
    For i = 0 To uMemory.Rows_affected - 1
      ' If i > 1000 Then Exit For
      tLocals.Action = udtuStandard_texts.Dataset_read
      tSearch.Keyword = "Date"
      ' If uApp.Debug Then tLocals.Msg = uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword)
      If IsDBNull(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword)) Then
      Else
        If uApp.Debug Then tLocals.Msg = uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword)
        txtMemory_query_result.Text = txtMemory_query_result.Text & uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item(tSearch.Keyword) & ", "
        txtMemory_query_result.Text = txtMemory_query_result.Text & Trim(uMemory.Dataset.Tables(uMemory.Table_name).Rows(i).Item("Time")) & "."
        txtMemory_query_result.Text = txtMemory_query_result.Text & vbCrLf
      End If
      If i / 100 = Int(i / 100) Then Call ToolStripProgressBar1_set()
    Next

    If cboMemory_query_time.Text = "First time" Then
      txtMemory_query_result.SelectionStart = 1
    ElseIf cboMemory_query_time.Text = "Last time" Then
      Stop ' Indefinite.
      txtMemory_query_result.SelectionStart = 1
    Else
      Stop
    End If
    tLocals.Success = udtBoolean_extended.True_

Error_process:
    If tLocals.Error_count > 0 Or tLocals.Status = udtuStandard_texts.Failed Then
      Stop ' Indefinite.
      tLocals.Success = udtBoolean_extended.False_
    End If

    uApp.Progressbar_show = False
    Call ToolStripProgressBar1_set()

  End Sub

  Private Sub MonthCalendar1_DateChanged(sender As System.Object, e As System.Windows.Forms.DateRangeEventArgs) Handles MonthCalendar1.DateChanged
    Stop
    uOp.Result = MonthCalendar1.SelectionRange.Start.ToString
  End Sub
  Private Sub MonthCalendar1_DateSelected(sender As Object, e As System.Windows.Forms.DateRangeEventArgs) Handles MonthCalendar1.DateSelected
    Stop
    uOp.Result = MonthCalendar1.SelectionRange.Start.ToString
  End Sub

#End Region ' End region, "Tab Memory query."

#Region "Tab Settings"
  ' Revised 2021.05.09.

  Private Sub tabSettings_preparation()
    ' Separated 2018.04.07. Revised 2021.05.09.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "tabSettings preparation"
    tLocals.Status = udtuStandard_texts.Initiation
    Call Statuslabel1_set("Loading...")
    Call Form_minimum_size()
    uOp.Subr = tLocals.Subr
    uUser.Cancel = False

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Set form common elements"
    Me.txtCon_help.Text = "Please set your desired settings:"
    tabSettings.Text = uApp.Short_name & " Settings and Status"
    txtSettings_first_name.Text = uUser.First_name
    chkSettings_min_sys_tray.Checked = uUser.Min_sys_tray
    If Not uUser.Min_sys_tray Then chkSettings_min_sys_tray.ForeColor = uApp.Colours.Off_

    tLocals.Action = "Set settings common"
    tLocals.Action = "Set speech value"
    scrolSettings_speech.Value = uUser.Speech
    If uUser.Speech = -1 Then
      Stop
      scrolSettings_speech.Value = 2
    End If
    Call scrolSettings_speech_Scroll(Nothing, Nothing)
    uOp.Subr = tLocals.Subr

    tLocals.Action = "Set start home tab"
    If uUser.Start_home_tab = udtStandard_off_on.Null Then
    ElseIf uUser.Start_home_tab = udtStandard_off_on.On_ Then
      rdoSettings_start_home_tab.Checked = True
      rdoSettings_start_last_tab.Checked = False
    ElseIf uUser.Start_home_tab = udtStandard_off_on.Off Then
      rdoSettings_start_home_tab.Checked = False
      rdoSettings_start_last_tab.Checked = True
    End If

    tLocals.Action = "Set error reporting"
    chkSettings_error_reporting.Checked = uApp.Email_udt.Smtp_working
    If uApp.Email_udt.Smtp_working Then
      chkSettings_error_reporting.ForeColor = uApp.Colours.On_
    Else
      chkSettings_error_reporting.ForeColor = uApp.Colours.Off_
    End If

    tLocals.Action = "Set regional settings:"
    tLocals.Action = "Operating system values:"
    lblSettings_system_country_value.Text = System.Globalization.RegionInfo.CurrentRegion.DisplayName & "."
    lblSettings_system_date_format_value.Text = System.Globalization.CultureInfo.CurrentCulture.DateTimeFormat.ShortDatePattern

    tLocals.Action = "User set values:"
    If cboSettings_country.Items.Count = 0 Then
      If uActive.Country = "" Or uActive.Currency_symbol = "" Or uActive.Currency_format = "" Then
        Call Country_detect(uActive.Country, True)
      End If
      uOp.Subr = tLocals.Subr
      cboSettings_country.Items.Add(uActive.Country)
    End If
    cboSettings_country.Text = uActive.Country ' !
    txtSettings_currency_symbol.Text = uActive.Currency_symbol
    txtSettings_currency_format.Text = uActive.Currency_format
    cboSettings_date_format.Items.Add("yyyy.MM.dd")
    cboSettings_date_format.Items.Add("yyyy/MM/dd")
    cboSettings_date_format.Items.Add("dd.MM.yyyy")
    cboSettings_date_format.Items.Add("dd-MM-yyyy")
    cboSettings_date_format.Items.Add("dd/MM/yyyy")
    cboSettings_date_format.Items.Add("MM/dd/yyyy")
    ' Until there is a user setting:
    cboSettings_date_format.Text = System.Globalization.CultureInfo.CurrentCulture.DateTimeFormat.ShortDatePattern ' !

    tLocals.Action = "Set theme"
    rdoSettings_theme_light.Checked = False
    rdoSettings_theme_dark.Checked = False
    rdoSettings_theme_system.Checked = False
    If uUser.Theme = udtTheme.Null Then
    ElseIf uUser.Theme = udtTheme.Light Then
      rdoSettings_theme_light.Checked = True
    ElseIf uUser.Theme = udtTheme.Dark Then
      rdoSettings_theme_dark.Checked = True
    ElseIf uUser.Theme = udtTheme.System Then
      rdoSettings_theme_system.Checked = True
    Else
      tLocals.Msg = uUser.Theme
      Stop ' Permanent.
    End If
    If uOp.Subr = tLocals.Subr Then Call Settings_theme_set()
    uOp.Subr = tLocals.Subr

    tLocals.Action = "Set application specific settings"

    tLocals.Action = "Set registration status"
    lblSettings_registration_status.Text = "Registration status: "
    If uApp.App_name = udtApplication.App_Seer Then
      lblSettings_registration_status.Text = lblSettings_registration_status.Text & udtApplication.App_Seer & " is free. No registration is required."
    Else
      If uReg.Registered Then
        lblSettings_registration_status.Text = lblSettings_registration_status.Text & uApp.App_name & " is registered with " & udtLivingInfoSystems.Name_short & "."
      ElseIf uReg.Trial_30_day Then
        lblSettings_registration_status.Text = lblSettings_registration_status.Text & "This is a trial. You have 30 days from " & DateAndTime.DateValue(uReg.Trial_30_day_from_date)
        lblSettings_registration_status.Text = lblSettings_registration_status.Text & " to register " & uApp.App_name & " with " & udtLivingInfoSystems.Name_short & "."
      Else
        lblSettings_registration_status.Text = lblSettings_registration_status.Text & "This copy of " & uApp.App_name & " is not registered with " & udtLivingInfoSystems.Name_short & "."
      End If
    End If
    If uReg.Registered Or uApp.App_name = udtApplication.App_Seer Then btnSettings_request_registration.Enabled = False
    btnSettings_enter_registration_code.Enabled = Not uReg.Registered
    If uOp.Administer Or uMachine.Development_machine Or uMachine.Testing_machine Or uApp.App_name = udtApplication.App_Template Then btnSettings_diagnostic.Visible = True
    If uOp.Administer Or uMachine.Development_machine Or uMachine.Testing_machine Or uApp.App_name = udtApplication.App_Template Then btnSettings_write_config.Visible = True

    btnSettings_diagnostic.Text = "&Diagnostics."

    btnSettings_okay.BackColor = uApp.Colours.Okay
    btnSettings_cancel.BackColor = uApp.Colours.Cancel
    Me.AcceptButton = btnSettings_okay
    Me.CancelButton = btnSettings_cancel
    txtSettings_first_name.SelectAll()
    txtSettings_first_name.Focus()
    tLocals.Success = udtBoolean_extended.True_

    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub lblSettings_first_name_MouseHover(sender As Object, e As System.EventArgs) Handles lblSettings_first_name.MouseHover
    txtCon_help.Text = uApp.Short_name & " will address you by name. Enter your desired name here."
  End Sub
  Private Sub lblSettings_first_name_MouseLeave(sender As Object, e As System.EventArgs) Handles lblSettings_first_name.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub txtSettings_first_name_MouseHover(sender As Object, e As System.EventArgs) Handles txtSettings_first_name.MouseHover
    txtCon_help.Text = uApp.Short_name & " will address you by name. Enter your desired name here."
  End Sub
  Private Sub txtSettings_first_name_MouseLeave(sender As Object, e As System.EventArgs) Handles txtSettings_first_name.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub chkSettings_min_sys_tray_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkSettings_min_sys_tray.CheckedChanged
    If chkSettings_min_sys_tray.Checked Then
      chkSettings_min_sys_tray.ForeColor = uApp.Colours.On_
    Else
      chkSettings_min_sys_tray.ForeColor = uApp.Colours.Off_
    End If
  End Sub
  Private Sub chkSettings_min_sys_tray_MouseHover(sender As Object, e As System.EventArgs) Handles chkSettings_min_sys_tray.MouseHover
    txtCon_help.Text = "When this is selected, and you click or tap the application minimise button (in the top right corner), " & uApp.App_name & " will minimise to the System Tray (next to the clock)." & vbCrLf
    txtCon_help.Text = txtCon_help.Text & "When this is not selected, and you click or tap the application minimise button " & uApp.App_name & " will minimise to the Task Bar." & vbCrLf
  End Sub
  Private Sub chkSettings_min_sys_tray_MouseLeave(sender As Object, e As System.EventArgs) Handles chkSettings_min_sys_tray.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub grpSettings_speech_level_MouseHover(sender As Object, e As System.EventArgs) Handles grpSettings_speech_level.MouseHover
    txtCon_help.Text = uApp.Short_name & " has three " & scrolSettings_speech.Maximum + 1 & " levels of speech available; mute, some speech, or verbose." & vbCrLf
    txtCon_help.Text = txtCon_help.Text & "The voice you hear is set in Windows Settings: Time and Language: Speech."
  End Sub
  Private Sub grpSettings_speech_level_MouseLeave(sender As Object, e As System.EventArgs) Handles grpSettings_speech_level.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub scrolSettings_speech_MouseHover(sender As Object, e As System.EventArgs) Handles scrolSettings_speech.MouseHover
    txtCon_help.Text = uApp.Short_name & " has three " & scrolSettings_speech.Maximum + 1 & " levels of speech available; mute, some speech, or verbose." & vbCrLf
    txtCon_help.Text = txtCon_help.Text & "The voice you hear is set in Windows Settings: Time and Language: Speech."
  End Sub
  Private Sub scrolSettings_speech_MouseLeave(sender As Object, e As System.EventArgs) Handles scrolSettings_speech.MouseLeave
    Call Context_sensitive_help_set()
  End Sub
  Private Sub scrolSettings_speech_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles scrolSettings_speech.Scroll
    ' Revised 2020.03.22.
    Select Case scrolSettings_speech.Value
      Case 0
        lblSettings_speech_level_result.Text = "Mute."
      Case 1
        lblSettings_speech_level_result.Text = "Some speech."
      Case 2
        lblSettings_speech_level_result.Text = "Verbose."
      Case Else
        Stop ' Permanent.
    End Select
  End Sub

  Private Sub lblSettings_speech_level_result_MouseHover(sender As Object, e As System.EventArgs) Handles lblSettings_speech_level_result.MouseHover
    txtCon_help.Text = uApp.Short_name & " has three " & scrolSettings_speech.Maximum + 1 & " levels of speech available; mute, some speech, or verbose." & vbCrLf
    txtCon_help.Text = txtCon_help.Text & "The voice you hear is set in Windows Settings: Time and Language: Speech."
  End Sub
  Private Sub lblSettings_speech_level_result_MouseLeave(sender As Object, e As System.EventArgs) Handles lblSettings_speech_level_result.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub grpSettings_start_home_MouseHover(sender As Object, e As System.EventArgs) Handles grpSettings_start_home.MouseHover
    txtCon_help.Text = "When " & uApp.Short_name & " runs, I can start with the Home tab displayed, or I can return you to the last tab you used."
  End Sub
  Private Sub grpSettings_start_home_MouseLeave(sender As Object, e As System.EventArgs) Handles grpSettings_start_home.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub chkSettings_error_reporting_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkSettings_error_reporting.CheckedChanged
    ' Revised 2020.04.17.
    If chkSettings_error_reporting.Checked Then
      chkSettings_error_reporting.ForeColor = uApp.Colours.On_
    Else
      chkSettings_error_reporting.ForeColor = uApp.Colours.Off_
    End If
    ' uApp.Email_smtp_working = chkError_reporting.Checked
    ' uUser.Preferences_changed = True
    ' Call Preferences_write_one("Email_smtp_working", uApp.Email_smtp_working, True)
  End Sub
  Private Sub chkSettings_error_reporting_MouseHover(sender As Object, e As System.EventArgs) Handles chkSettings_error_reporting.MouseHover
    txtCon_help.Text = "If an programme error occurs, it can be reported to " & udtLivingInfoSystems.Name_long & ", at your discretion."
  End Sub
  Private Sub chkSettings_error_reporting_MouseLeave(sender As Object, e As System.EventArgs) Handles chkSettings_error_reporting.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub cboSettings_country_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSettings_country.SelectedIndexChanged
    uOp.Result = cboSettings_country.Text
    If Not uOp.Form_updating Then Stop ' Temporary.
  End Sub

  Private Sub cboSettings_date_format_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cboSettings_date_format.SelectedIndexChanged
    ' Written 2021.03.04.
    If uOp.Form_initialising Or uOp.Form_updating Then Exit Sub
    Microsoft.Win32.Registry.SetValue("HKEY_CURRENT_USER\Control Panel\International", "sShortDate", cboSettings_date_format.Text)
    ' Call PostMessage(65535, 26, 0&, 0&)
    If cboSettings_date_format.Text = System.Globalization.CultureInfo.CurrentCulture.DateTimeFormat.ShortDatePattern Then
      Call Statuslabel2_set("Set locale date format success.")
    Else
      Call Statuslabel2_set("Set locale date format failure.", Color.Red)
    End If
  End Sub

  Private Sub rdoSettings_theme_light_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoSettings_theme_light.CheckedChanged
    If rdoSettings_theme_light.Checked Then
      rdoSettings_theme_dark.Checked = False
      rdoSettings_theme_system.Checked = False
      uUser.Theme = udtTheme.Light
    End If
    Call Settings_theme_set()
  End Sub

  Private Sub rdoSettings_theme_dark_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoSettings_theme_dark.CheckedChanged
    If rdoSettings_theme_dark.Checked Then
      rdoSettings_theme_light.Checked = False
      rdoSettings_theme_system.Checked = False
      uUser.Theme = udtTheme.Dark
    End If
    Call Settings_theme_set()
  End Sub

  Private Sub rdoSettings_theme_system_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoSettings_theme_system.CheckedChanged
    If rdoSettings_theme_system.Checked Then
      rdoSettings_theme_light.Checked = False
      rdoSettings_theme_dark.Checked = False
      uUser.Theme = udtTheme.System
    End If
    Call Settings_theme_set()
  End Sub

  Private Sub btnSettings_first_run_wizard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_first_run_wizard.Click
    ' Revised 2021.04.17.
    uOp.Event_ = "btnSettings_first_run_wizard_Click"
    uOp.Subr = uOp.Event_

    uUser.First_run_wizard = True
    uUser.First_run_wizard_step = 1
    uUser.Preferences_changed = True
    Call Preferences_write()
    uOp.Subr = uOp.Event_

    Call tabFirst_run_wizard_preparation()
    uOp.Subr = uOp.Event_

    uOp.Subr = ""
    uOp.Event_ = ""
  End Sub
  Private Sub btnSettings_first_run_wizard_MouseHover(sender As Object, e As System.EventArgs) Handles btnSettings_first_run_wizard.MouseHover
    txtCon_help.Text = "You can run the First Run Wizard again to review the theory given there, and how to use " & uApp.Short_name & "." & vbCrLf
    txtCon_help.Text = txtCon_help.Text & "Running the First Run Wizard again will not change any of the information you have entered into " & uApp.Short_name & "."
  End Sub
  Private Sub btnSettings_first_run_wizard_MouseLeave(sender As Object, e As System.EventArgs) Handles btnSettings_first_run_wizard.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnSettings_request_registration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_request_registration.Click
    uOp.Event_ = "btnSettings_request_registration_Click"
    Call Registration_request()
    uOp.Event_ = ""
  End Sub
  Private Sub btnSettings_request_registration_MouseHover(sender As Object, e As System.EventArgs) Handles btnSettings_request_registration.MouseHover
    txtCon_help.Text = "You may request a registration code from " & udtLivingInfoSystems.Name_long & "."
  End Sub
  Private Sub btnSettings_request_registration_MouseLeave(sender As Object, e As System.EventArgs) Handles btnSettings_request_registration.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnSettings_enter_registration_code_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_enter_registration_code.Click
    ' Revised 2021.03.19.
    Dim tLocals As udtLocals = Nothing
    uOp.Event_ = "btnSettings_register_Click"
    tLocals.Subr = uOp.Event_
    tLocals.Msg = "Please enter a registration code."
    tLocals.Response = Inputbox_LIS(tLocals.Msg, "", tabSettings, udtDialogue_position.Bottom_right)
    If tLocals.Response <> "" Then Call Register(tLocals.Response)

    uOp.Event_ = ""
  End Sub
  Private Sub btnSettings_enter_registration_code_MouseHover(sender As Object, e As System.EventArgs) Handles btnSettings_enter_registration_code.MouseHover
    txtCon_help.Text = "When you receive a registration code back from " & udtLivingInfoSystems.Name_long & " by email, enter it here."
  End Sub
  Private Sub btnSettings_enter_registration_code_MouseLeave(sender As Object, e As System.EventArgs) Handles btnSettings_enter_registration_code.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnSettings_update_me_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_update_me.Click
    uOp.Event_ = "btnSettings_update_me_Click"
    Call Me_update()
    uOp.Event_ = ""
  End Sub
  Private Sub btnSettings_update_me_MouseHover(sender As Object, e As System.EventArgs) Handles btnSettings_update_me.MouseHover
    txtCon_help.Text = "Live updates are not implemented yet."
  End Sub
  Private Sub btnSettings_update_me_MouseLeave(sender As Object, e As System.EventArgs) Handles btnSettings_update_me.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnSettings_diagnostic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_diagnostic.Click
    ' Revised 2021.02.14.
    uOp.Event_ = "btnSettings_diagnostic_Click"
    uOp.Subr = uOp.Event_
    If Not tabControl_main.TabPages.Contains(tabDiagnostic) Then
      tabControl_main.TabPages.Insert(tabControl_main.TabCount, tabDiagnostic)
    End If
    tabControl_main.SelectTab(tabDiagnostic)
    uOp.Subr = uOp.Event_

    uOp.Subr = ""
    Call Statuslabel1_set()
    uOp.Event_ = ""
  End Sub
  Private Sub btnSettings_diagnostic_MouseHover(sender As Object, e As System.EventArgs) Handles btnSettings_diagnostic.MouseHover
    txtCon_help.Text = uApp.Short_name & " can check a number of internal things, in particular, do a detailed check of my own memory. This will open a new tab."
  End Sub
  Private Sub btnSettings_diagnostic_MouseLeave(sender As Object, e As System.EventArgs) Handles btnSettings_diagnostic.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnSettings_write_config_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_write_config.Click
    Call Config_xml_create()
  End Sub

  Private Sub btnSettings_okay_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_okay.Click
    ' Revised 2021.05.09.
    Dim tLocals As udtLocals = Nothing
    uOp.Event_ = "btnSettings_okay_click"
    tLocals.Subr = uOp.Event_
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr
    Call Statuslabel1_set("Saving settings...")
    Me.DialogResult = System.Windows.Forms.DialogResult.OK

    tLocals.Action = "Check settings common"
    If txtSettings_first_name.Text <> "" And uUser.First_name <> txtSettings_first_name.Text Then
      uUser.First_name = txtSettings_first_name.Text
      uUser.Preferences_changed = True
      Call Speak_it(uOp.Subr, "Hello " & uUser.First_name, 2)
    End If

    tLocals.Action = "Check minimise to system tray"
    If uUser.Min_sys_tray <> chkSettings_min_sys_tray.Checked Then
      uUser.Min_sys_tray = chkSettings_min_sys_tray.Checked
      uUser.Preferences_changed = True
    End If

    tLocals.Action = "Check speech value"
    If uUser.Speech <> scrolSettings_speech.Value Then
      uUser.Speech = scrolSettings_speech.Value
      uUser.Preferences_changed = True
    End If

    tLocals.Action = "Check start home tab"
    If rdoSettings_start_home_tab.Checked Or rdoSettings_start_last_tab.Checked Then
      ' Only set if one of the radio buttons is selected.
      If rdoSettings_start_home_tab.Checked Then
        If uUser.Start_home_tab <> udtStandard_off_on.On_ Then uUser.Preferences_changed = True
        uUser.Start_home_tab = udtStandard_off_on.On_
      ElseIf rdoSettings_start_last_tab.Checked Then
        If uUser.Start_home_tab <> udtStandard_off_on.Off Then uUser.Preferences_changed = True
        uUser.Start_home_tab = udtStandard_off_on.Off
      End If
    End If

    tLocals.Action = "Check error reporting"
    If uApp.Email_udt.Smtp_working <> chkSettings_error_reporting.Checked Then
      uApp.Email_udt.Smtp_working = chkSettings_error_reporting.Checked
      uUser.Preferences_changed = True
    End If

    tLocals.Action = "Check regional settings"
    If uActive.Country <> cboSettings_country.Text Then
      uUser.Preferences_changed = True
      uActive.Country = cboSettings_country.Text
    End If
    If uActive.Currency_symbol <> txtSettings_currency_symbol.Text Then
      uUser.Preferences_changed = True
      uActive.Currency_symbol = txtSettings_currency_symbol.Text
    End If
    If uActive.Currency_format <> txtSettings_currency_format.Text Then
      uUser.Preferences_changed = True
      uActive.Currency_format = txtSettings_currency_format.Text
    End If

    tLocals.Action = "Check theme"
    tLocals.Msg = uUser.Theme

    If rdoSettings_theme_light.Checked Or rdoSettings_theme_dark.Checked Or rdoSettings_theme_system.Checked Then
      ' Only set if one of the radio buttons is selected.
      If rdoSettings_theme_light.Checked Then
        If uUser.Theme <> udtTheme.Light Then uUser.Preferences_changed = True
        uUser.Theme = udtTheme.Light
      ElseIf rdoSettings_theme_dark.Checked Then
        If uUser.Theme <> udtTheme.Dark Then uUser.Preferences_changed = True
        uUser.Theme = udtTheme.Dark
      ElseIf rdoSettings_theme_system.Checked Then
        If uUser.Theme <> udtTheme.System Then uUser.Preferences_changed = True
        uUser.Theme = udtTheme.System
      Else
        uUser.Theme = udtTheme.Null
      End If
    End If

    Call Settings_theme_set()
    uOp.Subr = tLocals.Subr

    tLocals.Action = "Check settings application specific"

    If uUser.Preferences_changed Then Call Preferences_write()
    If uUser.Tab_last <> "" Then tabControl_main.SelectTab(uUser.Tab_last)

    uOp.Subr = ""
    Call Statuslabel1_set()
    uOp.Event_ = ""
  End Sub
  Private Sub btnSettings_okay_MouseHover(sender As Object, e As System.EventArgs) Handles btnSettings_okay.MouseHover
    txtCon_help.Text = "Click the Okay button when you are happy with the settings, and they will be saved; then you will be returned to the tab you came from."
  End Sub
  Private Sub btnSettings_okay_MouseLeave(sender As Object, e As System.EventArgs) Handles btnSettings_okay.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Private Sub btnSettings_cancel_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSettings_cancel.Click
    ' Revised 2020.03.22.
    Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
    uUser.Cancel = True
    ' Re-select the tab that was previously selected.
    If uUser.Tab_last <> "" Then tabControl_main.SelectTab(uUser.Tab_last)
  End Sub
  Private Sub btnSettings_cancel_MouseHover(sender As Object, e As System.EventArgs) Handles btnSettings_cancel.MouseHover
    txtCon_help.Text = "Click the Cancel button to not save any changes to the settings; you will be returned to the tab you came from."
  End Sub
  Private Sub btnSettings_cancel_MouseLeave(sender As Object, e As System.EventArgs) Handles btnSettings_cancel.MouseLeave
    Call Context_sensitive_help_set()
  End Sub

  Sub Settings_theme_set()
    ' Started 2018.12.29. Revised 2021.02.07.
    ' Ref. www.mztools.com/articles/2005/MZ2005001.aspx.
    uOp.Subr = "Theme set"

    ' Stop ' To do, to develop:

    If rdoSettings_theme_light.Checked Then
      ' Stop
      For Each tControl As Control In Me.Controls
        Dim tType As String = tControl.Name
        Dim tName As String = ""
        If TypeOf tControl Is Form Then
          Stop
        ElseIf TypeOf tControl Is Label Then
          Stop
        ElseIf TypeOf tControl Is Control Then
          ' Stop
        ElseIf TypeOf tControl Is System.ComponentModel.IComponent Then
          Stop
        Else
          Stop
        End If
      Next
      Me.BackColor = SystemColors.Window

    ElseIf rdoSettings_theme_dark.Checked Then
      For Each tControl As Control In Me.Controls
        Dim tType As String = tControl.Name
        Dim tName As String = ""
        If TypeOf tControl Is Form Then
          Stop
        ElseIf TypeOf tControl Is Label Then
          Stop
        ElseIf TypeOf tControl Is Control Then
          ' Stop
        ElseIf TypeOf tControl Is System.ComponentModel.IComponent Then
          Stop
        Else
          Stop
        End If
      Next
      Me.BackColor = Color.Black

    ElseIf rdoSettings_theme_system.Checked Then
      ' Reference, https://www.mztools.com/articles/2012/MZ2012012.aspx.
      ' Stop ' To do, to develop.

    End If

    uOp.Subr = ""
  End Sub

#End Region ' End region, "Tab Settings."

#Region "Tab System Information"
  ' Written 2018.10.17. Revised 2021.03.18.

  Private Sub tabSystem_information_preparation()
    ' Written 2018.10.17. Revised 2021.03.18.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "tabSystem_information preparation"
    uOp.Subr = tLocals.Subr
    Call Statuslabel1_set("Loading...")
    Call Form_minimum_size()
    uOp.Subr = tLocals.Subr
    uOp.Called_from = tLocals.Subr

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Set form elements"
    uApp.Progressbar_show = True
    If uOp.Form_initialising Then
      uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 7
    Else
      uApp.Progressbar_steps_total = 7
    End If
    Call ToolStripProgressBar1_set()

    tLocals.Action = "Populating environment dump"
    If Dir(uMachine.Environment_dump, FileAttribute.Normal) = "" Then
      If uOp.Form_initialising Then
        uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 1
      Else
        uApp.Progressbar_steps_total = 1
      End If
      Call Environment_dump(False)
      Call ToolStripProgressBar1_set()
    End If
    txtSystem_information_environment_dump.Text = System.IO.File.ReadAllText(uMachine.Environment_dump)
    txtSystem_information_environment_dump.Select(0, 0)

    tLocals.Action = "Populating System Information list"
    Call Statuslabel1_set(tLocals.Subr & ", " & tLocals.Action & "...")
    ' lstvSystem_information.Items.Clear()
    If lstvSystem_information.Items.Count = 0 Then
      tLocals.Action = "Add each property of the SystemInformation class to the list box:"
      Dim t As Type = GetType(System.Windows.Forms.SystemInformation)
      Dim pi As PropertyInfo() = t.GetProperties()
      For i As Integer = 0 To pi.Length - 1
        lstvSystem_information.Items.Add(pi(i).Name)
      Next i
    End If
    Call ToolStripProgressBar1_set()

    lstvSystem_information.Sort()
    lstvSystem_information.Columns(0).AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent)
    tLocals.Msg = lstvSystem_information.Items.Count
    For Each tRow As ListViewItem In lstvSystem_information.Items
      tRow.SubItems.Add(System_information_get_property_value_fn(tRow.Text).ToString)
    Next
    lstvSystem_information.Columns(1).AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent)
    Call ToolStripProgressBar1_set()

    tLocals.Action = "Configure the list item selected handler for the list box to invoke a method that displays the value of each property"
    Call ToolStripProgressBar1_set()

    txtSystem_information_environment_dump.Focus()
    uOp.Subr = ""
    Call Statuslabel1_set()
    uOp.Success = True
  End Sub

  Private Function System_information_get_property_value_fn(ByVal tProperty_name As String) As Object
    ' Separated 2018.10.20. Revised 2021.03.16.
    System_information_get_property_value_fn = Nothing
    If tProperty_name Is Nothing Then Exit Function

    If tProperty_name = "PowerStatus" Then
      ' Cycle and display the values of each property of the PowerStatus property.
      Dim t As Type = GetType(System.Windows.Forms.PowerStatus)
      Dim pi As PropertyInfo() = t.GetProperties()
      For i As Integer = 0 To pi.Length - 1
        Dim tProperty_value As Object = pi(i).GetValue(SystemInformation.PowerStatus, Nothing)
        System_information_get_property_value_fn = "(See text box for details.)"
      Next i
    Else
      ' Display the value of the selected property of the SystemInformation type:
      Dim t As Type = GetType(System.Windows.Forms.SystemInformation)
      Dim pi As PropertyInfo() = t.GetProperties()
      Dim tProperty As PropertyInfo = Nothing
      For i As Integer = 0 To pi.Length - 1
        If pi(i).Name = tProperty_name Then
          tProperty = pi(i)
          Exit For
        End If
      Next i
      If tProperty = Nothing Then
        Stop
      Else
        System_information_get_property_value_fn = tProperty.GetValue(Nothing, Nothing)
      End If
    End If
  End Function

#End Region ' End region, "Tab System Information."

#Region "Tab Play"

  Sub tabPlay_preparation()
    TabControl1.Appearance = TabAppearance.FlatButtons
    TabControl1.ItemSize = New Size(0, 1)
    TabControl1.SizeMode = TabSizeMode.Fixed
    uOp.Success = True

  End Sub

#End Region ' End region, "Tab Play"

#End Region ' End region, "Tabs common."

#Region "Application specific common sub-routines"

  Sub Template_testing()
    ' Separated 2019.11.09. Revised 2021.03.13.
    Dim tLocals As udtLocals = Nothing
    tLocals.Subr = "Template testing"
    uOp.Subr = tLocals.Subr
    tLocals.Status = udtuStandard_texts.Initiation
    Call Log_write(tLocals, 0)
    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Status = ""

    ' uOp.Success = True ' Turn off if something fails.

    ' Stop ' Indefinite.

    Select Case uMachine.Name
      Case "LIS_SERVER", uMachine.Development_machine_name

        uOp.Subr = tLocals.Subr
    End Select
    If uOp.Event_ <> "" And tLocals.Error_count = 0 And uError.Number = 0 And uApp.Terminating = 0 Then tLocals.Success = udtBoolean_extended.True_

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

#End Region ' End region, "Application specific common sub-routines."

#Region "Tabs application specific"

#Region "Tab Music"
  ' Created 2018.03.14. Revised 2021.04.07.

  Structure udtFile_extended_properties
    ' Written 2019.01.05.
    Public Name_0 As String
    Public Size_1 As String
    Public Item_type_2 As String
    Public Date_modified_3 As String
    Public Date_created_4 As String
    Public Date_accessed_5 As String
    Public Attributes_6 As String
    Public Offline_status_7 As String
    Public Availability_8 As String
    Public Perceived_type_9 As String
    Public Owner_10 As String
    Public Kind_11 As String
    Public Date_taken_12 As String
    Public Contributing_artists_13 As String
    Public Album_14 As String
    Public Year_15 As String
    Public Genre_16 As String
    Public Conductors_17 As String
    Public Tags_18 As String
    Public Rating_19 As String
    Public Authors_20 As String
    Public Title_21 As String
    Public Subject_22 As String
    Public Categories_23 As String
    Public Comments_24 As String
    Public Copyright_25 As String
    Public Hash_26 As String
    Public Length_27 As String
    Public Bit_rate_28 As String
    Public Protected_29 As String
    Public Camera_model_30 As String
    Public Dimensions_31 As String
    Public Camera_maker_32 As String
    Public Company_33 As String
    Public File_description_34 As String
  End Structure

  Sub tabMusic_preparation()
    ' Created 2018.03.14. Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing
    Dim tFile As udtFile = Nothing

    tLocals.Subr = "tabMusic preparation"
    tFile.Extended = New udtFile_extended_properties
    uOp.Subr = tLocals.Subr
    tLocals.Status = udtuStandard_texts.Initiation
    Call Statuslabel1_set("Loading...")
    uOp.Result = ""

    tLocals.Action = udtuStandard_texts.Main_start
    tLocals.Action = "Set form elements"
    gMusic.Path_start = "C:\Users\myk_h\OneDrive\New stuff and to do's"
    tFile.File_path = gMusic.Path_start
    btnMusic_swap.Enabled = False
    btnMusic_save_one.Enabled = False
    btnMusic_Google_it.Enabled = False
    Me.AcceptButton = btnMusic_save_one

    uOp.Success = True
    uOp.Subr = ""
  End Sub

  Private Sub File_extended_properties_null(ByRef tFile As udtFile)
    ' Separated 2019.12.02. Revised 2021.04.07.
    uOp.Subr = "File extended properties null"

    With tFile.Extended
      .Name_0 = Nothing
      .Size_1 = Nothing
      .Item_type_2 = Nothing
      .Date_modified_3 = Nothing
      .Date_created_4 = Nothing
      .Date_accessed_5 = Nothing
      .Attributes_6 = Nothing
      .Offline_status_7 = Nothing
      .Availability_8 = Nothing
      .Perceived_type_9 = Nothing
      .Owner_10 = Nothing
      .Kind_11 = Nothing
      .Date_taken_12 = Nothing
      .Contributing_artists_13 = Nothing
      .Album_14 = Nothing
      .Year_15 = Nothing
      .Genre_16 = Nothing
      .Conductors_17 = Nothing
      .Tags_18 = Nothing
      .Rating_19 = Nothing
      .Authors_20 = Nothing
      .Title_21 = Nothing
      .Subject_22 = Nothing
      .Categories_23 = Nothing
      .Comments_24 = Nothing
      .Copyright_25 = Nothing
      .Hash_26 = Nothing
      .Length_27 = Nothing
      .Bit_rate_28 = Nothing
      .Protected_29 = Nothing
      .Camera_model_30 = Nothing
      .Dimensions_31 = Nothing
      .Camera_maker_32 = Nothing
      .Company_33 = Nothing
      .File_description_34 = Nothing
    End With

    uOp.Subr = ""
  End Sub

  Private Sub Determine_file_properties_get_extended_properties(ByRef tFile As udtFile)
    ' Separated 2019.01.05. Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    uOp.Subr = "Determine file properties get extended properties"

    Dim tShell As Shell32.Shell = New Shell32.Shell
    Dim tFolder As Shell32.Folder
    tFolder = tShell.NameSpace(tFile.File_path)
    Dim tFolder_item As Shell32.FolderItem
    tFolder_item = tFolder.ParseName(tFile.File_name)
    If tFolder_item IsNot Nothing Then
      ' https://docs.microsoft.com/en-us/windows/desktop/shell/folder-getdetailsof.
      With tFile.Extended
        .Name_0 = tFolder.GetDetailsOf(tFolder_item, 0)
        .Size_1 = tFolder.GetDetailsOf(tFolder_item, 1)
        .Item_type_2 = tFolder.GetDetailsOf(tFolder_item, 2)
        .Date_modified_3 = tFolder.GetDetailsOf(tFolder_item, 3)
        .Date_created_4 = tFolder.GetDetailsOf(tFolder_item, 4)
        .Date_accessed_5 = tFolder.GetDetailsOf(tFolder_item, 5)
        .Attributes_6 = tFolder.GetDetailsOf(tFolder_item, 6)
        .Offline_status_7 = tFolder.GetDetailsOf(tFolder_item, 7)
        .Availability_8 = tFolder.GetDetailsOf(tFolder_item, 8)
        .Perceived_type_9 = tFolder.GetDetailsOf(tFolder_item, 9)
        .Owner_10 = tFolder.GetDetailsOf(tFolder_item, 10)
        .Kind_11 = tFolder.GetDetailsOf(tFolder_item, 11)
        .Date_taken_12 = tFolder.GetDetailsOf(tFolder_item, 12)
        .Contributing_artists_13 = tFolder.GetDetailsOf(tFolder_item, 13)
        .Album_14 = tFolder.GetDetailsOf(tFolder_item, 14)
        .Year_15 = tFolder.GetDetailsOf(tFolder_item, 15)
        .Genre_16 = tFolder.GetDetailsOf(tFolder_item, 16)
        .Conductors_17 = tFolder.GetDetailsOf(tFolder_item, 17)
        .Tags_18 = tFolder.GetDetailsOf(tFolder_item, 18)
        .Rating_19 = tFolder.GetDetailsOf(tFolder_item, 19)
        .Authors_20 = tFolder.GetDetailsOf(tFolder_item, 20)
        .Title_21 = tFolder.GetDetailsOf(tFolder_item, 21)
        .Subject_22 = tFolder.GetDetailsOf(tFolder_item, 22)
        .Categories_23 = tFolder.GetDetailsOf(tFolder_item, 23)
        .Comments_24 = tFolder.GetDetailsOf(tFolder_item, 24)
        .Copyright_25 = tFolder.GetDetailsOf(tFolder_item, 25)
        .Hash_26 = tFolder.GetDetailsOf(tFolder_item, 26)
        .Length_27 = tFolder.GetDetailsOf(tFolder_item, 27)
        .Bit_rate_28 = tFolder.GetDetailsOf(tFolder_item, 28)
        .Protected_29 = tFolder.GetDetailsOf(tFolder_item, 29)
        .Camera_model_30 = tFolder.GetDetailsOf(tFolder_item, 30)
        .Dimensions_31 = tFolder.GetDetailsOf(tFolder_item, 31)
        .Camera_maker_32 = tFolder.GetDetailsOf(tFolder_item, 32)
        .Company_33 = tFolder.GetDetailsOf(tFolder_item, 33)
        .File_description_34 = tFolder.GetDetailsOf(tFolder_item, 34)
      End With
    End If

    tFolder_item = Nothing
    tFolder = Nothing
    tShell = Nothing
    uOp.Subr = ""
  End Sub

  Private Sub Determine_file_properties_mp3_properties()
    ' See frmMain.tabMusic.
  End Sub

  Private Sub dgvMusic_naming_SelectionChanged(sender As Object, e As System.EventArgs) Handles dgvMusic_naming.SelectionChanged
    ' Written 2019.10.05. Revised 2021.03.04.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    tLocals.Subr = "dgvMusic_naming_SelectionChanged"
    If uOp.Form_initialising And uOp.Called_from <> udtgApplication_subroutine_names.Music_renamer Then GoTo Ender_partial
    If uOp.Called_from = udtApplication_subroutine_names.tabControl_main_SelectedIndexChanged Then GoTo Ender_partial
    If uOp.Called_from = udtgApplication_subroutine_names.dgvMusic_naming_clear Then GoTo Ender_partial
    If uOp.Event_ = "" Then uOp.Event_ = tLocals.Subr
    uOp.Subr = uOp.Event_
    Call Gmusic_clear()
    uOp.Subr = tLocals.Subr
    Call dgvMusic_details_clear_contents()
    uOp.Subr = tLocals.Subr
    Call Statuslabel2_set("")
    Me.Refresh()

Main:
    tLocals.Action = udtuStandard_texts.Main_start
    If dgvMusic_naming.Rows.Count >= 1 Then
      tLocals.Action = "Determine file basic meta-data"
      If uApp.Debug Then tLocals.Msg = dgvMusic_details.Rows.Count
      gMusic.File_original_name = dgvMusic_naming.SelectedCells(dgvMusic_naming_Original_name.Index).Value
      gMusic.File_new_name = Trim(dgvMusic_naming.SelectedCells(dgvMusic_naming_New_name.Index).Value)
      If gMusic.File_new_name = "" Then
        ' Means initialising; the data grid view is being populated.
        uOp.Success = False
      Else
        tLocals.Action = "Populate gMusic"
        Dim tFile_new_name As String = gMusic.File_new_name
        If InStr(gMusic.File_new_name, ",") = 0 Then
          ' Stop
          If InStr(gMusic.File_new_name, "-") = 0 Then
            ' Stop
          Else
            gMusic.Track_artist = VB.Left(gMusic.File_new_name, InStr(gMusic.File_new_name, "-") - 1)
            tFile_new_name = VB.Mid(gMusic.File_new_name, InStr(gMusic.File_new_name, "-") + 1)
            If InStr(tFile_new_name, "(") = 0 Then
              gMusic.Track_title = tFile_new_name
            Else
              If gMusic.Track_album = "" Then
                gMusic.Track_album = Mid(tFile_new_name, InStr(tFile_new_name, "(") + 1, 999)
                gMusic.Track_album = VB.Left(gMusic.Track_album, InStr(gMusic.Track_album, ")") - 1)
                gMusic.Track_title = Trim(VB.Left(tFile_new_name, InStr(tFile_new_name, "(") - 1))
              Else
                Stop
              End If
            End If
          End If
        Else
          gMusic.Track_artist = VB.Left(gMusic.File_new_name, InStr(gMusic.File_new_name, ",") - 1)
          tFile_new_name = VB.Mid(gMusic.File_new_name, InStr(gMusic.File_new_name, ",") + 1)
          If InStr(tFile_new_name, "(") = 0 Then
            gMusic.Track_title = tFile_new_name
          Else
            If gMusic.Track_album = "" Then
              gMusic.Track_album = Mid(tFile_new_name, InStr(tFile_new_name, "(") + 1, 999)
              gMusic.Track_album = VB.Left(gMusic.Track_album, InStr(gMusic.Track_album, ")") - 1)
              gMusic.Track_title = Trim(VB.Left(tFile_new_name, InStr(tFile_new_name, "(") - 1))
            Else
              Stop
            End If
          End If
        End If

        Call Gmusic_conditioning(True)
        uOp.Subr = tLocals.Subr

        tLocals.Action = "Check integrity"
        gMusic.File_original_full_name = gMusic.Path_start & "\" & gMusic.File_original_name
        If Dir(gMusic.File_original_full_name) = "" Then
          Call Form_refresh(False)
          GoTo Ender_partial
        End If

        Call dgvMusic_details_fill()
        uOp.Subr = tLocals.Subr

        tLocals.Action = "Check for existing mp3 meta-data"
        Call Mp3_tag_v1_get()
        uOp.Subr = tLocals.Subr
        If Not uOp.Success Then
          Stop ' Permanent.
          tLocals.Error_count = tLocals.Error_count + 1
          uOp.Success = False
          GoTo Ender_partial
        End If

        uOp.Success = True
      End If
      Me.Refresh()
    Else
      uOp.Success = True
    End If ' If dgvMusic_naming.Rows.Count >= 1 Then

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
    dgvMusic_naming.Focus()

Ender_partial:
    uOp.Subr = ""
    If uOp.Event_ = tLocals.Subr Then uOp.Event_ = ""
  End Sub

  Private Sub MusicdgvDetails_CellEndEdit(sender As Object, e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvMusic_details.CellEndEdit
    ' Created 2019.10.05. Revised 2019.12.31.
    uOp.Subr = "MusicdgvDetails_CellEndEdit"

    If dgvMusic_details.Item(0, 0).Value = "" Then
      gMusic.Track_artist = Trim(dgvMusic_details.Item(1, 0).Value)
      dgvMusic_details.Item(0, 0).Value = Trim(dgvMusic_details.Item(1, 0).Value)
    Else
      gMusic.Track_artist = Trim(dgvMusic_details.Item(0, 0).Value)
    End If

    If dgvMusic_details.Item(0, 1).Value = "" Then
      gMusic.Track_album = Trim(dgvMusic_details.Item(1, 1).Value)
      dgvMusic_details.Item(0, 1).Value = Trim(dgvMusic_details.Item(1, 1).Value)
    Else
      gMusic.Track_album = Trim(dgvMusic_details.Item(0, 1).Value)
    End If

    If dgvMusic_details.Item(0, 2).Value = "" Then
      gMusic.Track_year = Trim(dgvMusic_details.Item(1, 2).Value)
      dgvMusic_details.Item(0, 2).Value = Trim(dgvMusic_details.Item(1, 2).Value)
    Else
      gMusic.Track_year = Trim(dgvMusic_details.Item(0, 2).Value)
    End If

    If dgvMusic_details.Item(0, 3).Value = "" Then
      gMusic.Track_number = Trim(dgvMusic_details.Item(1, 3).Value)
      dgvMusic_details.Item(0, 3).Value = Trim(dgvMusic_details.Item(1, 3).Value)
    Else
      gMusic.Track_number = Trim(dgvMusic_details.Item(0, 3).Value)
    End If

    If dgvMusic_details.Item(0, 4).Value = "" Then
      gMusic.Track_title = Trim(dgvMusic_details.Item(1, 4).Value)
      dgvMusic_details.Item(0, 4).Value = Trim(dgvMusic_details.Item(1, 4).Value)
    Else
      gMusic.Track_title = Trim(dgvMusic_details.Item(0, 4).Value)
    End If

    If dgvMusic_details.Item(0, 5).Value = "" Then
      gMusic.Track_comment = Trim(dgvMusic_details.Item(1, 5).Value)
      dgvMusic_details.Item(0, 5).Value = Trim(dgvMusic_details.Item(1, 5).Value)
    Else
      gMusic.Track_comment = Trim(dgvMusic_details.Item(0, 5).Value)
    End If

    If dgvMusic_details.Item(0, 6).Value = "" And dgvMusic_details.Item(1, 6).Value = "" Then

    Else
      Stop
    End If
    ' [Enum].GetName(GetType(MP3_Id3_v1.Genres), CInt(objMP3_v1.Frame(MP3_Id3_v1.Frame_types.Genre)))
    If dgvMusic_details.Item(0, 6).Value = "" Then
      gMusic.Track_genre = Trim(dgvMusic_details.Item(1, 6).Value)
      dgvMusic_details.Item(0, 6).Value = Trim(dgvMusic_details.Item(1, 6).Value)
    Else
      gMusic.Track_genre = Trim(dgvMusic_details.Item(0, 6).Value)
    End If

    If dgvMusic_details.Columns(0).Width < 200 Then dgvMusic_details.Columns(0).Width = 200
    If dgvMusic_details.Columns(1).Width < 200 Then dgvMusic_details.Columns(1).Width = 200
    ' btnMusic_save_one.Focus()

    uOp.Subr = ""
  End Sub

  Private Sub btnMusic_gmusic_clear_album_Click(sender As System.Object, e As System.EventArgs) Handles btnMusic_gmusic_clear_album.Click
    ' Written 2019.10.14. Revised 2021.02.15.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    uOp.Event_ = "btnMusic_gmusic_clear_album_Click"
    tLocals.Subr = uOp.Event_
    gMusic.Track_title = gMusic.Track_title & ", " & gMusic.Track_album
    gMusic.Track_album = ""
    Call dgvMusic_details_fill()
    tLocals.Success = udtBoolean_extended.True_

    btnMusic_save_one.Focus()

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
    uOp.Event_ = ""
  End Sub

  Private Sub btnMusic_mp3_tag_clear_artist_Click(sender As System.Object, e As System.EventArgs) Handles btnMusic_mp3_tag_clear_artist.Click
    ' Written 2019.10.26. Revised 2021.02.15.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    tLocals.Subr = "btnMusic_mp3_tag_clear_artist_Click"
    dgvMusic_details.Item(1, 0).Value = ""
    Me.Refresh()
    btnMusic_save_one.Focus()
    tLocals.Success = udtBoolean_extended.True_

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
  End Sub

  Private Sub btnMusic_mp3_tag_clear_album_Click(sender As System.Object, e As System.EventArgs) Handles btnMusic_mp3_tag_clear_album.Click
    ' Written 2019.10.24. Revised 2021.02.15.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    tLocals.Subr = "btnMusic_mp3_tag_clear_album_Click"
    dgvMusic_details.Item(1, 1).Value = ""
    Me.Refresh()
    btnMusic_save_one.Focus()
    tLocals.Success = udtBoolean_extended.True_

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
  End Sub

  Sub tabMusic_load_files()
    ' Separated 2018.04.28. Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tFile As udtFile = Nothing

    Dim tDi As System.IO.DirectoryInfo = New System.IO.DirectoryInfo(gMusic.Path_start)
    tLocals.Subr = "Music load files"
    uOp.Subr = tLocals.Subr
    tLocals.Status = udtuStandard_texts.Initiation
    Call Log_write(tLocals, 0)
    tLocals.Msg = "Searching for music and populating list..."
    uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + 1
    Call Statuslabel1_set(tLocals.Msg)
    Call Statuslabel2_set("I am checking " & tDi.GetFiles().Length & " files.")

    If dgvMusic_naming.Rows.Count = 0 Then
      tLocals.Action = "Check " & tFile.File_path
      gMusic.File_count = 0

      For Each tFile.File_full_name In My.Computer.FileSystem.GetFiles(gMusic.Path_start)
        If Not File_properties_determine_fn(tFile) Then Stop
        If tFile.File_extension = ".mp3" Or tFile.File_extension = ".wma" Then
          dgvMusic_naming.Rows.Add(tFile.File_name)
          uOp.Subr = tLocals.Subr
          gMusic.File_count = gMusic.File_count + 1
        End If
      Next
      If Not File_properties_determine_fn(tFile) Then Stop
      gMusic.Message = "I found " & gMusic.File_count & " music files."
      Call Statuslabel2_set(gMusic.Message)

      tLocals.Action = "Check sub-folders"
      For Each tFile.File_path In My.Computer.FileSystem.GetDirectories(gMusic.Path_start, FileIO.SearchOption.SearchTopLevelOnly)
        Dim tSub_folder As String = Replace(tFile.File_path, gMusic.Path_start & "\Music\", "")
        tLocals.Action = "Check " & tSub_folder
        For Each tFile.File_full_name In My.Computer.FileSystem.GetFiles(tFile.File_path)
          If Not File_properties_determine_fn(tFile) Then Stop
          If tFile.File_extension = "mp3" Or tFile.File_extension = "wma" Then
            Stop ' To do, to develop.
            If tSub_folder = "" Then
              dgvMusic_naming.Rows.Add(tFile.File_name)
              gMusic.File_count = gMusic.File_count + 1
            Else
              dgvMusic_naming.Rows.Add(tSub_folder & "\" & tFile.File_name)
              gMusic.File_count = gMusic.File_count + 1
            End If
          End If
        Next
      Next
      If Not File_properties_determine_fn(tFile) Then Stop
      gMusic.Message = "I found " & gMusic.File_count & " music files."
      Call Statuslabel2_set(gMusic.Message)
      uOp.Subr = tLocals.Subr

      If gMusic.File_count > 0 Then
        uApp.Progressbar_steps_total = uApp.Progressbar_steps_total + gMusic.File_count
        Call Music_renamer()
        uOp.Subr = tLocals.Subr
        btnMusic_swap.Enabled = True
        btnMusic_save_one.Enabled = True
        btnMusic_Google_it.Enabled = True
      Else
        btnMusic_swap.Enabled = False
        btnMusic_save_one.Enabled = False
        btnMusic_Google_it.Enabled = False
      End If
    End If

    btnMusic_save_one.Focus()
    uOp.Success = True

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
    uOp.Success = True
  End Sub

  Private Sub Music_renamer()
    ' Separated 2018.06.04. Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tFile As udtFile = Nothing

    Dim i As Short = 0
    Dim tNew_name As String = ""
    Dim tdgvrow As DataGridViewRow
    tLocals.Subr = udtgApplication_subroutine_names.Music_renamer
    uOp.Subr = tLocals.Subr
    tLocals.Action = "Fix file naming"

    For Each tdgvrow In dgvMusic_naming.Rows
      gMusic.Track_album = Nothing
      gMusic.Track_artist = Nothing
      gMusic.Track_number = 0
      gMusic.Track_title = Nothing

      i = i + 1
      tNew_name = tdgvrow.Cells(dgvMusic_naming_Original_name.Name).Value
      If InStr(tNew_name, "\") > 0 Then
        tNew_name = Mid(tNew_name, InStr(tNew_name, "\") + 1)
      End If
      If InStr(tNew_name, "quot") > 0 Then
        Stop ' To do, to develop.
      End If
      tFile.File_full_name = gMusic.Path_start & "\" & tNew_name
      If File_properties_determine_fn(tFile) Then
        tNew_name = tFile.File_short_name
      Else
        Stop
      End If
      uOp.Subr = tLocals.Subr

      ' "In Strict Confidence – Rain Extended Versionfor★๖ۣۣۜL ๖ۣۣۜA ๖ۣۣۜN ๖ۣA★.mp3"
      tNew_name = Replace(tNew_name, "for★๖ۣۣۜL_๖ۣۣۜA_๖ۣۣۜN_๖ۣA★", "")
      tNew_name = Replace(tNew_name, "★", "")
      tNew_name = Replace(tNew_name, "๖", "")
      tNew_name = Replace(tNew_name, "ۣa", "")
      tNew_name = Replace(tNew_name, "ۣn", "")
      tNew_name = Replace(tNew_name, "ۣ", "")
      tNew_name = Replace(tNew_name, "ۜ", "")
      tNew_name = Replace(tNew_name, "FORL_A_N_A", "")

      ' "FLESH ╺╸ Black crown (320  kbps) (Mp3Converter.net).mp3"
      tNew_name = Replace(tNew_name, "╺╸", ", ")

      ' "『Lyrics』Blood Of A Lion - Beast In Black (320  kbps) (Mp3Converter.net).mp3")
      tNew_name = Replace(tNew_name, "『Lyrics』", ", ")

      tNew_name = Replace(tNew_name, " & ", " and ")
      tNew_name = Replace(tNew_name, "@", "at")
      tNew_name = Replace(tNew_name, "--", "-")
      tNew_name = Replace(tNew_name, "_", " ")
      tNew_name = Replace(tNew_name, "—", "-")
      tNew_name = Replace(tNew_name, "–", "-")
      tNew_name = Replace(tNew_name, " - ", ", ")
      tNew_name = Replace(tNew_name, "  ", " ")
      tNew_name = Replace(tNew_name, "'", "")
      tNew_name = LCase(tNew_name)
      tNew_name = Replace(tNew_name, ", official video", "")

      If InStr(tNew_name, "(1)") > 0 Then Stop
      If InStr(tNew_name, "(2)") > 0 Then Stop
      tNew_name = Replace(tNew_name, "(1)", "")
      tNew_name = Replace(tNew_name, "(2)", "")
      tNew_name = Replace(tNew_name, "(320 kbps)", "")
      ' tNew_name = Replace(tNew_name, "(extended version)", "")
      tNew_name = Replace(tNew_name, "(demo version)", "")
      tNew_name = Replace(tNew_name, "(industrial dance video)", "")
      tNew_name = Replace(tNew_name, "(lyrics on screen)", "")
      tNew_name = Replace(tNew_name, "(lyric video)", "")
      tNew_name = Replace(tNew_name, "(original song)", "")
      tNew_name = Replace(tNew_name, "(mp3converter.net)", "")
      tNew_name = Replace(tNew_name, "(music video)", "")
      tNew_name = Replace(tNew_name, "(live session)", "")
      tNew_name = Replace(tNew_name, "(lyrics)", "")
      tNew_name = Replace(tNew_name, "(official)", "")
      tNew_name = Replace(tNew_name, "(official audio)", "")
      tNew_name = Replace(tNew_name, "(official music video)", "")
      tNew_name = Replace(tNew_name, "(official video)", "")
      tNew_name = Replace(tNew_name, "(official video clip)", "")
      tNew_name = Replace(tNew_name, "(official video hd)", "")
      tNew_name = Replace(tNew_name, "(offizielles video)", "")
      tNew_name = Replace(tNew_name, "(official lyric video)", "")
      tNew_name = Replace(tNew_name, "(official video lyrics)", "")
      tNew_name = Replace(tNew_name, "(performance video)", "")
      tNew_name = Replace(tNew_name, "(with live singers)", "")

      tNew_name = Replace(tNew_name, "[hd]", "")
      tNew_name = Replace(tNew_name, "[hd, lyrics]", "")
      tNew_name = Replace(tNew_name, "[mp3converter.net]", "")
      tNew_name = Replace(tNew_name, "[official audio]", "")
      tNew_name = Replace(tNew_name, "[official music video]", "")
      tNew_name = Replace(tNew_name, "[official video]", "")

      If InStr(tNew_name, "feat") > 0 Then
        tNew_name = Replace(tNew_name, "feat. ", "featuring ")
        tNew_name = Replace(tNew_name, "feat ", "featuring ")
      End If
      tNew_name = Replace(tNew_name, " ft. ", " featuring ")
      tNew_name = Replace(tNew_name, "mt.", "mount")
      tNew_name = Replace(tNew_name, "mt", "mount")
      tNew_name = Replace(tNew_name, "music video", "")
      tNew_name = Replace(tNew_name, "official audio", "")
      tNew_name = Replace(tNew_name, "official music video", "")
      tNew_name = Replace(tNew_name, "official video", "")
      tNew_name = Replace(tNew_name, "official visual", "")
      tNew_name = Replace(tNew_name, "official", "")
      tNew_name = Replace(tNew_name, "lyric video", "")
      tNew_name = Replace(tNew_name, "napalm records", "")
      tNew_name = Replace(tNew_name, "original mix", "")
      tNew_name = Replace(tNew_name, "promo video", "")
      tNew_name = Replace(tNew_name, "video edit", "")
      tNew_name = Replace(tNew_name, "-vubey", "")
      tNew_name = Replace(tNew_name, " vubey", "")

      tNew_name = Replace(tNew_name, "  ", " ")
      tNew_name = Replace(tNew_name, "  ", " ")
      tNew_name = Replace(tNew_name, "  ", " ")
      tNew_name = Replace(tNew_name, "  ", " ")
      tNew_name = Replace(tNew_name, " ,", ",")
      tNew_name = Replace(tNew_name, " .", ".")

      tNew_name = English_convert_fn(tNew_name, True) ' !
      tNew_name = Title_case_fn(tNew_name) ' !
      uOp.Subr = tLocals.Subr
      tLocals.Action = "Fix file naming"

      tNew_name = Replace(tNew_name, " And ", " and ")
      tNew_name = Replace(tNew_name, " Full Album", " full album")
      tNew_name = Replace(tNew_name, " At ", " at ")
      tNew_name = Replace(tNew_name, " In ", " in ")
      tNew_name = Replace(tNew_name, " Of ", " of ")
      tNew_name = Replace(tNew_name, " The ", " the ")
      tNew_name = Replace(tNew_name, ", in ", ", In ")
      tNew_name = Replace(tNew_name, ", the ", ", The ")
      tNew_name = Trim(tNew_name)

      tdgvrow.Cells(dgvMusic_naming_New_name.Name).Value = tNew_name

      Call ToolStripProgressBar1_set()
      Call Statuslabel2_set("Processed " & i & " of " & gMusic.File_count & " records.")
      uOp.Subr = tLocals.Subr
      Me.Refresh()

      tNew_name = ""
      If Not File_properties_determine_fn(tFile) Then Stop
      uOp.Subr = tLocals.Subr
    Next

    dgvMusic_naming.Rows(0).Selected = True
    uOp.Called_from = uOp.Subr
    Call dgvMusic_naming_SelectionChanged(Nothing, Nothing)
    uOp.Subr = tLocals.Subr
    Me.Refresh()
    uOp.Success = True

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
  End Sub

  Private Sub btnMusic_swap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMusic_swap.Click
    ' Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tFile As udtFile = Nothing
    uOp.Subr = "btn_Swap_Click"
    tLocals.Action = "Swap before and after a comma"

    tFile.File_short_name = dgvMusic_naming.CurrentRow.Cells(dgvMusic_naming_New_name.Name).Value
    tFile.File_short_name = Mid(tFile.File_short_name, InStr(tFile.File_short_name, ", ") + 2) & ", " & Microsoft.VisualBasic.Left(tFile.File_short_name, InStr(tFile.File_short_name, ",") - 1)
    dgvMusic_naming.CurrentRow.Cells(dgvMusic_naming_New_name.Name).Value = tFile.File_short_name
    Call dgvMusic_naming_SelectionChanged(Nothing, Nothing)
    btnMusic_save_one.Focus()
    tLocals.Action = ""
    uOp.Subr = ""
  End Sub

  Private Sub btnMusic_save_one_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMusic_save_one.Click
    ' Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tFile As udtFile = Nothing

    Dim tPrompt As String = ""
    tLocals.Subr = "btnMusic_save_one_Click"
    uOp.Event_ = tLocals.Subr
    uOp.Subr = tLocals.Subr
    tLocals.Action = udtuStandard_texts.Initiation
    tLocals.Status = udtuStandard_texts.Initiation
    gMusic.File_new_name = ""
    If Not File_properties_determine_fn(tFile) Then Stop

    tLocals.Action = udtuStandard_texts.Main_start
    If dgvMusic_naming.Rows.Count > 0 Then
      gMusic.File_original_name = dgvMusic_naming.CurrentRow.Cells(0).Value
      Call Gmusic_conditioning(True)
      uOp.Subr = tLocals.Subr

      tPrompt = "Please edit the file name before saving. The original name was: " & vbCrLf
      tPrompt = tPrompt & gMusic.File_original_name & "." & vbCrLf
      tPrompt = tPrompt & "Use parentheses for the album title."
      gMusic.File_new_name = Inputbox_LIS(tPrompt, gMusic.File_new_name, tabControl_main, udtDialogue_position.Bottom_right)
      If uDialogue.Dialogue_result = DialogResult.None Or uDialogue.Dialogue_result = DialogResult.Cancel Then
      Else
        gMusic.Track_title = gMusic.File_new_name
        Call btnMusic_save_one_Click_part_2()
      End If
      uOp.Subr = tLocals.Subr
    Else
      Stop ' Indefinite.
    End If

    uOp.Subr = ""
    uOp.Event_ = ""
  End Sub

  Sub btnMusic_save_one_Click_part_2()
    ' Separated 2019.04.16. Revised 2021.04.06.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tFile As udtFile = Nothing

    tLocals.Subr = "btnMusic_save_one_Click_part_2"
    uOp.Subr = tLocals.Subr
    tLocals.Status = udtuStandard_texts.Initiation
    If gMusic.File_new_name = "" Then
      Stop ' Permanent.
      uOp.Subr = ""
      GoTo Ender_partial
    End If

    tLocals.Action = udtuStandard_texts.Main_start
    Call Gmusic_conditioning(False)
    uOp.Subr = tLocals.Subr
    If Not uOp.Success Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      uOp.Success = False
      GoTo Error_process
    End If
    uOp.Success = False

    If Dir(gMusic.File_original_full_name) = "" Then
      Stop ' To do, to test:
      Call Form_refresh(False)
      GoTo Error_process
    End If

    If gMusic.Track_artist <> tFile.Extended.Contributing_artists_13 Then
      Call Mp3_tag_v1_set()
      If uOp.Success Then
        tLocals.Success = uOp.Success
      Else
        Call Mp3_tag_v2_set()
      End If
    End If
    uOp.Subr = tLocals.Subr
    uOp.Success = False

    If tLocals.Success Then
      tLocals.Action = "Save it"
      If Dir(tFile.File_path, FileAttribute.Directory) = "" Then System.IO.Directory.CreateDirectory(tFile.File_path)
      If gMusic.Track_album <> "" Then
        tFile.File_path = tFile.File_path & "\" & gMusic.Track_album
        If Dir(tFile.File_path, FileAttribute.Directory) = "" Then System.IO.Directory.CreateDirectory(tFile.File_path)
        gMusic.File_new_full_name = tFile.File_path & "\" & gMusic.File_new_name & "." & gMusic.File_extension
      End If
      gMusic.File_new_full_name = tFile.File_path & "\" & gMusic.File_new_name & "." & gMusic.File_extension
      tFile.Copy_source = gMusic.File_original_full_name
      tFile.Copy_destination = gMusic.File_new_full_name
      If Dir(tFile.Copy_source, FileAttribute.Normal) = "" Then
        Stop ' Permanent.
        tLocals.Error_count = tLocals.Error_count + 1
        tLocals.Status = udtuStandard_texts.Failed
        tLocals.Success = udtBoolean_extended.False_
        GoTo Error_process
      Else
        If Dir(tFile.Copy_destination, FileAttribute.Normal) = "" Then
          FileCopy(tFile.Copy_source, tFile.Copy_destination)
          tLocals.Success = udtBoolean_extended.True_
        Else
          tLocals.Success = udtBoolean_extended.False_
          uError.Message = "A file with this name already exists."
          Call Msgbox_LIS(uError.Message, udtAlert_types.Information, udtDialogue_types.Okay_only, tabMusic, udtDialogue_position.Bottom_right)
        End If
      End If
      If tLocals.Success Then
        tLocals.Action = "Delete file " & tFile.Copy_source
        Kill(tFile.Copy_source)
        tLocals.Msg = dgvMusic_naming.CurrentRow.Cells(dgvMusic_naming_New_name.Name).Value
        dgvMusic_naming.Rows.RemoveAt(dgvMusic_naming.CurrentRow.Index)
      End If

      If dgvMusic_naming.Rows.Count >= 1 Then
        If dgvMusic_naming.CurrentRow.Cells(0).Value = "" Then dgvMusic_naming.Rows(0).Selected = True
      End If
      Me.Refresh()

    Else ' If  tLocals.Success  Then
      Stop ' Permanent.
      tLocals.Error_count = tLocals.Error_count + 1
      tLocals.Success = udtBoolean_extended.False_
      GoTo Error_process
    End If ' If  tLocals.Success  Then

    tLocals.Msg = dgvMusic_naming.Rows.Count
    If dgvMusic_naming.Rows.Count = 0 Then
      btnMusic_swap.Enabled = False
      btnMusic_save_one.Enabled = False
      btnMusic_Google_it.Enabled = False
    End If

Error_process:
    If tLocals.Error_count > 0 Then
      Stop ' Permanent.
    End If

Ender_full:
    If Not File_properties_determine_fn(tFile) Then Stop
    uOp.Subr = tLocals.Subr
    btnMusic_save_one.Focus()

    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
    Call Log_write(tLocals, 0)

Ender_partial:
    uOp.Subr = ""
    If tLocals.Success = udtBoolean_extended.True_ Then uOp.Success = True Else uOp.Success = False
  End Sub

  Private Sub btnMusic_Google_it_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMusic_Google_it.Click
    ' Written 2018.08.31. Revised 2021.03.04.
    If dgvMusic_naming.Rows.Count > 0 Then
      Dim tName As String = dgvMusic_naming.CurrentRow.Cells(0).Value
      Dim tSearch As String = ""
      tName = Replace(tName, ",", "%2C")
      tName = Replace(tName, " ", "+")
      tName = Replace(tName, ".mp3", "")
      tSearch = "www.google.co.nz/search?q=" & tName
      Process.Start(tSearch)
    End If
    btnMusic_save_one.Focus()
  End Sub

  Private Sub Gmusic_clear()
    uOp.Subr = "Gmusic clear"
    ' gMusic.File_count = 0
    gMusic.File_extension = ""
    gMusic.File_new_full_name = ""
    gMusic.File_new_name = ""
    gMusic.File_original_full_name = ""
    gMusic.File_original_name = ""
    gMusic.Message = ""
    ' gMusic.Path_start = Nothing
    gMusic.Track_album = ""
    gMusic.Track_artist = ""
    gMusic.Track_comment = ""
    gMusic.Track_genre = ""
    gMusic.Track_number = ""
    gMusic.Track_title = ""
    gMusic.Track_year = ""

    uOp.Subr = ""
  End Sub

  Private Sub Gmusic_conditioning(ByVal tBefore_dialogue As Boolean)
    ' Separated 2019.10.26. Revised 2021.04.07.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    Dim tFile As udtFile = Nothing
    tLocals.Subr = "Gmusic conditioning"

    If tBefore_dialogue Then
      tLocals.Action = "Populate gMusic"
      'If gMusic.Track_artist = "" And dgvMusic_details.Item(0, 0).Value <> "" Then gMusic.Track_artist = dgvMusic_details.Item(0, 0).Value
      'If gMusic.Track_album = "" And dgvMusic_details.Item(0, 1).Value <> "" Then gMusic.Track_album = dgvMusic_details.Item(0, 1).Value
      'If gMusic.Track_year = "" And dgvMusic_details.Item(0, 2).Value <> "" Then gMusic.Track_year = dgvMusic_details.Item(0, 2).Value
      'If gMusic.Track_number = "" And dgvMusic_details.Item(0, 3).Value <> "" Then gMusic.Track_number = dgvMusic_details.Item(0, 3).Value
      'If gMusic.Track_title = "" And dgvMusic_details.Item(0, 4).Value <> "" Then gMusic.Track_title = dgvMusic_details.Item(0, 4).Value
      'If gMusic.Track_comment = "" And dgvMusic_details.Item(0, 5).Value <> "" Then gMusic.Track_comment = Trim(dgvMusic_details.Item(0, 5).Value)
      'If gMusic.Track_genre = "" And dgvMusic_details.Item(0, 6).Value <> "" Then gMusic.Track_genre = dgvMusic_details.Item(0, 6).Value
      gMusic.Track_artist = Trim(dgvMusic_details.Item(0, 0).Value)
      gMusic.Track_album = Trim(dgvMusic_details.Item(0, 1).Value)
      gMusic.Track_year = Trim(dgvMusic_details.Item(0, 2).Value)
      gMusic.Track_number = Trim(dgvMusic_details.Item(0, 3).Value)
      gMusic.Track_title = Trim(dgvMusic_details.Item(0, 4).Value)
      gMusic.Track_comment = Trim(dgvMusic_details.Item(0, 5).Value)
      gMusic.Track_genre = Trim(dgvMusic_details.Item(0, 6).Value)
    End If

    If gMusic.Track_artist = "" Or gMusic.Track_title = "" Or tBefore_dialogue = False Then
      tLocals.Action = "Detect track artist, title"
      If InStr(gMusic.File_new_name, ",") > 0 Then
        gMusic.Track_artist = Trim(Microsoft.VisualBasic.Left(gMusic.File_new_name, InStr(gMusic.File_new_name, ",") - 1))
        gMusic.Track_title = Trim(Mid(gMusic.File_new_name, InStr(gMusic.File_new_name, ",") + 1))
      ElseIf InStr(gMusic.File_new_name, " - ") > 0 Then
        gMusic.Track_artist = Trim(Microsoft.VisualBasic.Left(gMusic.File_new_name, InStr(gMusic.File_new_name, " - ") - 1))
        gMusic.Track_title = Trim(Mid(gMusic.File_new_name, InStr(gMusic.File_new_name, " - ") + 1))
      ElseIf InStr(gMusic.File_new_name, "- ") > 0 Then
        gMusic.Track_artist = Trim(Microsoft.VisualBasic.Left(gMusic.File_new_name, InStr(gMusic.File_new_name, "- ") - 1))
        gMusic.Track_title = Trim(Mid(gMusic.File_new_name, InStr(gMusic.File_new_name, "- ") + 1))
      ElseIf InStr(gMusic.File_new_name, "-") > 0 Then
        gMusic.Track_artist = Trim(Microsoft.VisualBasic.Left(gMusic.File_new_name, InStr(gMusic.File_new_name, "-") - 1))
        gMusic.Track_title = Trim(Mid(gMusic.File_new_name, InStr(gMusic.File_new_name, "-") + 1))
      Else
        If gMusic.Track_title = "" Then gMusic.Track_title = gMusic.File_new_name
      End If
    End If
    gMusic.Track_artist = Trim(gMusic.Track_artist)

    tLocals.Action = "Condition track artist"
    If gMusic.Track_artist = "" Then gMusic.Track_artist = "Unknown artist"
    If InStr(LCase(gMusic.Track_artist), "various") > 0 Then
      gMusic.Track_artist = "Various artists"
    End If
    If InStr(LCase(gMusic.Track_artist), "unknown") > 0 Then
      gMusic.Track_artist = "Unknown artist"
    End If
    If VB.Left(gMusic.Track_artist, 4) = "The " Then
      gMusic.Track_artist = VB.Mid(gMusic.Track_artist, 5) & ", The"
    End If
    gMusic.Track_artist = Title_case_fn(Trim(gMusic.Track_artist))

    tLocals.Action = "Condiction track title"
    gMusic.Track_title = Replace(gMusic.Track_title, "?", "")
    gMusic.Track_title = Replace(gMusic.Track_title, ".mp3", "")
    gMusic.Track_title = Replace(gMusic.Track_title, ".wma", "")
    If InStr(gMusic.Track_title, "amp") > 0 Then
      Stop ' To do to develop.
    End If
    gMusic.Track_title = Trim(gMusic.Track_title)

    tLocals.Action = "Get track album"
    If InStr(gMusic.Track_title, "(") > 0 Then
      If VB.Right(gMusic.Track_title, 1) = ")" Then
        If InStr(gMusic.Track_title, "(Extended Version)") = 0 Then
          If gMusic.Track_album = "" Then
            gMusic.Track_album = Mid(gMusic.Track_title, InStr(gMusic.Track_title, "(") + 1, 999)
            gMusic.Track_album = VB.Left(gMusic.Track_album, InStr(gMusic.Track_album, ")") - 1)
            gMusic.Track_title = Trim(VB.Left(gMusic.Track_title, InStr(gMusic.Track_title, "(") - 1))
          End If
        End If
      End If
    End If
    gMusic.Track_album = Trim(gMusic.Track_album)

    tLocals.Action = "Condition track album"
    If gMusic.Track_album = "The Absolute Best Beer Drinkin" Or _
       gMusic.Track_album = "The Best Beer Drinking Songs I" Or _
       gMusic.Track_album = "101 Driving Songs [Disc 5]" Then
      gMusic.Track_album = ""
    End If
    If gMusic.Track_album <> "" Then gMusic.Track_album = Title_case_fn(Trim(gMusic.Track_album))

    tLocals.Action = "Separate artist and album from title"
    If gMusic.Track_artist <> "" Then
      If InStr(gMusic.Track_title, gMusic.Track_artist) > 0 Then
        gMusic.Track_title = Mid(gMusic.Track_title, Len(gMusic.Track_artist) + 1)
        gMusic.Track_title = Trim(gMusic.Track_title)
        If gMusic.Track_album <> "" Then
          If InStr(gMusic.Track_title, "(" & gMusic.Track_album & ")") > 0 Then
            gMusic.Track_title = Mid(gMusic.Track_title, Len(gMusic.Track_album) + 3)
          End If
          If VB.Left$(gMusic.Track_title, 1) = "," Then
            gMusic.Track_title = Mid(gMusic.Track_title, 2)
          End If
          gMusic.Track_title = Trim(gMusic.Track_title)
        End If
      End If
    End If

    tLocals.Action = "Condition track comment"
    '  tLocals.Msg  = Len(gMusic.Track_comment)
    '  tLocals.Msg  = Asc(gMusic.Track_comment)
    gMusic.Track_comment = Trim(gMusic.Track_comment)
    If gMusic.Track_comment = " " Then gMusic.Track_comment = ""
    If gMusic.Track_comment = vbCr Then gMusic.Track_comment = ""
    If gMusic.Track_comment = vbCrLf Then gMusic.Track_comment = ""
    If gMusic.Track_comment = StrDup(28, Chr(0)) Then gMusic.Track_comment = ""
    gMusic.Track_comment = Trim(gMusic.Track_comment)

    tLocals.Action = "Condition track genre"
    If gMusic.Track_genre = "None" Then gMusic.Track_genre = ""
    gMusic.Track_genre = Trim(gMusic.Track_genre)

    tLocals.Action = "Set file path"
    tFile.File_path = gMusic.Path_start & "\Music"
    If gMusic.Track_artist = "" Then
      Stop
      gMusic.Track_artist = "Various artists"
    End If
    If gMusic.Track_artist <> "" Then tFile.File_path = tFile.File_path & "\" & gMusic.Track_artist
    If InStr(gMusic.File_new_name, "soundtrack") > 0 Then tFile.File_path = tFile.File_path & "\" & "Soundtrack"

    tLocals.Action = "Condition file extension"
    gMusic.File_extension = Mid(gMusic.File_original_name, InStrRev(gMusic.File_original_name, ".") + 1)

    tLocals.Action = "Condition file new name"
    gMusic.File_new_name = gMusic.Track_artist & ", "
    If gMusic.Track_album <> "" Then gMusic.File_new_name = gMusic.File_new_name & "(" & gMusic.Track_album & ") "
    gMusic.File_new_name = gMusic.File_new_name & gMusic.Track_title

    uOp.Success = True
    uOp.Subr = ""
  End Sub

  Sub dgvMusic_naming_clear()
    ' Separated 2020.03.01.
    uOp.Subr = "dgvMusic_naming clear"
    Dim tCalled_from As String = uOp.Called_from
    uOp.Called_from = uOp.Subr
    If dgvMusic_naming.Rows.Count > 0 Then
      For Each tRow As DataGridViewRow In dgvMusic_naming.Rows
        '   tRow.Cells(dgvMusic_naming_Original_name.Name).Value = ""
        '   tRow.Cells(dgvMusic_naming_New_name.Name).Value = ""
        dgvMusic_naming.Rows.RemoveAt(0)
      Next
      Call dgvMusic_naming_clear()
    End If
    uOp.Called_from = tCalled_from
    uOp.Subr = ""
  End Sub

  Sub dgvMusic_details_clear_contents()
    ' Separated 2019.10.14.
    If dgvMusic_details.Rows.Count < 7 Then
      Do
        dgvMusic_details.Rows.Add()
      Loop Until dgvMusic_details.Rows.Count = 7
    End If
    For Each tRow As DataGridViewRow In dgvMusic_details.Rows
      tRow.Cells(dgvMusic_details_gMusic.Name).Value = ""
      tRow.Cells(dgvMusic_details_Mp3_tag.Name).Value = ""
    Next
  End Sub

  Sub dgvMusic_details_fill()
    ' Revised 2021.02.15.
    Dim tLocals As udtLocals = Nothing : Stop ' To do: retest using tLocals.
    tLocals.Subr = "dgvMusic_details fill"

    tLocals.Action = "Add meta-data to the data grid view"
    If dgvMusic_details.Rows.Count < 7 Then
      Do
        dgvMusic_details.Rows.Add()
      Loop Until dgvMusic_details.Rows.Count = 7
    End If
    dgvMusic_details.Item(0, 0).Value = gMusic.Track_artist
    dgvMusic_details.Item(0, 1).Value = gMusic.Track_album
    dgvMusic_details.Item(0, 2).Value = gMusic.Track_year
    dgvMusic_details.Item(0, 3).Value = gMusic.Track_number
    dgvMusic_details.Item(0, 4).Value = gMusic.Track_title
    dgvMusic_details.Item(0, 5).Value = gMusic.Track_comment
    dgvMusic_details.Item(0, 6).Value = gMusic.Track_genre

    Me.Refresh()
    tLocals.Success = udtBoolean_extended.True_

Ender_full:
    If tLocals.Status = udtuStandard_texts.Cancelled Or tLocals.Status = udtuStandard_texts.Failed Then
      tLocals.Status = udtuStandard_texts.Failed
      tLocals.Success = udtBoolean_extended.False_
    Else
      tLocals.Status = udtuStandard_texts.Completion
    End If
    Call Log_write(tLocals, 0)
    uOp.Subr = ""
  End Sub

#End Region ' End tab Music.

#End Region ' End region, "Tabs application specific."

#End Region ' End region, "tabControl_main."

End Class
